//
//  IAPV4Test.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by paikjongman on 2017. 8. 31..
//  Copyright © 2017년 GCP. All rights reserved.
//

#ifndef IAPV4Test_hpp
#define IAPV4Test_hpp

#include "BaseView.hpp"
#include "Postbox.hpp"

class IAPV4Test : public BaseView
{
public:
    CREATE_FUNC(IAPV4Test);
    virtual bool init()override;
    virtual void onButtonEvent(int buttonTag)override;
    
    enum : int
    {
        BUTTON_MARKET_CONNECT
        ,BUTTON_GET_MARKET_PRODUCT_INFO
        ,EDITBOX_MARKET_PID_LIST
        ,BUTTON_GET_PRODUCT_INFO
        ,BUTTON_PURCHASE
        ,BUTTON_RESTORE
        ,BUTTON_GET_SUBSCRIPTION_PRODUCT_INFO
        ,BUTTON_PURCHASE_SUBSCRIPTION
        ,BUTTON_RESTORE_SUBSCRIPTION
        ,EDITBOX_ADDITIONAL_INFO
        ,BUTTON_MARKET_SELECT
        ,BUTTON_BALANCE_INFO
        ,BUTTON_BALANCE_CHARGE
        ,BUTTON_CHECK_PROMOTE_PURCHASE
        ,BUTTON_TRANSACTION_FINISH
        ,BUTTON_TRANSACTIONMULTI_FINISH
        ,BUTTON_GET_SELECTED_MARKET
        ,BUTTON_GET_ACCOUNT_UUID
        ,BUTTON_SHOW_POSTBOX
#if (CC_TARGET_PLATFORM == CC_PLATFORM_IOS)
        ,BUTTON_FINISH_ALL_TRANSACTIONS
#endif
    };
    
#if (CC_TARGET_PLATFORM == CC_PLATFORM_IOS)
    const static int iOS_RECEIPT_LENGTH_LIMIT = 200;
#endif
    
private:
    void logHead(const char* funcName);
    void logHead(const char* funcName,hive::ResultAPI const & result);
    
    std::vector<hive::IAPV4Product> productCache;
    std::vector<std::string> pidList;
    
    void onTransactionFinish(hive::ResultAPI const & result,std::string marketPid);
    void onTransactionMultiFinish(std::vector<hive::ResultAPI> const & resultList,std::vector<std::string> const & marketPidList);
    virtual void onEnter()override;
    void receiptVerify(hive::IAPV4Receipt receipt,Postbox::ItemType itemType,std::function<void()> callback);
    void receiptVerify(std::vector<hive::IAPV4Receipt> vec,int startIndex,Postbox::ItemType itemType,std::function<void()> callback);
    void showResult(hive::ResultAPI const & api);
    int finishAllTransactions();
};

#endif /* IAPV4Test_hpp */
