//
//  SocialHiveTest.cpp
//  hivesdk
//
//  Created by paikjongman on 2017. 2. 28..
//
//

#include "SocialV4Test.hpp"

using namespace hive;

const std::vector<const char*> viewTypeList = {"FullScreen", "Frame"};

bool SocialV4Test::init()
{
    if(!BaseView::init())
        return false;
    
    setUseShowLogButton(true);
    Logger::setLoggerListener([=](std::string tag, std::string level, std::string logMessage){
        addLogMessage(logMessage);
    });

    addCombobox("ViewType : ", std::move(viewTypeList), 0, COMBOBOX_VIEW_TYPE);

    addButton("SocialV4.showCommunity()", BUTTON_SHOW_COMMUNITY);

    addButton("SocialV4.sharePhoto()", BUTTON_SHARE_PHOTO);
    
    setUseBackButton(true, "- SocialV4Test -");
    
    return true;
}

void SocialV4Test::onButtonEvent(int buttonTag)
{
    switch (buttonTag) {
        case BUTTON_SHOW_COMMUNITY: {
            Logger::log("\n\n=== SocialV4 커뮤니티 호출 ===\n");
            Logger::log("SocialV4::showCommunity(ProviderType, ViewType) Called\n");

            int index = getSelectedComboboxIndex(COMBOBOX_VIEW_TYPE);
            auto viewType = static_cast<SocialV4::ViewType>(index);

            SocialV4::showCommunity(SocialV4::ProviderType::HIVE, viewType,
                                    [=](ResultAPI const &result) {
                                        Logger::log("=== SocialV4::showCommunity Called ===");
                                        Logger::log("result code:%d message:%s\n", result.code,
                                                    result.message.c_str());
                                    });
            break;
        }

        case BUTTON_SHARE_PHOTO:
            Logger::log("\n\n=== SocialV4 사진첩 공유 호출 ===\n");
            Logger::log("SocialV4::sharePhoto(ProviderType) Called\n");
            SocialV4::sharePhoto(SocialV4::ProviderType::FACEBOOK, [=](ResultAPI const & result){
                Logger::log("=== SocialV4::sharePhoto Called ===");
                Logger::log("result code:%d message:%s\n", result.code, result.message.c_str());
            });
        default:
            break;
    }
}