//
//  TransactionCleaner.m
//
//
//  Created by sjyong on 2021/02/17.
//

#import "IAPV4Test.hpp"
#import "Configuration.hpp"
#import <Foundation/Foundation.h>
#import <StoreKit/StoreKit.h>
#import <AdSupport/AdSupport.h>
#import <UIKit/UIKit.h>

int IAPV4Test::finishAllTransactions()
{
#if (CC_TARGET_PLATFORM == CC_PLATFORM_IOS)
    int finishedTransactionCount = 0;
    NSArray<SKPaymentTransaction *> *transactions    = [[SKPaymentQueue defaultQueue] transactions];

    for (SKPaymentTransaction * transaction in transactions) {

        if(transaction.transactionState == SKPaymentTransactionStatePurchased || transaction.transactionState == SKPaymentTransactionStateRestored) {
            [[SKPaymentQueue defaultQueue] finishTransaction:transaction];
            finishedTransactionCount++;
        }
    }

    return finishedTransactionCount;
#else
    // Not Supported
    return -1;
#endif
}


const char* Configuration::getIDFV()
{
#if (CC_TARGET_PLATFORM == CC_PLATFORM_IOS)
    return [[[[UIDevice currentDevice] identifierForVendor] UUIDString] UTF8String];
#else
    return ""
#endif
}
const char* Configuration::getIDFA(){
    
#if (CC_TARGET_PLATFORM == CC_PLATFORM_IOS)
    return [[[[ASIdentifierManager sharedManager] advertisingIdentifier] UUIDString] UTF8String];
#else
    return ""
#endif
}

void Configuration::copyIDFV() {
#if (CC_TARGET_PLATFORM == CC_PLATFORM_IOS)
    UIPasteboard *pasteboard = [UIPasteboard generalPasteboard];
    pasteboard.string = [[[UIDevice currentDevice] identifierForVendor] UUIDString];
#endif
}

void Configuration::copyIDFA() {
#if (CC_TARGET_PLATFORM == CC_PLATFORM_IOS)
    UIPasteboard *pasteboard = [UIPasteboard generalPasteboard];
    pasteboard.string = [[[ASIdentifierManager sharedManager] advertisingIdentifier] UUIDString];
#endif
}
