//
//  UIInputList.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by paikjongman on 2017. 6. 16..
//  Copyright © 2017년 GCP. All rights reserved.
//

#ifndef UIInputList_hpp
#define UIInputList_hpp

#include "cocos2d.h"
#include "ui/CocosGUI.h"
#include "BaseView.hpp"

class InputList : public BaseView
{
public:
    typedef std::function<void(InputList* select,const std::vector<std::string>& inputs)> InputListCallback;
    static InputList *create(const char* title,InputListCallback callback);
    virtual bool init(const char *title,InputListCallback callback);
    
    std::string getTitle()const{
        return viewTitle;
    };
    
    std::vector<std::string> getInputLists();
protected:
    virtual void onButtonEvent(int buttonTag)override;
    
private:
    
    int OK_BUTTON_TAG;
    int CANCEL_BUTTON_TAG;
    int ADD_EDITBOX_TAG;
    
    std::vector<std::string> data;
    InputListCallback okCallback;
    std::string viewTitle;
};

#endif /* UIInputList_hpp */
