//
//  UIMulltiselect.hpp
//  HIVE_SDK_v4_Cocos_Sample
//
//  Created by paikjongman on 2017. 3. 9..
//  Copyright © 2017년 ryuvsken. All rights reserved.
//

#ifndef UIMulltiselect_hpp
#define UIMulltiselect_hpp

#include "cocos2d.h"
#include "ui/CocosGUI.h"
#include "BaseView.hpp"

class MultiSelect : public BaseView
{
public:
    typedef std::function<void(MultiSelect* select,const std::vector<int>& selectedIndexes)> MultiSelectCallback;
    static MultiSelect *create(const char* title,const std::vector<std::string>& list,MultiSelectCallback callback);
    virtual bool init(const char *title,const std::vector<std::string>& list,MultiSelectCallback callback);
    
    std::string getTitle()const{
        return viewTitle;
    };
    void selectFromIndex(int i);
    void unselectFromIndex(int i);
    bool isSelectIndex(int i);
    void clearSelect();
    
    std::vector<int> getSelectIndexes();
    
protected:
    virtual void onButtonEvent(int buttonTag)override;
    
private:
    
    int OK_BUTTON_TAG;
    int CANCEL_BUTTON_TAG;
    
    std::vector<std::string> data;
    std::vector<int> selectedIndex;
    MultiSelectCallback okCallback;
    std::string viewTitle;
};
#endif /* UIMulltiselect_hpp */
