//
//  ActiveUserParamsScene.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by sjyong on 2021/09/29.
//

#ifndef ActiveUserParamScene_hpp
#define ActiveUserParamScene_hpp

#include <stdio.h>
#include <functional>
#include "C2SModuleAPIList.hpp"
#include "BaseView.hpp"
#include "C2SActiveUser.h"

using namespace std; 

class ActiveUserParamScene: public BaseView
{
public:
    enum ButtonParam: int {
        BUTTON_OK = 0,
        COMBOBOX_SERVER_STATE,
        TOGGLE_BUTTON_SHOW_NOTICE,
        EDITBOX_VID,
        EDITBOX_UID,
        EDITBOX_SERVER_ID,
        COMBOBOX_GAME_LANGUAGE,
        EDITBOX_MIN_TIMEOUT_SECONDS,
        EDITBOX_BUF_SIZE,
        TOGGLE_BUTTON_IS_LOGGED,
        EDITBOX_URL,
        TOGGLE_BUTTON_IS_ON,
        EDITBOX_FUNNELS_TRACK,
        EDITBOX_OPTION_TAG,
        EDITBOX_REQUESTS,
        EDITBOX_SEND_LIMIT,
        EDITBOX_QUEUE_LIMIT,
        EDITBOX_SEND_CYCLE_SECOND,
        EDITBOX_LOG_DATA,
        COMBOBOX_MODULE_ORIENTATION,
        TOGGLE_BUTTON_IS_USE_HERCULES,
        EDITBOX_CHANNEL,
    };

    CREATE_FUNC(ActiveUserParamScene);

    virtual bool init() override;
    virtual void update(float dt) override;
    virtual void onButtonEvent(int buttonTag) override;
    
    void showParameters(int tag);

private:
    vector<const char*> orientationList;

    C2SModuleAPIList::ActiveUserAPI api;
    function<void()> setCompletionHandler;
    
    void showStartExParam(function<void()> completionHandler);
    void showStartWithoutNoticeParam(function<void()> completionHandler);
    void showSetVidParam(function<void()> completionHandler);
    void showSetServerIdParam(bool isUpdate, function<void()> completionHandler);
    void showSetGameLanguageParam(bool isUpdate, function<void()> completionHandler);
    void showSetMinTimeoutSecondsParam(function<void()> completionHandler);
    void showGetVersionParam(function<void()> completionHandler);
    void showSetLoggedParam(function<void()> completionHandler);
    void showUserAgreeSetViewParam(function<void()> completionHandler);
    void showUserAgreeShowTermsUIparam(function<void()> completionHandler);
    void showUserAgreeShowTermsUIExParam(function<void()> completionHandler);
    void showSetPermissionViewStateParam(function<void()> completionHandler);
    void showSendFunnelsLogsParam(function<void()> completionHandler);
    void showRequestUserPermissionsParam(function<void()> completionHandler);
    void showSetAnalyticsLogSettingsParam(function<void()> completionHandler);
    void showSendAnalyticsLogParam(function<void()> completionHandler);
    void showSetModuleOrientationParam(function<void()> completionHandler);
    void showSetEmergencyModeUid(function<void()> completionHandler);
    void showSetUseHerculesParam(function<void()> completionHandler);
    void showSetChannelParam(function<void()> completionHandler);
    
    SERVER_STATE stringToServerState(std::string value);
    MODULE_ORIENTATION stringToOrientation(std::string value);
};



#endif /* ActiveUserParamScene_hpp */
