//
//  C2SModuleAPIList.hpp
//  HIVE_SDK_Cocos_Sample
//
//  개별모듈 API 리스트 : https://developers.withhive.com/c2s/api/
//  Created by sjyong on 2021/09/30.
//

#ifndef C2SModuleAPIList_hpp
#define C2SModuleAPIList_hpp

#include <stdio.h>


class C2SModuleAPIList
{
public:
    enum ActiveUserAPI: int {
        ACTIVEUSER_START = 0,
        ACTIVEUSER_START_EX,
        ACTIVEUSER_START_WITHOUT_NOTICE,
        ACTIVEUSER_SET_VID,
        ACTIVEUSER_SET_SERVER_ID,
        ACTIVEUSER_SET_GAME_LANGUAGE,
        ACTIVEUSER_SET_MIN_TIMEOUT_SECONDS,
        ACTIVEUSER_REGISTER_TOKEN,
        ACTIVEUSER_GET_VERSION,
        ACTIVEUSER_SET_LOGGED,
        ACTIVEUSER_GET_DID,
        ACTIVEUSER_USER_AGREE_SHOW_TERMS_UI,
        ACTIVEUSER_USER_AGREE_SHOW_TERMS_UI_EX,
        ACTIVEUSER_SET_ENABLE_REQUEST_STORAGE_PERMISSION,
        ACTIVEUSER_UPDATE_NOTICE_SHOW_POPUP,
        ACTIVEUSER_UPDATE_NOTICE_GET_POPUP_INFO,
        ACTIVEUSER_GET_PERMISSION_VIEW_DATA,
        ACTIVEUSER_SET_PERMISSION_VIEW_STATE,
        ACTIVEUSER_SEND_FUNNELS_LOGS,
        ACTIVEUSER_REQUEST_USER_PERMISSIONS,
        ACTIVEUSER_UPDATE_SERVER_ID,
        ACTIVEUSER_UPDATE_GAME_LANGUAGE,
        ACTIVEUSER_SET_ANALYTICS_LOG_SETTINGS,
        ACTIVEUSER_SEND_ANALYTICS_LOG,
        ACTIVEUSER_SET_MODULE_ORIENTATION,
        ACTIVEUSER_SET_EMERGENCY_MODE_UID,
        ACTIVEUSER_SET_USE_HERCULES,
        ACTIVEUSER_GET_HIVE_COUNTRY,
        ACTIVEUSER_GET_CHANNEL,
        ACTIVEUSER_SET_CHANNEL,
    };

    enum PeppermintAPI: int {
        HUB_ASYNC_REQUEST_DEVICE_REGISTERED = 0,
        HUB_ASYNC_REQUEST_FRIENDS_GAME,
        HUB_ASYNC_REQUEST_FRIENDS_OTHER,
        HUB_ASYNC_REQUEST_FRIENDS_RECEIVE_LIST,
        HUB_ASYNC_REQUEST_FRIENDS_REJECT_REQUEST,
        HUB_ASYNC_REQUEST_FRIENDS_REQUEST,
        HUB_ASYNC_REQUEST_FRIENDS,
        HUB_ASYNC_REQUEST_GUEST_AUTH,
        HUB_ASYNC_REQUEST_GUEST_CREATE,
        HUB_ASYNC_REQUEST_GUEST_STATUS_SAVE_DATA,
        HUB_ASYNC_REQUEST_MESSAGE_WRITE,
        HUB_ASYNC_REQUEST_MESSAGE_GET_INVITATIONS,
        HUB_ASYNC_REQUEST_MESSAGE_NOTI_COUNT,
        HUB_ASYNC_REQUEST_SAVE_DATA_DELETE,
        HUB_ASYNC_REQUEST_SAVE_DATA_DOWNLOAD,
        HUB_ASYNC_REQUEST_SAVE_DATA_UPLOAD,
        HUB_ASYNC_REQUEST_UPLOAD_IMAGE_WITH_JSON,
        HUB_ASYNC_REQUEST_USER_HUB_UID,
        HUB_ASYNC_REQUEST_USER_ME_NOTIFICATIONS,
        HUB_ASYNC_REQUEST_USER_ME,
        HUB_ASYNC_REQUEST_USER_MODIFY_INFO,
        HUB_ASYNC_REQUEST_USERS,
        HUB_ASYNC_REQUEST_WALL_WRITE,
        HUB_AUTH,
        HUB_GET_IS_PGS,
        HUB_GUEST_ACQUIRE_UID,
        HUB_GUEST_BIND,
        HUB_INITIALIZE,
        HUB_INITIALIZE_EX,
        HUB_LOGOUT,
        HUB_LOGIN_PROC,
        HUB_SET_OPTION,
        HUB_SHOW_DIALOG,
        HUB_SHOW_DIALOG_FOR_CHAT_BOT,
        HUB_SOCIAL_REQUEST_REQUEST_USER_PROFILE,
        HUB_SOCIAL_REQUEST_INVITE_DIALOG,
        HUB_SOCIAL_REQUEST_RECEIVED_INVITE,
        HUB_SOCIAL_REQUEST_REQUEST_FRIENDS,
        HUB_SOCIAL_REQUEST_USER_PROFILE_IMAGE,
        HUB_SOCIAL_REQUEST_SHARE_APP_ACTIVITY,
        HUB_SOCIAL_REQUEST_IS_AUTHORIZED,
        HUB_SOCIAL_REQUEST_LOGOUT,
        HUB_SOCIAL_REQUEST_CONNECT,
        HUB_SOCIAL_REQUEST_SET_PERMISSION,
        HUB_UNINITIALIZE,
        HUB_SET_AUTH_DIALOG_CLEAR,
        HUB_SET_PGS_AUTO_LOGIN,
        HUB_SET_PGS_AUTO_LOGIN_WITH_CB,
        HUB_USER_DELETE_CB,
        HUB_IS_PGS_AVAILABLE,
        HUB_AUTH_WITH_PARAM,
    };

    enum HivePromotionAPI: int {
        PROMOTION_INITIALIZE = 0,
        PROMOTION_SHOW,
        PROMOTION_SHOW_CUSTOM,
        PROMOTION_GET_OFFERWALL_STATE,
        PROMOTION_SHOW_OFFERWALL,
        PROMOTION_SHOW_REVIEW,
        PROMOTION_SHOW_NATIVE_REVIEW,
        PROMOTION_SHOW_EXIT,
        PROMOTION_GET_VIEW_INFO,
        PROMOTION_GET_BADGE_INFO,
        PROMOTION_GET_BANNER_INFO,
        PROMOTION_GET_APP_INVITATION_DATA,
        PROMOTION_SHOW_UA_SHARE,
        PROMOTION_SET_ADDITIONAL_INFO,
        PROMOTION_UPDATE_PROMOTION_DATA,
        PROMOTION_HIVE_PROMOTION_GET_VERSION,
    };

    enum InAppV4API: int {
        INAPPV4_MARKET_CONNECT = 0,
        INAPPV4_GET_MARKET_PRODUCT_INFO,
        INAPPV4_GET_PRODUCT_INFO,
        INAPPV4_GET_SUBSCRIPTION_PRODUCT_INFO,
        INAPPV4_PURCHSE,
        INAPPV4_PURCHASE_SUBSCRIPTION,
        INAPPV4_RESTORE,
        INAPPV4_RESTORE_SUBSCRIPTION,
        INAPPV4_TRANSACTION_FINISH,
        INAPPV4_CHECK_PROMOTE_PURCHASE,
        INAPPV4_SET_UID,
        INAPPV4_GET_SELECTED_MARKET,
        INAPPV4_GET_ACCOUNT_UUID,
        INAPPV4_SHOW_MARKET_SELECTION,
        INAPPV4_GET_BALANCE_INFO,
        INAPPV4_SHOW_CHARGE,
        INAPPV4_SET_LIFE_CYCLE_CB,
        INAPPV4_GET_VERSION,
    };

    enum OfferwallAPI: int {
        OFFERWALL_INITIALIZE = 0,
        OFFERWALL_INITIALIZE_EX,
        OFFERWALL_SET_LOG,
        OFFERWALL_SHOW_EX,
        OFFERWALL_REWARD_FINISH,
        OFFERWALL_GET_STATE,
        OFFERWALL_GET_VERSION,
    };

    enum PushAPI: int {
        // Common
        PUSH_START_EX = 0,
        PUSH_GET_AGREE_NOTICE,
        PUSH_GET_AGREE_NIGHT,
        PUSH_REGISTER_LOCAL_PUSH,
        PUSH_REGISTER_LOCAL_PUSH_EX,
        PUSH_UNREGISTER_LOCAL_PUSH,
        PUSH_SET_AGREE,
        PUSH_SET_UID,

        // iOS
        PUSH_GET_VERSION_EX,
        PUSH_SET_FOREGROUND,
        PUSH_GET_FOREGROUND_REMOTE,
        PUSH_GET_FOREGROUND_LOCAL,
        PUSH_REQUEST_PERMISSION,

        // Android
        PUSH_SET_PUSH,
        PUSH_SET_SOUND,
        PUSH_SET_VIB,
        PUSH_GET_PUSH,
        PUSH_GET_SOUND,
        PUSH_GET_VIB,
        PUSH_REGISTER_LOCAL_PUSH_DATA,
        PUSH_REGISTER_LOCAL_PUSH_BIG,
        PUSH_UNREGISTER_ALL_LOCAL_PUSH,
        PUSH_REGISTER_CALLBACK_HANDLER,
        PUSH_UNREGISTER_CALLBACK_HANDLER,
        PUSH_SET_OPERATION_LOCAL_PUSH_ON_RUNNING,
        PUSH_SET_OPERATION_GCM_PUSH_ON_RUNNING,
        PUSH_GET_REGISTRATION_ID,
    };

    enum MercuryAPI: int {
        MERCURY_SHOW_EX = 0,
        MERCURY_SHOW_EX_CUSTOM_VIEW_ID,
        MERCURY_GET_CUSTOM_VIEW_INFO,
        MERCURY_GET_CUSTOM_VIEW_INFO_CUSTOM_VIEW_ID,
        MERCURY_SHOW_REVIEW_POPUP,
        MERCURY_SHOW_NATIVE_REVIEW_POPUP,
        MERCURY_SHOW_MORE_GAMES_POPUP,
        MERCURY_SET_UID,
        MERCURY_SET_IS_USING_STAGING,
        MERCURY_SET_LOG,
        MERCURY_GET_VERSION,
        MERCURY_INIT_IMAGE_LOADER,
        MERCURY_GET_BADGE,
        MERCURY_GET_BADGE_TYPE,
        MERCURY_REQUEST_UA_INFO,
        MERCURY_REQUEST_UA_LINK_SHARE,
        MERCURY_GET_BANNER_INFO,
        MERCURY_SET_BANNER_ON_GAME_WINDOW
    };

    // MARK: 인앱 구매 아이템 확인용 우편함 (API는 아님)
    enum PostBox: int {
        // INAPPV4 마지막 API + 1
        POSTBOX_OPEN = INAPPV4_GET_VERSION + 1,
    };
};

#endif /* C2SModuleAPIList_hpp */
