//
//  C2SModuleListScene.cpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by sjyong on 2021/09/27.
//

#include "C2SModuleListScene.hpp"
#include "ActiveUserScene.hpp"
#include "PeppermintScene.hpp"
#include "HivePromotionScene.hpp"
#include "InAppV4Scene.hpp"
#include "OfferwallScene.hpp"
#include "PushScene.hpp"
#include "MercuryScene.hpp"

#include <map>
#include <iostream>

using namespace::std;

#define MAKE_VIEW_CREATE(x) [](BaseView* view){ view->pushView(x::create());  }

std::function<void(BaseView* view)> C2SModuleListSceneChange[] = {
    MAKE_VIEW_CREATE(ActiveUserScene),
    MAKE_VIEW_CREATE(PeppermintScene),
    MAKE_VIEW_CREATE(MercuryScene),
    MAKE_VIEW_CREATE(OfferwallScene),
    MAKE_VIEW_CREATE(PushScene),
    MAKE_VIEW_CREATE(InAppV4Scene),
    MAKE_VIEW_CREATE(HivePromotionScene)
};
bool C2SModuleListScene::init()
{
    if(!BaseView::init())
        return false;

    const char* buttons[]={
        "ActiveUser",
        "Peppermint",
        "Mercury",
        "Offerwall (Android only)",
        "Push",
        "InAppV4",
        "HivePromotion"
    };


    for (int i=0; i<sizeof(buttons)/sizeof(*buttons); i++) {
        addButton(buttons[i], i);
    }

    scheduleUpdate();

    return true;
}
void C2SModuleListScene::update(float dt)
{
    BaseView::update(dt);

    static bool firstRun = true;
    if(firstRun) {
        firstRun = false;
    }
}

void C2SModuleListScene::onButtonEvent(int buttonTag)
{
    C2SModuleListSceneChange[buttonTag](this);
}
