//
//  OfferwallParamScene.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by sjyong on 2021/10/19.
//

#ifndef OfferwallParamScene_hpp
#define OfferwallParamScene_hpp

#include <stdio.h>
#include <functional>

#include "C2SModuleAPIList.hpp"
#include "BaseView.hpp"

using namespace std;

class OfferwallParamScene: public BaseView
{
public:
    enum ButtonParam: int {
        BUTTON_OK = 0,
        EDITBOX_UID,
        TOGGLE_BUTTON_IS_USING_STAGING,
        TOGGLE_BUTTON_IS_LOG,
        EDITBOX_ADDITIONAL_INFO,
    };

    CREATE_FUNC(OfferwallParamScene);

    virtual bool init() override;
    virtual void update(float dt) override;
    virtual void onButtonEvent(int buttonTag) override;

    void showParameters(int tag);
private:
    C2SModuleAPIList::OfferwallAPI api;

    function<void()> setCompletionHandler;

    void showInitializeParam(function<void()> completionHandler);
    void showInitializeExParam(function<void()> completionHandler);
    void showSetLogParam(function<void()> completionHandler);
    void showShowExParam(function<void()> completionHandler);
};

#endif /* OfferwallParamScene_hpp */
