//
//  PeppermintScene.cpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by sjyong on 2021/09/27.
//

#include "C2SModuleAPIList.hpp"
#include "PeppermintScene.hpp"
#include "PeppermintParamScene.hpp"
#include "ParameterDataManager.hpp"
#include "ui/CocosGUI.h"
#include "Postbox.hpp"

using namespace cocos2d;
using namespace cocos2d::ui;
using namespace hive;

#include <map>
#include <sstream>

bool PeppermintScene::init()
{
    if (!BaseView::init())
        return false;

    setUseShowLogButton(true);

    setUseBackButton(true, "- Peppermint - ");


    // common API
    //    addButton("Initialize", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_INITIALIZE);    // removed, C2S.20.0
    addButton("InitializeEx", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_INITIALIZE_EX);
    //    addButton("UnInitialize", C2SModuleAPIList::HUB_UNINITIALIZE);        // removed, C2S.20.0
    addButton("Auth", C2SModuleAPIList::HUB_AUTH);
    addButton("AuthWithParam", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_AUTH_WITH_PARAM);
    addButton("GuestAcquireUid", C2SModuleAPIList::HUB_GUEST_ACQUIRE_UID);
    addButton("GuestBind", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_GUEST_BIND);
    addButton("Logout", C2SModuleAPIList::HUB_LOGOUT);
//    addButton("SetOption", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_SET_OPTION); // removed, C2S.20.0
    addButton("ShowDialog", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_SHOW_DIALOG);
    addButton("ShowDialogForChatbot", C2SModuleAPIList::HUB_SHOW_DIALOG_FOR_CHAT_BOT);
    addButton("setAuthDialogClear", C2SModuleAPIList::HUB_SET_AUTH_DIALOG_CLEAR);
//    addButton("setPGSAutoLogin", C2SModuleAPIList::HUB_SET_PGS_AUTO_LOGIN);   // 미사용 API로 분류 (QA팀 논의)
    addButton("setPGSAutoLoginWithCB", C2SModuleAPIList::HUB_SET_PGS_AUTO_LOGIN_WITH_CB);
    addButton("UserDelete", C2SModuleAPIList::HUB_USER_DELETE_CB);
//    addButton("isPGSAvailable", C2SModuleAPIList::HUB_IS_PGS_AVAILABLE);

    // AsyncRequest API
    addLabel("- Peppermint AsyncRequest -", LinearGravity::CENTER_HORIZONTAL, DEFAULT_FONT_SIZE, Node::INVALID_TAG);
    addButton("AsyncRequest (device/registered)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_ASYNC_REQUEST_DEVICE_REGISTERED);
    addButton("AsyncRequest (friends/game)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_ASYNC_REQUEST_FRIENDS_GAME);
    addButton("AsyncRequest (friends/other)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_ASYNC_REQUEST_FRIENDS_OTHER);
    addButton("AsyncRequest (friends/receive_list)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_ASYNC_REQUEST_FRIENDS_RECEIVE_LIST);
    addButton("AsyncRequest (friends/reject_request)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_ASYNC_REQUEST_FRIENDS_REJECT_REQUEST);
    addButton("AsyncRequest (friends/request)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_ASYNC_REQUEST_FRIENDS_REQUEST);
    addButton("AsyncRequest (friends)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_ASYNC_REQUEST_FRIENDS);
    addButton("AsyncRequest (guest/auth)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_ASYNC_REQUEST_GUEST_AUTH);
    addButton("AsyncRequest (guest/create)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_ASYNC_REQUEST_GUEST_CREATE);
//    addButton("AsyncRequest (guest/status_savedata)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_ASYNC_REQUEST_GUEST_STATUS_SAVE_DATA);    // 미사용 API로 분류 (QA팀 논의)
    addButton("AsyncRequest (message/write)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_ASYNC_REQUEST_MESSAGE_WRITE);
    addButton("AsyncRequest (message/get_invitations)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_ASYNC_REQUEST_MESSAGE_GET_INVITATIONS);
    addButton("AsyncRequest (message/noticount)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_ASYNC_REQUEST_MESSAGE_NOTI_COUNT);
    addButton("AsyncRequest (upload/image_with_json)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_ASYNC_REQUEST_UPLOAD_IMAGE_WITH_JSON);
    addButton("AsyncRequest (user/{hub_uid})", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_ASYNC_REQUEST_USER_HUB_UID);
    addButton("AsyncRequest (user/me/notifications)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_ASYNC_REQUEST_USER_ME_NOTIFICATIONS);
    addButton("AsyncRequest (user/me)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_ASYNC_REQUEST_USER_ME);
    addButton("AsyncRequest (user/modify_info)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_ASYNC_REQUEST_USER_MODIFY_INFO);
    addButton("AsyncRequest (users)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_ASYNC_REQUEST_USERS);

    // SocialRequest API
    addLabel("- Peppermint SocialRequest -", LinearGravity::CENTER_HORIZONTAL, DEFAULT_FONT_SIZE, Node::INVALID_TAG);
    addButton("SocialRequest (social/request_user_profile)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_SOCIAL_REQUEST_REQUEST_USER_PROFILE);
    addButton("SocialRequest (social/invite_dialog)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_SOCIAL_REQUEST_INVITE_DIALOG);
    addButton("SocialRequest (social/received_invite)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_SOCIAL_REQUEST_RECEIVED_INVITE);
    addButton("SocialRequest (social/request_friends)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_SOCIAL_REQUEST_REQUEST_FRIENDS);
    addButton("SocialRequest (social/user_profile_image)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_SOCIAL_REQUEST_USER_PROFILE_IMAGE);
    addButton("SocialRequest (social/share_app_activity)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_SOCIAL_REQUEST_SHARE_APP_ACTIVITY);
    addButton("SocialRequest (social/is_authorized)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_SOCIAL_REQUEST_IS_AUTHORIZED);
//    addButton("SocialRequest (social/logout)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_SOCIAL_REQUEST_LOGOUT);  // removed, C2S.20.0
    addButton("SocialRequest (social/connect)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_SOCIAL_REQUEST_CONNECT);
    addButton("SocialRequest (social/set_permission)", ButtonMode::NEED_PARAM, C2SModuleAPIList::HUB_SOCIAL_REQUEST_SET_PERMISSION);

    scheduleUpdate();

    return true;
}

void PeppermintScene::update(float dt)
{
    BaseView::update(dt);

    static bool firstRun = true;
    if (firstRun) {
        firstRun = false;
    }
}

void PeppermintScene::onButtonEvent(int buttonTag)
{
    // Parameter 세팅 화면 생성 및 이동
    if (buttonTag >= DEFAULT_PARAM_BUTTON_TAG) {
        PeppermintParamScene* paramScene = PeppermintParamScene::create();
        BaseView::pushView(paramScene);
        paramScene->showParameters(buttonTag % DEFAULT_PARAM_BUTTON_TAG);
        return;
    }

    // API 호출
    C2SModuleAPIList::PeppermintAPI api = static_cast<C2SModuleAPIList::PeppermintAPI>(buttonTag);
    switch (api) {

        case C2SModuleAPIList::HUB_ASYNC_REQUEST_DEVICE_REGISTERED:
        {
            string requestName = "device/registered";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            if (params.length() <= 0) {
                hubAsyncReqeust(requestName, "");
                break;
            }

            hubAsyncReqeust(requestName, params);
            break;
        }
        case C2SModuleAPIList::HUB_ASYNC_REQUEST_FRIENDS_GAME:
        {
            string requestName = "friends/game";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            if (params.length() <= 0) {
                hubAsyncReqeust(requestName, "");
                break;
            }

            hubAsyncReqeust(requestName, params);
            break;
        }
        case C2SModuleAPIList::HUB_ASYNC_REQUEST_FRIENDS_OTHER:
        {
            string requestName = "friends/other";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            if (params.length() <= 0) {
                hubAsyncReqeust(requestName, "");
                break;
            }

            hubAsyncReqeust(requestName, params);
            break;
        }
        case C2SModuleAPIList::HUB_ASYNC_REQUEST_FRIENDS_RECEIVE_LIST:
        {
            string requestName = "friends/receive_list";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            if (params.length() <= 0) {
                picojson::object paramsDefault;
                paramsDefault["count"] = picojson::value(static_cast<double>(5));
                string paramsString = picojson::value(paramsDefault).serialize();

                hubAsyncReqeust(requestName, paramsString);
                break;
            }

            hubAsyncReqeust(requestName, params);
            break;
        }
        case C2SModuleAPIList::HUB_ASYNC_REQUEST_FRIENDS_REJECT_REQUEST:
        {
            string requestName = "friends/reject_request";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            if (params.length() <= 0) {
                picojson::object paramsDefault;
                string uid = ParameterDataManager::getInstance()->commonParams->getUid();
                paramsDefault["uid"] = picojson::value(uid);
                string paramsString = picojson::value(paramsDefault).serialize();

                hubAsyncReqeust(requestName, paramsString);
                break;
            }

            hubAsyncReqeust("friends/reject_request", params);
            break;
        }
        case C2SModuleAPIList::HUB_ASYNC_REQUEST_FRIENDS_REQUEST:
        {
            string requestName = "friends/request";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            if (params.length() <= 0) {
                picojson::object paramsDefault;
                paramsDefault["friend_uid"] = picojson::value("0");
                paramsDefault["show_status"] = picojson::value(static_cast<bool>(true));
                string paramsString = picojson::value(paramsDefault).serialize();

                hubAsyncReqeust(requestName, paramsString);
                break;
            }

            hubAsyncReqeust(requestName, params);
            break;
        }
        case C2SModuleAPIList::HUB_ASYNC_REQUEST_FRIENDS:
        {
            string requestName = "friends";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            if (params.length() <= 0) {
                hubAsyncReqeust(requestName, "");
                break;
            }

            hubAsyncReqeust(requestName, params);
            break;
        }
        case C2SModuleAPIList::HUB_ASYNC_REQUEST_GUEST_AUTH:
        {
            string requestName = "guest/auth";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            if (params.length() <= 0) {
                picojson::object paramsDefault;
                string guestUid = ParameterDataManager::getInstance()->peppermintParams->getGuestUid();
                paramsDefault["guest_uid"] = picojson::value(guestUid);
                string paramsString = picojson::value(paramsDefault).serialize();

                hubAsyncReqeust(requestName, paramsString);
                break;
            }

            hubAsyncReqeust(requestName, params);
            break;
        }
        case C2SModuleAPIList::HUB_ASYNC_REQUEST_GUEST_CREATE:
        {
            string requestName = "guest/create";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            if (params.length() <= 0) {
                hubAsyncReqeust(requestName, "");
                break;
            }

            hubAsyncReqeust(requestName, params);
            break;
        }
        case C2SModuleAPIList::HUB_ASYNC_REQUEST_GUEST_STATUS_SAVE_DATA:
        {
            string requestName = "guest/status_savedata";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            if (params == "") {
                picojson::object paramsDefault;
                string uid = ParameterDataManager::getInstance()->commonParams->getUid();
                paramsDefault["uid"] = picojson::value(uid);
                string paramsString = picojson::value(paramsDefault).serialize();

                hubAsyncReqeust(requestName, paramsString);
                break;
            }

            hubAsyncReqeust(requestName, params);
            break;
        }
        case C2SModuleAPIList::HUB_ASYNC_REQUEST_MESSAGE_WRITE:
        {
            string requestName = "message/write";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            if (params.length() <= 0) {
                hubAsyncReqeust(requestName, "");
                break;
            }

            hubAsyncReqeust(requestName, params);
            break;
        }
        case C2SModuleAPIList::HUB_ASYNC_REQUEST_MESSAGE_GET_INVITATIONS:
        {
            string requestName = "message/get_invitations";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            if (params.length() <= 0) {
                hubAsyncReqeust(requestName, "");
                break;
            }

            hubAsyncReqeust(requestName, params);
            break;
        }
        case C2SModuleAPIList::HUB_ASYNC_REQUEST_MESSAGE_NOTI_COUNT:
        {
            string requestName = "message/noticount";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            if (params.length() <= 0) {
                hubAsyncReqeust(requestName, "");
                break;
            }

            hubAsyncReqeust(requestName, params);
            break;
        }
        case C2SModuleAPIList::HUB_ASYNC_REQUEST_UPLOAD_IMAGE_WITH_JSON:
        {
            string requestName = "upload/image_with_json";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            if (params.length() <= 0) {
                picojson::object paramsDefault;
                // 개발자 사이트 Hive 로고 이미지 캡처
                string imageBase64 = PeppermintParamScene::getImageBase64();
                paramsDefault["image"] = picojson::value(imageBase64);
                string paramsString = picojson::value(paramsDefault).serialize();
                hubAsyncReqeust(requestName, paramsString);
                break;
            }

            hubAsyncReqeust(requestName, params);
            break;
        }
        case C2SModuleAPIList::HUB_ASYNC_REQUEST_USER_HUB_UID:
        {
            string requestName = ParameterDataManager::getInstance()->peppermintParams->getRequestName();

            if (requestName.empty()) {
                requestName = "user/";
                requestName.append(ParameterDataManager::getInstance()->commonParams->getUid());
            }

            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            if (params.empty()) {
                hubAsyncReqeust(requestName, "");
                break;
            }

            hubAsyncReqeust(requestName, params);
            break;
        }
        case C2SModuleAPIList::HUB_ASYNC_REQUEST_USER_ME_NOTIFICATIONS:
        {
            string requestName = "user/me/notifications";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            if (params.length() <= 0) {
                hubAsyncReqeust(requestName, "");
                break;
            }

            hubAsyncReqeust(requestName, params);
            break;
        }
        case C2SModuleAPIList::HUB_ASYNC_REQUEST_USER_ME:
        {
            string requestName = "user/me";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            if (params.length() <= 0) {
                hubAsyncReqeust(requestName, "");
                break;
            }

            hubAsyncReqeust(requestName, params);
            break;
        }
        case C2SModuleAPIList::HUB_ASYNC_REQUEST_USER_MODIFY_INFO:
        {
            string requestName = "user/modify_info";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            if (params.length() <= 0) {
                picojson::object paramsDefault;
                paramsDefault["comment"] = picojson::value("c2s sample comment");
                paramsDefault["realname"] = picojson::value("c2s sample realname");
                string paramsString = picojson::value(paramsDefault).serialize();

                hubAsyncReqeust(requestName, paramsString);
                break;
            }

            hubAsyncReqeust(requestName, params);
            break;
        }
        case C2SModuleAPIList::HUB_ASYNC_REQUEST_USERS:
        {
            string requestName = "users";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            if (params.length() <= 0) {
                // 조회 할 UID목록 (Default)
                picojson::array uidArray;
                uidArray.push_back(picojson::value("1234567"));
                uidArray.push_back(picojson::value("1234568"));
                picojson::value uidList = picojson::value(uidArray);

                picojson::object paramsDefault;
                paramsDefault["uid_list"] = picojson::value(uidList);
                string paramsString = picojson::value(paramsDefault).serialize();

                hubAsyncReqeust(requestName, paramsString);
                break;
            }

            hubAsyncReqeust(requestName, params);
            break;
        }
        case C2SModuleAPIList::HUB_AUTH:
        {
            void* callbackParam = NULL;

            int resultCode = CS_hubAuth([](const char* jsonString, void* param){

                // set uid
                picojson::value json = ParameterDataManager::getInstance()->parseStringToJsonData(jsonString);
                string did = json.get("did").to_str();
                string uid = json.get("uid").to_str();
                string sessionKey = json.get("sessionkey").to_str();

                ParameterDataManager::getInstance()->commonParams->setDid(did);
                ParameterDataManager::getInstance()->commonParams->setUid(uid);
                ParameterDataManager::getInstance()->commonParams->setSessionKey(sessionKey);
                // File write
                ParameterDataManager::getInstance()->commonParams->writeCommonParametersToFile();

                addLogHubCallbackWithJSON(jsonString, param);

                // postbox login
                Postbox::setLoginType(Postbox::v0);
                Postbox::login([=](const Postbox::Login *data, Postbox::Error error){
                    stringstream postboxLog;

                    if (data != NULL) {
                        postboxLog << "nickname : " << data->nickname << '\n';
                        postboxLog << "gem : " << data->gem << '\n';
                        postboxLog << "gold : " << data->gold << '\n';
                    }
                    postboxLog << "error" << '\n';
                    postboxLog << "result_code : " << error.result_code << '\n';
                    postboxLog << "result_msg : " << error.result_msg << '\n';

                    addCallbackLogMessage(postboxLog.str(), "Postbox::login CB : ");
                });
            }, callbackParam);

            addLogResultCode("CS_hubAuth", resultCode);
            break;
        }
        case C2SModuleAPIList::HUB_AUTH_WITH_PARAM:
        {
            string param = ParameterDataManager::getInstance()->peppermintParams->getAuthWithParam();
            void* callbackParam = NULL;

            int resultCode = CS_hubAuthWithParam(param.c_str(), [](const char* jsonString, void* param){


                picojson::value json = ParameterDataManager::getInstance()->parseStringToJsonData(jsonString);
                if(json.contains("needGuestLogin")) {

                    addLogHubCallbackWithJSON(jsonString, param);

                } else {

                    // set uid
                    string did = json.get("did").to_str();
                    string uid = json.get("uid").to_str();
                    string sessionKey = json.get("sessionkey").to_str();

                    ParameterDataManager::getInstance()->commonParams->setDid(did);
                    ParameterDataManager::getInstance()->commonParams->setUid(uid);
                    ParameterDataManager::getInstance()->commonParams->setSessionKey(sessionKey);
                    // File write
                    ParameterDataManager::getInstance()->commonParams->writeCommonParametersToFile();

                    addLogHubCallbackWithJSON(jsonString, param);

                    // postbox login
                    Postbox::setLoginType(Postbox::v0);
                    Postbox::login([=](const Postbox::Login *data, Postbox::Error error){
                        stringstream postboxLog;

                        if (data != NULL) {
                            postboxLog << "nickname : " << data->nickname << '\n';
                            postboxLog << "gem : " << data->gem << '\n';
                            postboxLog << "gold : " << data->gold << '\n';
                        }
                        postboxLog << "error" << '\n';
                        postboxLog << "result_code : " << error.result_code << '\n';
                        postboxLog << "result_msg : " << error.result_msg << '\n';

                        addCallbackLogMessage(postboxLog.str(), "Postbox::login CB : ");
                    });
                }

            }, callbackParam);

            addLogResultCode("CS_hubAuthWithParam", resultCode);
            break;
        }
        case C2SModuleAPIList::HUB_GUEST_ACQUIRE_UID:
        {
            void* callbackParam = NULL;

            int resultCode = CS_hubGuestAcquireUid([](const char* jsonString, void* param){

                picojson::value json = ParameterDataManager::getInstance()->parseStringToJsonData(jsonString);
                string candidateUid = json.get("uid").to_str();
                if(candidateUid != "") {
                    ParameterDataManager::getInstance()->peppermintParams->setCandidateUid(candidateUid);
                }

                addLogHubCallbackWithJSON(jsonString, param);
            }, callbackParam);

            addLogResultCode("CS_hubGuestAcquireUid", resultCode);

            break;
        }
        case C2SModuleAPIList::HUB_GUEST_BIND:
        {
            string guestUid = ParameterDataManager::getInstance()->peppermintParams->getGuestUid();
            string candidateUid = ParameterDataManager::getInstance()->peppermintParams->getCandidateUid();
            void* callbackParam = NULL;

            int resultCode = CS_hubGuestBind(guestUid.c_str(), candidateUid.c_str(), [](const char* jsonString, void* param){

                // set uid
                picojson::value json = ParameterDataManager::getInstance()->parseStringToJsonData(jsonString);
                string did = json.get("did").to_str();
                string uid = json.get("uid").to_str();
                string sessionKey = json.get("sessionkey").to_str();

                ParameterDataManager::getInstance()->commonParams->setDid(did);
                ParameterDataManager::getInstance()->commonParams->setUid(uid);
                ParameterDataManager::getInstance()->commonParams->setSessionKey(sessionKey);

                addLogHubCallbackWithJSON(jsonString, param);

                // postbox login
                Postbox::setLoginType(Postbox::v0);
                Postbox::login([=](const Postbox::Login *data, Postbox::Error error){
                    stringstream postboxLog;

                    if (data != NULL) {
                        postboxLog << "nickname : " << data->nickname << '\n';
                        postboxLog << "gem : " << data->gem << '\n';
                        postboxLog << "gold : " << data->gold << '\n';
                    }
                    postboxLog << "error" << '\n';
                    postboxLog << "result_code : " << error.result_code << '\n';
                    postboxLog << "result_msg : " << error.result_msg << '\n';

                    addCallbackLogMessage(postboxLog.str(), "Postbox::login CB : ");
                });

            }, callbackParam);

            addLogResultCode("CS_hubGuestBind", resultCode);

            break;
        }
        case C2SModuleAPIList::HUB_INITIALIZE:
        {
//            string appId = ParameterDataManager::getInstance()->peppermintParams->getAppId();
//            string gameIndex = ParameterDataManager::getInstance()->peppermintParams->getGameIndex();
//            bool useTestServer = ParameterDataManager::getInstance()->peppermintParams->getUseTestServer();
//
//            int resultCode = CS_hubInitialize(appId.c_str(), gameIndex.c_str(), useTestServer);

            addLogResultCode("CS_hubInitialize(deprecated)", 0);


            break;
        }
        case C2SModuleAPIList::HUB_INITIALIZE_EX:
        {
            string appId = ParameterDataManager::getInstance()->peppermintParams->getAppId();
            HiveSocialServerState serverType = ParameterDataManager::getInstance()->peppermintParams->getServerState();

            int resultCode = CS_hubInitializeEx(appId.c_str(), serverType);

            addLogResultCode("CS_hubInitializeEx", resultCode);

            break;
        }
        case C2SModuleAPIList::HUB_LOGOUT:
        {
            void* callbackParam = NULL;

            int resultCode = CS_hubLogout([](const char* jsonString, void* param){

                ParameterDataManager::getInstance()->onLogOut();

                addLogHubCallbackWithJSON(jsonString, param);
            }, callbackParam);

            addLogResultCode("CS_hubLogout", resultCode);

            break;
        }
        case C2SModuleAPIList::HUB_SET_OPTION:
        {
//            string key = ParameterDataManager::getInstance()->peppermintParams->getKey();
//            string value = ParameterDataManager::getInstance()->peppermintParams->getValue();
//
//            int resultCode = CS_hubSetOption(key.c_str(), value.c_str());
            addLogResultCode("CS_hubSetOption(deprecated)", 0);

            break;
        }
        case C2SModuleAPIList::HUB_SHOW_DIALOG:
        {
            string relativePath = ParameterDataManager::getInstance()->peppermintParams->getRelativePath();
            void* callbackParam = NULL;

            int resultCode = CS_hubShowDialog(relativePath.c_str(), [](const char* jsonString, void* param){

                addLogHubCallbackWithJSON(jsonString, param);
            }, callbackParam);

            addLogResultCode("CS_hubShowDialog", resultCode);

            break;
        }
        case C2SModuleAPIList::HUB_SHOW_DIALOG_FOR_CHAT_BOT:
        {
            string param = ParameterDataManager::getInstance()->peppermintParams->getChatbotParam();
            void* callbackParam = NULL;

            int resultCode = CS_hubShowDialogForChatbot(param.c_str(), [](const char* jsonString, void* param){

                addLogHubCallbackWithJSON(jsonString, param);
            }, callbackParam);

            addLogResultCode("CS_hubShowDialogForChatbot", resultCode);

            break;
        }
        case C2SModuleAPIList::HUB_SET_AUTH_DIALOG_CLEAR:
        {
            void* callbackParam = NULL;

            int resultCode = CS_hubSetAuthDialogClear();

            addLogResultCode("CS_hubSetAuthDialogClear1", resultCode);
            break;
        }

//        case C2SModuleAPIList::HUB_SET_PGS_AUTO_LOGIN:
//        {
//            int resultCode = CS_hubSetPGSAutoLogin();
//
//            addLogResultCode("CS_hubSetPGSAutoLogin", resultCode);
//
//            break;
//        }
        case C2SModuleAPIList::HUB_SET_PGS_AUTO_LOGIN_WITH_CB:
        {
#if (CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID)
            void* callbackParam = NULL;

            int resultCode = CS_hubSetPGSAutoLoginWithCB([](const char* jsonString, void* param) {
                addLogHubCallbackWithJSON(jsonString, param);
            }, callbackParam);

            addLogResultCode("CS_hubSetPGSAutoLoginWithCB", resultCode);
#else
            addLogMessage("CS_hubSetPGSAutoLoginWithCB(not support in IOS, Android Only)");
#endif
            break;
        }
        case C2SModuleAPIList::HUB_USER_DELETE_CB:
        {
            void* callbackParam = NULL;

            int resultCode = CS_hubUserDelete([](const char* jsonString, void* param) {
                addLogHubCallbackWithJSON(jsonString, param);
            }, callbackParam);

            addLogResultCode("CS_hubUserDelete", resultCode);
            break;
        }
//        case C2SModuleAPIList::HUB_IS_PGS_AVAILABLE:
//        {
//            int resultCode = CS_hubIsPGSAvailable();
//
//            addLogResultCode("CS_hubIsPGSAvailable", resultCode);
//
//            break;
//        }

        /** SOCIAL_REQUEST **/
        case C2SModuleAPIList::HUB_SOCIAL_REQUEST_REQUEST_USER_PROFILE:     // facebook
        {
            string socialService = ParameterDataManager::getInstance()->peppermintParams->getSocialService();
            string requestName = "social/request_user_profile";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            void *callbackParam = NULL;

            int resultCode = CS_hubSocialRequest(socialService.c_str(), requestName.c_str(), params.c_str(), [](const char *jsonString, void *param) {
                addLogHubCallbackWithJSON(jsonString, param);
            }, callbackParam);

            stringstream log;
            log << "CS_hubSocialRequest(" << requestName << ")";
            addLogResultCode(log.str().c_str(), resultCode);

            break;
        }
        case C2SModuleAPIList::HUB_SOCIAL_REQUEST_INVITE_DIALOG:            // facebook
        {
            string socialService = ParameterDataManager::getInstance()->peppermintParams->getSocialService();
            string requestName = "social/invite_dialog";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            void *callbackParam = NULL;

            int resultCode = CS_hubSocialRequest(socialService.c_str(), requestName.c_str(), params.c_str(), [](const char *jsonString, void *param) {
                addLogHubCallbackWithJSON(jsonString, param);
            }, callbackParam);

            stringstream log;
            log << "CS_hubSocialRequest(" << requestName << ")";
            addLogResultCode(log.str().c_str(), resultCode);

            break;
        }
        case C2SModuleAPIList::HUB_SOCIAL_REQUEST_RECEIVED_INVITE:          // facebook
        {
            string socialService = ParameterDataManager::getInstance()->peppermintParams->getSocialService();
            string requestName = "social/received_invite";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            void *callbackParam = NULL;

            int resultCode = CS_hubSocialRequest(socialService.c_str(), requestName.c_str(), params.c_str(), [](const char *jsonString, void *param) {
                addLogHubCallbackWithJSON(jsonString, param);
            }, callbackParam);

            stringstream log;
            log << "CS_hubSocialRequest(" << requestName << ")";
            addLogResultCode(log.str().c_str(), resultCode);

            break;
        }
        case C2SModuleAPIList::HUB_SOCIAL_REQUEST_REQUEST_FRIENDS:          // facebook
        {
            string socialService = ParameterDataManager::getInstance()->peppermintParams->getSocialService();
            string requestName = "social/request_friends";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            void *callbackParam = NULL;

            int resultCode = CS_hubSocialRequest(socialService.c_str(), requestName.c_str(), params.c_str(), [](const char *jsonString, void *param) {
                addLogHubCallbackWithJSON(jsonString, param);
            }, callbackParam);

            stringstream log;
            log << "CS_hubSocialRequest(" << requestName << ")";
            addLogResultCode(log.str().c_str(), resultCode);

            break;
        }
        case C2SModuleAPIList::HUB_SOCIAL_REQUEST_USER_PROFILE_IMAGE:       // facebook
        {
            string socialService = ParameterDataManager::getInstance()->peppermintParams->getSocialService();
            string requestName = "social/user_profile_image";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            void *callbackParam = NULL;

            int resultCode = CS_hubSocialRequest(socialService.c_str(), requestName.c_str(), params.c_str(), [](const char *jsonString, void *param) {
                addLogHubCallbackWithJSON(jsonString, param);
            }, callbackParam);

            stringstream log;
            log << "CS_hubSocialRequest(" << requestName << ")";
            addLogResultCode(log.str().c_str(), resultCode);

            break;
        }
        case C2SModuleAPIList::HUB_SOCIAL_REQUEST_SHARE_APP_ACTIVITY:       // facebook
        {
            string socialService = ParameterDataManager::getInstance()->peppermintParams->getSocialService();
            string requestName = "social/share_app_activity";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            void *callbackParam = NULL;

            int resultCode = CS_hubSocialRequest(socialService.c_str(), requestName.c_str(), params.c_str(), [](const char *jsonString, void *param) {
                addLogHubCallbackWithJSON(jsonString, param);
            }, callbackParam);

            stringstream log;
            log << "CS_hubSocialRequest(" << requestName << ")";
            addLogResultCode(log.str().c_str(), resultCode);

            break;
        }
        case C2SModuleAPIList::HUB_SOCIAL_REQUEST_IS_AUTHORIZED:            // facebook
        {
            string socialService = ParameterDataManager::getInstance()->peppermintParams->getSocialService();
            string requestName = "social/is_authorized";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            void *callbackParam = NULL;

            int resultCode = CS_hubSocialRequest(socialService.c_str(), requestName.c_str(), params.c_str(), [](const char *jsonString, void *param) {
                addLogHubCallbackWithJSON(jsonString, param);
            }, callbackParam);

            stringstream log;
            log << "CS_hubSocialRequest(" << requestName << ")";
            addLogResultCode(log.str().c_str(), resultCode);

            break;
        }
        case C2SModuleAPIList::HUB_SOCIAL_REQUEST_LOGOUT:                   // facebook
        {
            string socialService = ParameterDataManager::getInstance()->peppermintParams->getSocialService();
            string requestName = "social/logout";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            void *callbackParam = NULL;

            int resultCode = CS_hubSocialRequest(socialService.c_str(), requestName.c_str(),
                                                 params.c_str(),
                                                 [](const char *jsonString, void *param) {

                                                     addLogHubCallbackWithJSON(jsonString, param);
                                                 }, callbackParam);

            stringstream log;
            log << "CS_hubSocialRequest(" << requestName << ")";
            addLogResultCode(log.str().c_str(), resultCode);

            break;
        }
        case C2SModuleAPIList::HUB_SOCIAL_REQUEST_CONNECT:                  // facebook, googleplus
        {
            string socialService = ParameterDataManager::getInstance()->peppermintParams->getSocialService();
            string requestName = "social/connect";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            void *callbackParam = NULL;

            int resultCode = CS_hubSocialRequest(socialService.c_str(), requestName.c_str(), params.c_str(), [](const char *jsonString, void *param) {
                addLogHubCallbackWithJSON(jsonString, param);
            }, callbackParam);

            stringstream log;
            log << "CS_hubSocialRequest(" << requestName << ")";
            addLogResultCode(log.str().c_str(), resultCode);

            break;
        }
        case C2SModuleAPIList::HUB_SOCIAL_REQUEST_SET_PERMISSION:           // facebook
        {
            string socialService = ParameterDataManager::getInstance()->peppermintParams->getSocialService();
            string requestName = "social/set_permission";
            string params = ParameterDataManager::getInstance()->peppermintParams->getParams(requestName);

            void *callbackParam = NULL;

            int resultCode = CS_hubSocialRequest(socialService.c_str(), requestName.c_str(), params.c_str(), [](const char *jsonString, void *param) {
                addLogHubCallbackWithJSON(jsonString, param);
            }, callbackParam);

            stringstream log;
            log << "CS_hubSocialRequest(" << requestName << ")";
            addLogResultCode(log.str().c_str(), resultCode);

            stringstream logParam;
            logParam << params;
            addLogParamData(log.str().c_str(), logParam.str().c_str());

            break;
        }
        case C2SModuleAPIList::HUB_UNINITIALIZE:
        {
//            int resultCode = CS_hubUninitialize();

            addLogResultCode("CS_hubUninitialize", 0);
            addLogMessage("( CS_hubUninitialize API는 KS C2S에서 더이상 작동하지 않습니다.(deprecated 예정) )");

            break;
        }
        default:
            break;
    }
}

void PeppermintScene::addLogHubCallbackWithJSON(const char* jsonString, void* param)
{
    stringstream log;

    log << "jsonString : ";
    if (jsonString) {
        log << jsonString << '\n';
    }
    else {
        log << "NULL" << '\n';
    }

    const char* paramString = static_cast<const char*>(param);

    log<< "param : ";
    if (paramString) {
        log << paramString << '\n';
    }
    else {
        log << "NULL" << '\n';
    }

    BaseView::addCallbackLogMessage(log.str().c_str(), "HubCallbackWithJSON : ");
}

void PeppermintScene::addLogResultCode(const char* api, int resultCode)
{
    stringstream log;
    log << api << " called. result : " << to_string(resultCode) << '\n';
    addLogMessage(log.str().c_str());
}

void PeppermintScene::addLogParamData(const char* api, const char* param)
{
    stringstream log;
    log << api << " param : " << param << '\n';
    addLogMessage(log.str().c_str());
}

void PeppermintScene::hubAsyncReqeust(string requestName, string params)
{
    void* callbackParam = NULL;

    int resultCode = CS_hubAsyncRequest(requestName.c_str(), params.c_str(), [](const char* jsonString, void* param){

        // guest/create 인 경우 guest_uid 처리
        picojson::value json = ParameterDataManager::getInstance()->parseStringToJsonData(
                jsonString);
        string type = json.get("type").to_str();
        string errorCode = json.get("error_code").to_str();
        string guestUid = json.get("guest_uid").to_str();
        string did = json.get("did").to_str();

        if (type == "guest/create" && errorCode == "0" && guestUid != "") {
            ParameterDataManager::getInstance()->peppermintParams->setGuestUid(guestUid);
            ParameterDataManager::getInstance()->commonParams->setDid(did);
        }
        else if (type == "guest/auth" && errorCode == "0") {
            // Guest postbox login
            Postbox::setLoginType(Postbox::v0);
            Postbox::login([=](const Postbox::Login *data, Postbox::Error error){
                stringstream postboxLog;

                if (data != NULL) {
                    postboxLog << "nickname : " << data->nickname << '\n';
                    postboxLog << "gem : " << data->gem << '\n';
                    postboxLog << "gold : " << data->gold << '\n';
                }
                postboxLog << "error" << '\n';
                postboxLog << "result_code : " << error.result_code << '\n';
                postboxLog << "result_msg : " << error.result_msg << '\n';

                addCallbackLogMessage(postboxLog.str(), "Postbox::login CB : ");
            });
        }

        addLogHubCallbackWithJSON(jsonString, param);
    }, callbackParam);

    stringstream log;
    log << "CS_hubAsyncRequest(" << requestName << ")";
    addLogResultCode(log.str().c_str(), resultCode);
}
