//
//  PushParamScene.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by sjyong on 2021/10/20.
//

#ifndef PushParamScene_hpp
#define PushParamScene_hpp

#include <stdio.h>
#include <functional>

#include "C2SModuleAPIList.hpp"
#include "BaseView.hpp"
#include "C2SPush.h"

using namespace std;

class PushParamScene: public BaseView
{
public:
    enum ButtonParam: int {
        BUTTON_OK = 0,
        // Common
        TOGGLE_BUTTON_NOTICE,
        TOGGLE_BUTTON_NIGHT,
        EDITBOX_PUSH_ID,
        EDITBOX_TITLE,
        EDITBOX_MSG,
        EDITBOX_TICKER,
        EDITBOX_TYPE,
        EDITBOX_ICON,
        EDITBOX_SOUND,
        EDITBOX_ACTIVE,
        EDITBOX_AFTER,
        EDITBOX_BROADCAST_ACTION,
        EDITBOX_UID,
        // iOS
        TOGGLE_BUTTON_REMOTE,
        TOGGLE_BUTTON_LOCAL,
        // Android
        TOGGLE_BUTTON_IS_PUSH,
        TOGGLE_BUTTON_IS_SOUND,
        TOGGLE_BUTTON_IS_VIB,
        EDITBOX_BIG_MSG,
        EDITBOX_JSON_PUSH_DATA,
        TOGGLE_BUTTON_BOOLEAN,
    };

    CREATE_FUNC(PushParamScene);

    virtual bool init() override;
    virtual void update(float dt) override;
    virtual void onButtonEvent(int buttonTag) override;

    void showParameters(int tag);
    
private:
    C2SModuleAPIList::PushAPI api;

    function<void()> setCompletionHandler;

    // MARK:  Common
    void showPushSetAgreeParam(function<void()> completionHandler);
    void showPushRegisterLocalPushParam(function<void()> completionHandler);
    void showPushRegisterLocalPushExParam(function<void()> completionHandler);
    void showPushUnRegisterLocalPushParam(function<void()> completionHandler);
    void showPushSetUidParam(function<void()> completionHandler);

    // MARK: iOS
    void showPushSetForegroundParam(function<void()> completionHandler);

    // MARK: Android
    void showPushSetPushParam(function<void()> completionHandler);
    void showPushSetSoundParam(function<void()> completionHandler);
    void showPushSetVibParam(function<void()> completionHandler);
    void showPushRegisterLocalPushBigParam(function<void()> completionHandler);
    void showPushRegisterLocalPushDataParam(function<void()> completionHandler);
    void showPushSetOperationLocalPushOnRunningParam(function<void()> completionHandler);
    void showPushSetOperationGCMPushOnRunningParam(function<void()> completionHandler);

    void addRegisterLocalPushParamButtons();
    void setRegisterLocalPushParam();

    Push_BoolType intToPushUserSetting(int value);
};

#endif /* PushParamScene_hpp */
