#ifdef __ANDROID__
#include <jni.h>
#include "C2SInAppV4.h"
#include <string.h>

#include <android/log.h>
#include <malloc.h>

// TODO : use android log
//#define LOGV(...) __android_log_print(ANDROID_LOG_VERBOSE, "InApp", __VA_ARGS__)
//#define LOGD(...) __android_log_print(ANDROID_LOG_DEBUG  , "InApp", __VA_ARGS__)
//#define LOGI(...) __android_log_print(ANDROID_LOG_INFO   , "InApp", __VA_ARGS__)
//#define LOGW(...) __android_log_print(ANDROID_LOG_WARN   , "InApp", __VA_ARGS__)
//#define LOGE(...) __android_log_print(ANDROID_LOG_ERROR  , "InApp", __VA_ARGS__)

static JavaVM* g_vm;
static jobject g_obj = 0;
static jclass  g_cls = 0;


JNIEXPORT void JNICALL
Java_com_com2us_module_inappv4_InAppV4_jniInAppV4Initialize(JNIEnv* env, jobject thiz, jobject obj) {
	(*env)->GetJavaVM(env, &g_vm);
	g_obj = (*env)->NewGlobalRef(env, obj);
	g_cls = (*env)->NewGlobalRef(env, (*env)->GetObjectClass(env, obj));
}

void CS_IapV4SetLifecycleCB(IapV4LifecycleCB cb) {
    JNIEnv*	env;

    if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)	{
        jmethodID method = (*env)->GetMethodID(env, g_cls, "setIapV4LifecycleListener", "(J)V");
        if (method != 0) {
            jlong cbRef = cb;

            (*env)->CallVoidMethod(env, g_obj, method, cbRef);
        }
    }
}

void CS_IapV4MarketConnect(MarketListCB cb) {
	JNIEnv*	env;

	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)	{
		jmethodID method = (*env)->GetMethodID(env, g_cls, "marketConnect", "(J)V");
		if (method != 0) {
			jlong cbRef = cb;

			(*env)->CallVoidMethod(env, g_obj, method, cbRef);
		}
	}
}

void CS_IapV4GetMarketProductInfo(const char** pidList, ProductInfoCB cb) {
	JNIEnv*	env;
	jobjectArray jpids = 0;

	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)	{
		jmethodID method = (*env)->GetMethodID(env, g_cls, "getMarketProductInfo", "([Ljava/lang/String;J)V");
		if (method != 0) {

            if(pidList != 0) {
                int i = 0;
                for(i = 0; pidList[i] != 0; i++) {
                    // update count i
                }
                jpids = (jobjectArray)(*env)->NewObjectArray(env, i, (*env)->FindClass(env, "java/lang/String"), (*env)->NewStringUTF(env, ""));

                int j = 0;
                for(j = 0; j < i; j++) {
                    (*env)->SetObjectArrayElement(env, jpids, j, (*env)->NewStringUTF(env, pidList[j]));
                }
            }

			jlong cbRef = cb;

			(*env)->CallVoidMethod(env, g_obj, method, jpids, cbRef);
		}
	}
}

void CS_IapV4GetProductInfo(ProductInfoCB cb) {
	JNIEnv*	env;

	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)	{
		jmethodID method = (*env)->GetMethodID(env, g_cls, "getProductInfo", "(J)V");
		if (method != 0) {
			jlong cbRef = cb;

			(*env)->CallVoidMethod(env, g_obj, method, cbRef);
		}
	}
}

void CS_IapV4GetSubscriptionProductInfo(ProductInfoCB cb) {
	JNIEnv*	env;

	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)	{
		jmethodID method = (*env)->GetMethodID(env, g_cls, "getSubscriptionProductInfo", "(J)V");
		if (method != 0) {
			jlong cbRef = cb;

			(*env)->CallVoidMethod(env, g_obj, method, cbRef);
		}
	}
}

void CS_IapV4Purchase(const char* marketPid, const char* additionalInfo, ReceiptInfoCB cb) {
	JNIEnv*	env;

	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)	{
		jmethodID method = (*env)->GetMethodID(env, g_cls, "purchase", "(Ljava/lang/String;Ljava/lang/String;J)V");
		if (method != 0) {
			jstring jmarketPid = (*env)->NewStringUTF(env, marketPid);
			jstring jadditionalInfo = (*env)->NewStringUTF(env, additionalInfo);
			jlong cbRef = cb;

			(*env)->CallVoidMethod(env, g_obj, method, jmarketPid, jadditionalInfo, cbRef);

			(*env)->DeleteLocalRef(env, jmarketPid);
			(*env)->DeleteLocalRef(env, jadditionalInfo);
		}
	}
}

void CS_IapV4PurchaseSubscription(const char* marketPid, const char* oldMarketPid, const char* additionalInfo, ReceiptInfoCB cb) {
	JNIEnv*	env;

	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)	{
		jmethodID method = (*env)->GetMethodID(env, g_cls, "purchaseSubscription", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;J)V");
		if (method != 0) {
			jstring jmarketPid = (*env)->NewStringUTF(env, marketPid);
			jstring joldMarketPid = (*env)->NewStringUTF(env, oldMarketPid);
			jstring jadditionalInfo = (*env)->NewStringUTF(env, additionalInfo);
			jlong cbRef = cb;

			(*env)->CallVoidMethod(env, g_obj, method, jmarketPid, joldMarketPid, jadditionalInfo, cbRef);

			(*env)->DeleteLocalRef(env, jmarketPid);
			(*env)->DeleteLocalRef(env, joldMarketPid);
			(*env)->DeleteLocalRef(env, jadditionalInfo);
		}
	}
}

void CS_IapV4Restore(ReceiptListInfoCB cb) {
	JNIEnv*	env;

	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)	{
		jmethodID method = (*env)->GetMethodID(env, g_cls, "restore", "(J)V");
		if (method != 0) {
			jlong cbRef = cb;

			(*env)->CallVoidMethod(env, g_obj, method, cbRef);
		}
	}
}

void CS_IapV4RestoreSubscription(ReceiptListInfoCB cb) {
	JNIEnv*	env;

	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)	{
		jmethodID method = (*env)->GetMethodID(env, g_cls, "restoreSubscription", "(J)V");
		if (method != 0) {
			jlong cbRef = cb;

			(*env)->CallVoidMethod(env, g_obj, method, cbRef);
		}
	}
}

void CS_IapV4TransactionFinish(const char* marketPid, TransactionCB cb) {
	JNIEnv*	env;

	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)	{
		jmethodID method = (*env)->GetMethodID(env, g_cls, "transactionFinish", "(Ljava/lang/String;J)V");
		if (method != 0) {
			jstring jmarketPid = (*env)->NewStringUTF(env, marketPid);
			jlong cbRef = cb;

			(*env)->CallVoidMethod(env, g_obj, method, jmarketPid, cbRef);

			(*env)->DeleteLocalRef(env, jmarketPid);
		}
	}
}

void CS_IapV4ShowMarketSelection(MarketListCB cb) {
	JNIEnv*	env;

	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)	{
		jmethodID method = (*env)->GetMethodID(env, g_cls, "showMarketSelection", "(J)V");
		if (method != 0) {
			jlong cbRef = cb;

			(*env)->CallVoidMethod(env, g_obj, method, cbRef);
		}
	}
}

void CS_IapV4GetBalanceInfo(BalanceCB cb) {
	JNIEnv*	env;

	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)	{
		jmethodID method = (*env)->GetMethodID(env, g_cls, "getBalanceInfo", "(J)V");
		if (method != 0) {
			jlong cbRef = cb;

			(*env)->CallVoidMethod(env, g_obj, method, cbRef);
		}
	}
}

void CS_IapV4ShowCharge(BalanceCB cb) {
	JNIEnv*	env;

	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)	{
		jmethodID method = (*env)->GetMethodID(env, g_cls, "showCharge", "(J)V");
		if (method != 0) {
			jlong cbRef = cb;

			(*env)->CallVoidMethod(env, g_obj, method, cbRef);
		}
	}
}

void CS_IapV4CheckPromotePurchase(CheckPromotePurchaseCB cb) {
	JNIEnv*	env;

	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)	{
		jmethodID method = (*env)->GetMethodID(env, g_cls, "checkPromotePurchase", "(J)V");
		if (method != 0) {
			jlong cbRef = cb;

			(*env)->CallVoidMethod(env, g_obj, method, cbRef);
		}
	}
}

int CS_IapV4GetSelectedMarket() {
	JNIEnv*	env;

	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
		jmethodID method = (*env)->GetMethodID(env, g_cls, "getSelectedMarket", "()I");
		if (method != 0) {
			return (*env)->CallIntMethod(env, g_obj, method);
		}
	}
	return 0;
}

const char* CS_IapV4GetAccountUuid(void) {
	JNIEnv *env = 0;

	jstring jaccountUuid = 0;
	char *ret = "";

	if((*g_vm)->GetEnv(g_vm, (void **)&env, JNI_VERSION_1_6) == JNI_OK)
	{
		jmethodID method = (*env)->GetMethodID(env, g_cls, "getAccountUuid", "()Ljava/lang/String;");
		if (0 != method) {
            jaccountUuid = (jstring) (*env)->CallObjectMethod(env, g_obj, method);
		}
	}

	if (jaccountUuid != 0) {
		ret = strdup((*env)->GetStringUTFChars(env, jaccountUuid, 0));
		(*env)->DeleteLocalRef(env, jaccountUuid);
		/* (ret == '\0') == (ret == NULL) == (ret == 0) */
		if (ret != NULL) {
			if (ret[0] == '\0') {
				free(ret);
				ret = 0;    /* or ret = NULL; */
			}
		}
	}

	return ret;
}

const char* CS_IapV4GetVersion() {
    JNIEnv *env = 0;
    jmethodID method;

    jstring jversion = 0;
    char *ret = "0";

    if (JNI_OK == (*g_vm)->GetEnv(g_vm, (void **) &env, JNI_VERSION_1_6)) {
        method = (*env)->GetStaticMethodID(env, g_cls, "getVersion", "()Ljava/lang/String;");
        if (0 != method) {
            jversion = (jstring) (*env)->CallStaticObjectMethod(env, g_cls, method);
        }
    }

    if (jversion != 0) {
        ret = strdup((*env)->GetStringUTFChars(env, jversion, 0));
        (*env)->DeleteLocalRef(env, jversion);
        /* (ret == '\0') == (ret == NULL) == (ret == 0) */
        if (ret != NULL) {
            if (ret[0] == '\0') {
                free(ret);
                ret = 0;    /* or ret = NULL; */
            }
        }
    }

    return ret;
}


char*
CS_IapV4JstringToChar(JNIEnv* env, jstring str)
{
    char* cDesc = strdup( (*env)->GetStringUTFChars(env, str, 0) );
    return cDesc;
}

char*
CS_IapV4JstringArrayToCharP(JNIEnv *env, jobjectArray stringArray)
{

	int stringCount = (*env)->GetArrayLength(env, stringArray);

	char* pids[stringCount+1];

	int i=0;
	for (i=0; i<stringCount; i++) {
		jstring string = (jstring) (*env)->GetObjectArrayElement(env, stringArray, i);
		pids[i] = strdup( (*env)->GetStringUTFChars(env, string, 0) );
		// Don't forget to call `ReleaseStringUTFChars` when you're done.
	}
	pids[stringCount+1] = 0;
	return pids;
}

JNIEXPORT void JNICALL
Java_com_com2us_module_inappv4_InAppV4_csIapV4LifecycleCB(JNIEnv* env, jobject obj, jlong cbRef, jint type, jstring str_data) {
    IapV4LifecycleCB cb = cbRef;

    char* data = CS_IapV4JstringToChar(env, str_data);

    if(cb != 0) {
        cb(type, data);
    }

	if(data != NULL)
		(*env)->ReleaseStringUTFChars(env, str_data, data);
}

JNIEXPORT void JNICALL
Java_com_com2us_module_inappv4_InAppV4_csMarketListCB(JNIEnv* env, jobject obj, jlong cbRef, jint code, jint errorCode, jstring str_errorMsg, jobject marketList) {
	MarketListCB cb = cbRef;

	char* errorMsg = CS_IapV4JstringToChar(env, str_errorMsg);

    CS_IapV4Result iapv4Result;
    iapv4Result.result = code;
    iapv4Result.errorCode = errorCode;
    iapv4Result.errorMessage = errorMsg;

	if(cb != 0) {
		if(marketList != 0) {
			int objectLength = (*env)->GetArrayLength(env, (jintArray)marketList);
            int* buf = (*env)->GetIntArrayElements(env, (jintArray)marketList, NULL);

			cb(iapv4Result, objectLength, buf);
		} else {
			int* marketListArr = NULL;
            cb(iapv4Result, 0, marketListArr);
		}
	}

	if(errorMsg != NULL)
		(*env)->ReleaseStringUTFChars(env, str_errorMsg, errorMsg);
}

JNIEXPORT void JNICALL
Java_com_com2us_module_inappv4_InAppV4_csGetProductInfoCB(JNIEnv* env, jobject obj, jlong cbRef, jint code, jint errorCode, jstring str_errorMsg, jobject productInfo) {
	ProductInfoCB cb = cbRef;

	char* errorMsg = CS_IapV4JstringToChar(env, str_errorMsg);

    CS_IapV4Result iapv4Result;
    iapv4Result.result = code;
    iapv4Result.errorCode = errorCode;
    iapv4Result.errorMessage = errorMsg;

    if(cb != 0) {
		if(productInfo != 0) {
			CS_IapV4ProductInfo* iapV4ProductInfo;

			int objectLength = (*env)->GetArrayLength(env, (jobjectArray)productInfo);
            iapV4ProductInfo = (CS_IapV4ProductInfo*)malloc( (sizeof(CS_IapV4ProductInfo) * (objectLength) ) );
			jobjectArray originalArray = (jobjectArray)productInfo;

			//
            jobject jobj = (*env)->GetObjectArrayElement(env, originalArray, 0);
            jclass cls = (*env)->GetObjectClass(env, jobj);

            //
            jfieldID fid_productType = (*env)->GetFieldID(env, cls, "productType", "Ljava/lang/String;");
            jfieldID fid_marketPid = (*env)->GetFieldID(env, cls, "marketPid", "Ljava/lang/String;");
            jfieldID fid_currency = (*env)->GetFieldID(env, cls, "currency", "Ljava/lang/String;");
            jfieldID fid_price = (*env)->GetFieldID(env, cls, "price", "D");
            jfieldID fid_displayPrice = (*env)->GetFieldID(env, cls, "displayPrice", "Ljava/lang/String;");
            //
            jfieldID fid_title = (*env)->GetFieldID(env, cls, "title", "Ljava/lang/String;");
            jfieldID fid_description = (*env)->GetFieldID(env, cls, "description", "Ljava/lang/String;");
            jfieldID fid_originalJson = (*env)->GetFieldID(env, cls, "originalJson", "Ljava/lang/String;");
            jfieldID fid_displayOriginalPrice = (*env)->GetFieldID(env, cls, "displayOriginalPrice", "Ljava/lang/String;");
            jfieldID fid_originalPrice = (*env)->GetFieldID(env, cls, "originalPrice", "D");
            //
            jfieldID fid_iconUrl = (*env)->GetFieldID(env, cls, "iconUrl", "Ljava/lang/String;");
            jfieldID fid_coinsReward = (*env)->GetFieldID(env, cls, "coinsReward", "I");

			int i = 0;
			for (i = 0; i < objectLength; i++) {
                (*env)->PushLocalFrame(env, 100);

				jobj = (*env)->GetObjectArrayElement(env, originalArray, i);
				cls = (*env)->GetObjectClass(env, jobj);

				jstring tempJstring;
				//
                tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_productType);
                iapV4ProductInfo[i].productType = CS_IapV4JstringToChar(env, tempJstring);
                (*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_marketPid);
				iapV4ProductInfo[i].marketPid = CS_IapV4JstringToChar(env, tempJstring);
				(*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_currency);
				iapV4ProductInfo[i].currency = CS_IapV4JstringToChar(env, tempJstring);
				(*env)->DeleteLocalRef(env, tempJstring);

				iapV4ProductInfo[i].price = (jlong)(*env)->GetDoubleField(env, jobj, fid_price);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_displayPrice);
				iapV4ProductInfo[i].displayPrice = CS_IapV4JstringToChar(env, tempJstring);
				(*env)->DeleteLocalRef(env, tempJstring);
                //
				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_title);
				iapV4ProductInfo[i].title = CS_IapV4JstringToChar(env, tempJstring);
				(*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_description);
				iapV4ProductInfo[i].description = CS_IapV4JstringToChar(env, tempJstring);
				(*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_originalJson);
				iapV4ProductInfo[i].originalJson = CS_IapV4JstringToChar(env, tempJstring);
				(*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_displayOriginalPrice);
				iapV4ProductInfo[i].displayOriginalPrice = CS_IapV4JstringToChar(env, tempJstring);
				(*env)->DeleteLocalRef(env, tempJstring);

				iapV4ProductInfo[i].originalPrice = (jlong)(*env)->GetDoubleField(env, jobj, fid_originalPrice);
                //
				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_iconUrl);
				iapV4ProductInfo[i].iconUrl = CS_IapV4JstringToChar(env, tempJstring);
				(*env)->DeleteLocalRef(env, tempJstring);

                iapV4ProductInfo[i].coinsReward = (jint)(*env)->GetIntField(env, jobj, fid_coinsReward);

				(*env)->DeleteLocalRef(env, cls);
				(*env)->DeleteLocalRef(env, jobj);

				(*env)->PopLocalFrame(env, NULL);
			}

			cb(iapv4Result, objectLength, iapV4ProductInfo);

			for (i = 0; i < objectLength; i++) {
				(*env)->PushLocalFrame(env, 100);

				jobj = (*env)->GetObjectArrayElement(env, originalArray, i);

				jstring tempJstring;
				//
                tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_productType);
                (*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ProductInfo[i].productType);
                (*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_marketPid);
				(*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ProductInfo[i].marketPid);
				(*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_currency);
				(*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ProductInfo[i].currency);
				(*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_displayPrice);
				(*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ProductInfo[i].displayPrice);
				(*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_title);
				(*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ProductInfo[i].title);
				(*env)->DeleteLocalRef(env, tempJstring);
				//
				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_description);
				(*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ProductInfo[i].description);
				(*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_originalJson);
				(*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ProductInfo[i].originalJson);
				(*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_displayOriginalPrice);
				(*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ProductInfo[i].displayOriginalPrice);
				(*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_iconUrl);
				(*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ProductInfo[i].iconUrl);
				(*env)->DeleteLocalRef(env, tempJstring);

				(*env)->DeleteLocalRef(env, jobj);

				(*env)->PopLocalFrame(env, NULL);
			}

			(*env)->DeleteLocalRef(env, originalArray);

			free(iapV4ProductInfo);
		} else {
            CS_IapV4ProductInfo* iapV4ProductInfo = NULL;
            cb(iapv4Result, 0, iapV4ProductInfo);
		}
	}

	if(errorMsg != NULL)
		(*env)->ReleaseStringUTFChars(env, str_errorMsg, errorMsg);
}

JNIEXPORT void JNICALL
Java_com_com2us_module_inappv4_InAppV4_csPurchaseCB(JNIEnv* env, jobject obj, jlong cbRef, jint code, jint errorCode, jstring str_errorMsg, jobject receiptInfo) {
	ReceiptInfoCB cb = cbRef;

	char* errorMsg = CS_IapV4JstringToChar(env, str_errorMsg);

    CS_IapV4Result iapv4Result;
    iapv4Result.result = code;
    iapv4Result.errorCode = errorCode;
    iapv4Result.errorMessage = errorMsg;

    if(cb != 0) {
		if(receiptInfo != 0) {
			CS_IapV4ReceiptInfo* iapV4ReceiptInfo;

			int objectLength = (*env)->GetArrayLength(env, (jobjectArray)receiptInfo);
			iapV4ReceiptInfo = (CS_IapV4ReceiptInfo*)malloc( (sizeof(CS_IapV4ReceiptInfo) * (objectLength) ) );
			jobjectArray originalArray = (jobjectArray)receiptInfo;

			//
			jobject jobj = (*env)->GetObjectArrayElement(env, originalArray, 0);
			jclass cls = (*env)->GetObjectClass(env, jobj);

			//
			jfieldID fid_type = (*env)->GetFieldID(env, cls, "type", "I");
			jfieldID fid_additionalInfo = (*env)->GetFieldID(env, cls, "additionalInfo", "Ljava/lang/String;");
			jfieldID fid_bypassInfo = (*env)->GetFieldID(env, cls, "bypassInfo", "Ljava/lang/String;");
			jfieldID fid_hiveiapReceipt = (*env)->GetFieldID(env, cls, "hiveiapReceipt", "Ljava/lang/String;");
			// //
			jfieldID fid_productType = (*env)->GetFieldID(env, cls, "productType", "Ljava/lang/String;");
			jfieldID fid_marketPid = (*env)->GetFieldID(env, cls, "marketPid", "Ljava/lang/String;");
			jfieldID fid_currency = (*env)->GetFieldID(env, cls, "currency", "Ljava/lang/String;");
			jfieldID fid_price = (*env)->GetFieldID(env, cls, "price", "D");
			jfieldID fid_displayPrice = (*env)->GetFieldID(env, cls, "displayPrice", "Ljava/lang/String;");
			//
			jfieldID fid_title = (*env)->GetFieldID(env, cls, "title", "Ljava/lang/String;");
			jfieldID fid_description = (*env)->GetFieldID(env, cls, "description", "Ljava/lang/String;");
			jfieldID fid_originalJson = (*env)->GetFieldID(env, cls, "originalJson", "Ljava/lang/String;");
			jfieldID fid_displayOriginalPrice = (*env)->GetFieldID(env, cls, "displayOriginalPrice", "Ljava/lang/String;");
			jfieldID fid_originalPrice = (*env)->GetFieldID(env, cls, "originalPrice", "D");
			//
			jfieldID fid_iconUrl = (*env)->GetFieldID(env, cls, "iconUrl", "Ljava/lang/String;");
			jfieldID fid_coinsReward = (*env)->GetFieldID(env, cls, "coinsReward", "I");

			int i = 0;
			for (i = 0; i < objectLength; i++) {
				(*env)->PushLocalFrame(env, 100);

				jobj = (*env)->GetObjectArrayElement(env, originalArray, i);
				cls = (*env)->GetObjectClass(env, jobj);

				jstring tempJstring;

				//
				iapV4ReceiptInfo[i].type = (jlong)(*env)->GetIntField(env, jobj, fid_type);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_additionalInfo);
				iapV4ReceiptInfo[i].additionalInfo = CS_IapV4JstringToChar(env, tempJstring);
				(*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_bypassInfo);
				iapV4ReceiptInfo[i].bypassInfo = CS_IapV4JstringToChar(env, tempJstring);
				(*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_hiveiapReceipt);
				iapV4ReceiptInfo[i].hiveiapReceipt = CS_IapV4JstringToChar(env, tempJstring);
				(*env)->DeleteLocalRef(env, tempJstring);
				// //
                tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_productType);
                iapV4ReceiptInfo[i].productType = CS_IapV4JstringToChar(env, tempJstring);
                (*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_marketPid);
				iapV4ReceiptInfo[i].marketPid = CS_IapV4JstringToChar(env, tempJstring);
				(*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_currency);
				iapV4ReceiptInfo[i].currency = CS_IapV4JstringToChar(env, tempJstring);
				(*env)->DeleteLocalRef(env, tempJstring);

				iapV4ReceiptInfo[i].price = (jlong)(*env)->GetDoubleField(env, jobj, fid_price);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_displayPrice);
				iapV4ReceiptInfo[i].displayPrice = CS_IapV4JstringToChar(env, tempJstring);
				(*env)->DeleteLocalRef(env, tempJstring);
                //
				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_title);
				iapV4ReceiptInfo[i].title = CS_IapV4JstringToChar(env, tempJstring);
				(*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_description);
				iapV4ReceiptInfo[i].description = CS_IapV4JstringToChar(env, tempJstring);
				(*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_originalJson);
				iapV4ReceiptInfo[i].originalJson = CS_IapV4JstringToChar(env, tempJstring);
				(*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_displayOriginalPrice);
				iapV4ReceiptInfo[i].displayOriginalPrice = CS_IapV4JstringToChar(env, tempJstring);
				(*env)->DeleteLocalRef(env, tempJstring);

				iapV4ReceiptInfo[i].originalPrice = (jlong)(*env)->GetDoubleField(env, jobj, fid_originalPrice);
                //
				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_iconUrl);
				iapV4ReceiptInfo[i].iconUrl = CS_IapV4JstringToChar(env, tempJstring);
				(*env)->DeleteLocalRef(env, tempJstring);

                iapV4ReceiptInfo[i].coinsReward = (jint)(*env)->GetIntField(env, jobj, fid_coinsReward);

				(*env)->DeleteLocalRef(env, cls);
				(*env)->DeleteLocalRef(env, jobj);

				(*env)->PopLocalFrame(env, NULL);
			}

			cb(iapv4Result, iapV4ReceiptInfo[0]);

			for (i = 0; i < objectLength; i++) {
				(*env)->PushLocalFrame(env, 100);

				jobj = (*env)->GetObjectArrayElement(env, originalArray, i);

				jstring tempJstring;

				//
				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_additionalInfo);
				(*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ReceiptInfo[i].additionalInfo);
				(*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_bypassInfo);
				(*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ReceiptInfo[i].bypassInfo);
				(*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_hiveiapReceipt);
				(*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ReceiptInfo[i].hiveiapReceipt);
				(*env)->DeleteLocalRef(env, tempJstring);
				// //
                tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_productType);
                (*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ReceiptInfo[i].productType);
                (*env)->DeleteLocalRef(env, tempJstring);

                tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_marketPid);
				(*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ReceiptInfo[i].marketPid);
				(*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_currency);
				(*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ReceiptInfo[i].currency);
				(*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_displayPrice);
				(*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ReceiptInfo[i].displayPrice);
				(*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_title);
				(*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ReceiptInfo[i].title);
				(*env)->DeleteLocalRef(env, tempJstring);
				//
				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_description);
				(*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ReceiptInfo[i].description);
				(*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_originalJson);
				(*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ReceiptInfo[i].originalJson);
				(*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_displayOriginalPrice);
				(*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ReceiptInfo[i].displayOriginalPrice);
				(*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_iconUrl);
				(*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ReceiptInfo[i].iconUrl);
				(*env)->DeleteLocalRef(env, tempJstring);

				(*env)->DeleteLocalRef(env, jobj);

				(*env)->PopLocalFrame(env, NULL);
			}

			(*env)->DeleteLocalRef(env, originalArray);

			free(iapV4ReceiptInfo);
		} else {
			CS_IapV4ReceiptInfo iapV4ReceiptInfo;
			cb(iapv4Result, iapV4ReceiptInfo);
		}
	}

	if(errorMsg != NULL)
		(*env)->ReleaseStringUTFChars(env, str_errorMsg, errorMsg);
}

JNIEXPORT void JNICALL
Java_com_com2us_module_inappv4_InAppV4_csRestoreCB(JNIEnv* env, jobject obj, jlong cbRef, jint code, jint errorCode, jstring str_errorMsg, jobject receiptInfo) {
	ReceiptListInfoCB cb = cbRef;

	char* errorMsg = CS_IapV4JstringToChar(env, str_errorMsg);

    CS_IapV4Result iapv4Result;
    iapv4Result.result = code;
    iapv4Result.errorCode = errorCode;
    iapv4Result.errorMessage = errorMsg;

    if(cb != 0) {
		if(receiptInfo != 0) {
			CS_IapV4ReceiptInfo* iapV4ReceiptInfo;

			int objectLength = (*env)->GetArrayLength(env, (jobjectArray)receiptInfo);
            iapV4ReceiptInfo = (CS_IapV4ReceiptInfo*)malloc( (sizeof(CS_IapV4ReceiptInfo) * (objectLength) ) );
			jobjectArray originalArray = (jobjectArray)receiptInfo;

			//
			jobject jobj = (*env)->GetObjectArrayElement(env, originalArray, 0);
			jclass cls = (*env)->GetObjectClass(env, jobj);

			//
			jfieldID fid_type = (*env)->GetFieldID(env, cls, "type", "I");
			jfieldID fid_additionalInfo = (*env)->GetFieldID(env, cls, "additionalInfo", "Ljava/lang/String;");
			jfieldID fid_bypassInfo = (*env)->GetFieldID(env, cls, "bypassInfo", "Ljava/lang/String;");
			jfieldID fid_hiveiapReceipt = (*env)->GetFieldID(env, cls, "hiveiapReceipt", "Ljava/lang/String;");
			// //
			jfieldID fid_productType = (*env)->GetFieldID(env, cls, "productType", "Ljava/lang/String;");
			jfieldID fid_marketPid = (*env)->GetFieldID(env, cls, "marketPid", "Ljava/lang/String;");
			jfieldID fid_currency = (*env)->GetFieldID(env, cls, "currency", "Ljava/lang/String;");
			jfieldID fid_price = (*env)->GetFieldID(env, cls, "price", "D");
			jfieldID fid_displayPrice = (*env)->GetFieldID(env, cls, "displayPrice", "Ljava/lang/String;");
			//
			jfieldID fid_title = (*env)->GetFieldID(env, cls, "title", "Ljava/lang/String;");
			jfieldID fid_description = (*env)->GetFieldID(env, cls, "description", "Ljava/lang/String;");
			jfieldID fid_originalJson = (*env)->GetFieldID(env, cls, "originalJson", "Ljava/lang/String;");
			jfieldID fid_displayOriginalPrice = (*env)->GetFieldID(env, cls, "displayOriginalPrice", "Ljava/lang/String;");
			jfieldID fid_originalPrice = (*env)->GetFieldID(env, cls, "originalPrice", "D");
			//
			jfieldID fid_iconUrl = (*env)->GetFieldID(env, cls, "iconUrl", "Ljava/lang/String;");
			jfieldID fid_coinsReward = (*env)->GetFieldID(env, cls, "coinsReward", "I");

			int i = 0;
			for (i = 0; i < objectLength; i++) {
				(*env)->PushLocalFrame(env, 100);

				jobj = (*env)->GetObjectArrayElement(env, originalArray, i);
				cls = (*env)->GetObjectClass(env, jobj);

				jstring tempJstring;

				//
				iapV4ReceiptInfo[i].type = (jlong)(*env)->GetIntField(env, jobj, fid_type);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_additionalInfo);
				iapV4ReceiptInfo[i].additionalInfo = CS_IapV4JstringToChar(env, tempJstring);
				(*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_bypassInfo);
				iapV4ReceiptInfo[i].bypassInfo = CS_IapV4JstringToChar(env, tempJstring);
				(*env)->DeleteLocalRef(env, tempJstring);

				tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_hiveiapReceipt);
				iapV4ReceiptInfo[i].hiveiapReceipt = CS_IapV4JstringToChar(env, tempJstring);
				(*env)->DeleteLocalRef(env, tempJstring);
				// //
                tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_productType);
                iapV4ReceiptInfo[i].productType = CS_IapV4JstringToChar(env, tempJstring);
                (*env)->DeleteLocalRef(env, tempJstring);

                tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_marketPid);
                iapV4ReceiptInfo[i].marketPid = CS_IapV4JstringToChar(env, tempJstring);
                (*env)->DeleteLocalRef(env, tempJstring);

                tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_currency);
                iapV4ReceiptInfo[i].currency = CS_IapV4JstringToChar(env, tempJstring);
                (*env)->DeleteLocalRef(env, tempJstring);

                iapV4ReceiptInfo[i].price = (jlong)(*env)->GetDoubleField(env, jobj, fid_price);

                tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_displayPrice);
                iapV4ReceiptInfo[i].displayPrice = CS_IapV4JstringToChar(env, tempJstring);
                (*env)->DeleteLocalRef(env, tempJstring);
				//
                tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_title);
                iapV4ReceiptInfo[i].title = CS_IapV4JstringToChar(env, tempJstring);
                (*env)->DeleteLocalRef(env, tempJstring);

                tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_description);
                iapV4ReceiptInfo[i].description = CS_IapV4JstringToChar(env, tempJstring);
                (*env)->DeleteLocalRef(env, tempJstring);

                tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_originalJson);
                iapV4ReceiptInfo[i].originalJson = CS_IapV4JstringToChar(env, tempJstring);
                (*env)->DeleteLocalRef(env, tempJstring);

                tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_displayOriginalPrice);
                iapV4ReceiptInfo[i].displayOriginalPrice = CS_IapV4JstringToChar(env, tempJstring);
                (*env)->DeleteLocalRef(env, tempJstring);

                iapV4ReceiptInfo[i].originalPrice = (jlong)(*env)->GetDoubleField(env, jobj, fid_originalPrice);
                //
                tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_iconUrl);
                iapV4ReceiptInfo[i].iconUrl = CS_IapV4JstringToChar(env, tempJstring);
                (*env)->DeleteLocalRef(env, tempJstring);

                iapV4ReceiptInfo[i].coinsReward = (jint)(*env)->GetIntField(env, jobj, fid_coinsReward);

				(*env)->DeleteLocalRef(env, cls);
				(*env)->DeleteLocalRef(env, jobj);

				(*env)->PopLocalFrame(env, NULL);
			}

			cb(iapv4Result, objectLength, iapV4ReceiptInfo);

			for (i = 0; i < objectLength; i++) {
				(*env)->PushLocalFrame(env, 100);

				jobj = (*env)->GetObjectArrayElement(env, originalArray, i);

				jstring tempJstring;

				//
                tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_additionalInfo);
                (*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ReceiptInfo[i].additionalInfo);
                (*env)->DeleteLocalRef(env, tempJstring);

                tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_bypassInfo);
                (*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ReceiptInfo[i].bypassInfo);
                (*env)->DeleteLocalRef(env, tempJstring);

                tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_hiveiapReceipt);
                (*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ReceiptInfo[i].hiveiapReceipt);
                (*env)->DeleteLocalRef(env, tempJstring);
                // //
                tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_productType);
                (*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ReceiptInfo[i].productType);
                (*env)->DeleteLocalRef(env, tempJstring);

                tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_marketPid);
                (*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ReceiptInfo[i].marketPid);
                (*env)->DeleteLocalRef(env, tempJstring);

                tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_currency);
                (*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ReceiptInfo[i].currency);
                (*env)->DeleteLocalRef(env, tempJstring);

                tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_displayPrice);
                (*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ReceiptInfo[i].displayPrice);
                (*env)->DeleteLocalRef(env, tempJstring);

                tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_title);
                (*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ReceiptInfo[i].title);
                (*env)->DeleteLocalRef(env, tempJstring);
                //
                tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_description);
                (*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ReceiptInfo[i].description);
                (*env)->DeleteLocalRef(env, tempJstring);

                tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_originalJson);
                (*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ReceiptInfo[i].originalJson);
                (*env)->DeleteLocalRef(env, tempJstring);

                tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_displayOriginalPrice);
                (*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ReceiptInfo[i].displayOriginalPrice);
                (*env)->DeleteLocalRef(env, tempJstring);

                tempJstring = (jstring)(*env)->GetObjectField(env, jobj, fid_iconUrl);
                (*env)->ReleaseStringUTFChars(env, tempJstring, iapV4ReceiptInfo[i].iconUrl);
                (*env)->DeleteLocalRef(env, tempJstring);

				(*env)->DeleteLocalRef(env, jobj);

				(*env)->PopLocalFrame(env, NULL);
			}

			(*env)->DeleteLocalRef(env, originalArray);

			free(iapV4ReceiptInfo);
		} else {
            CS_IapV4ReceiptInfo* iapV4ReceiptInfo = NULL;
            cb(iapv4Result, 0, iapV4ReceiptInfo);
		}
	}

	if(errorMsg != NULL)
		(*env)->ReleaseStringUTFChars(env, str_errorMsg, errorMsg);
}

JNIEXPORT void JNICALL
Java_com_com2us_module_inappv4_InAppV4_csTransactionFinishCB(JNIEnv* env, jobject obj, jlong cbRef, jint code, jint errorCode, jstring str_errorMsg, jstring str_marketPid) {
	TransactionCB cb = cbRef;

	char* errorMsg = CS_IapV4JstringToChar(env, str_errorMsg);
	char* marketPid = CS_IapV4JstringToChar(env, str_marketPid);

    CS_IapV4Result iapv4Result;
    iapv4Result.result = code;
    iapv4Result.errorCode = errorCode;
    iapv4Result.errorMessage = errorMsg;

    if(cb != 0) {
		cb(iapv4Result, marketPid);
	}

	if(errorMsg != NULL)
		(*env)->ReleaseStringUTFChars(env, str_errorMsg, errorMsg);
	if(marketPid != NULL)
		(*env)->ReleaseStringUTFChars(env, str_marketPid, marketPid);
}

JNIEXPORT void JNICALL
Java_com_com2us_module_inappv4_InAppV4_csGetBalanceInfoCB(JNIEnv* env, jobject obj, jlong cbRef, jint code, jint errorCode, jstring str_errorMsg, jint balance) {
	BalanceCB cb = cbRef;

	char* errorMsg = CS_IapV4JstringToChar(env, str_errorMsg);

    CS_IapV4Result iapv4Result;
    iapv4Result.result = code;
    iapv4Result.errorCode = errorCode;
    iapv4Result.errorMessage = errorMsg;

    if(cb != 0) {
		cb(iapv4Result, balance);
	}

	if(errorMsg != NULL)
		(*env)->ReleaseStringUTFChars(env, str_errorMsg, errorMsg);
}

JNIEXPORT void JNICALL
Java_com_com2us_module_inappv4_InAppV4_csCheckPromotePurchaseCB(JNIEnv* env, jobject obj, jlong cbRef, jint code, jint errorCode, jstring str_errorMsg, jstring str_marketPid) {
	CheckPromotePurchaseCB cb = cbRef;

	char* errorMsg = CS_IapV4JstringToChar(env, str_errorMsg);
	char* marketPid = NULL;
    if(str_marketPid != NULL) {
        marketPid = CS_IapV4JstringToChar(env, str_marketPid);
    }
    CS_IapV4Result iapv4Result;
    iapv4Result.result = code;
    iapv4Result.errorCode = errorCode;
    iapv4Result.errorMessage = errorMsg;

    if(cb != 0) {
		cb(iapv4Result, marketPid);
	}

	if(errorMsg != NULL)
		(*env)->ReleaseStringUTFChars(env, str_errorMsg, errorMsg);
	if(marketPid != NULL)
		(*env)->ReleaseStringUTFChars(env, str_marketPid, marketPid);
}
#endif
