/*
 * JNISample.cpp
 *
 *  Created on: 2014. 12. 22.
 *      Author: pnpsinki
 */
#include "JNISample.h"
#include "platform/android/jni/JniHelper.h"
#include "cocos2d.h"

USING_NS_CC;

#ifdef __cplusplus
extern "C" {
#endif

void getDeviceModel(char* _name)
{
	JniMethodInfo t;
	if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "getDeviceModel", "()[B"))
	{
		jbyteArray array;
		array = (jbyteArray)t.env->CallStaticObjectMethod(t.classID, t.methodID);
		jint len = t.env->GetArrayLength(array);
		jbyte* data = t.env->GetByteArrayElements(array, NULL);
		if(data != NULL)
		{
			memcpy(_name, data, len);
			t.env->ReleaseByteArrayElements(array, data, JNI_ABORT);
		}
	}
}

void getOSVersion(char* _name)
{
	JniMethodInfo t;
	if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "getOSVersion", "()[B"))
	{
		jbyteArray array;
		array = (jbyteArray)t.env->CallStaticObjectMethod(t.classID, t.methodID);
		jint len = t.env->GetArrayLength(array);
		jbyte* data = t.env->GetByteArrayElements(array, NULL);
		if(data != NULL)
		{
			memcpy(_name, data, len);
			t.env->ReleaseByteArrayElements(array, data, JNI_ABORT);
		}
	}
}

void showDialogMsg(const char* _name)
{
	log("showDialogMsg");
	JniMethodInfo t;
	jstring result;
	if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "showDialogMsg", "(Ljava/lang/String;)V"))
	{
		result = t.env->NewStringUTF(_name);
		t.env->CallStaticVoidMethod(t.classID, t.methodID, result);
	}
}

void showToastMsg(const char* _name)
{
	log("showToastMsg");
	JniMethodInfo t;
	jstring result;
	if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "showToastMsg", "(Ljava/lang/String;)V"))
	{
		result = t.env->NewStringUTF(_name);
		t.env->CallStaticVoidMethod(t.classID, t.methodID, result);
	}
}

const char* getCurrentTime() {
	log("getCurrentTime");
	JniMethodInfo t;
	jstring result;
	if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "getCurrentTime", "()Ljava/lang/String;"))
	{
		result = (jstring) t.env->CallStaticObjectMethod(t.classID, t.methodID);
		std::string resultStd = JniHelper::jstring2string(result);

		return resultStd.c_str();
	}
	return "";
}

const char* getAppVersion() {
	log("getAppVersion");
	JniMethodInfo t;
	jstring result;
	if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "getAppVersion", "()Ljava/lang/String;"))
	{
		result = (jstring) t.env->CallStaticObjectMethod(t.classID, t.methodID);
		std::string resultStd = JniHelper::jstring2string(result);

		return resultStd.c_str();
	}
	return "";
}

const char* getHiveSdkVersion() {
	log("getHiveSdkVersion");
	JniMethodInfo t;
	jstring result;
	if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "getHiveSdkVersion", "()Ljava/lang/String;"))
	{
		result = (jstring) t.env->CallStaticObjectMethod(t.classID, t.methodID);
		std::string resultStd = JniHelper::jstring2string(result);

		return resultStd.c_str();
	}
	return "";
}

const char* getHiveCountryCode() {
	log("getHiveCountryCode");
	JniMethodInfo t;
	jstring result;
	if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "getHiveCountryCode", "()Ljava/lang/String;"))
	{
		result = (jstring) t.env->CallStaticObjectMethod(t.classID, t.methodID);
		std::string resultStd = JniHelper::jstring2string(result);

		return resultStd.c_str();
	}
	return "";
}

void postBoxInit(const char* data)
{
	log("postBoxInit");
	JniMethodInfo t;
	jstring result;

	if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "postBoxInit", "(Ljava/lang/String;)V"))
	{
		result = t.env->NewStringUTF(data);
		t.env->CallStaticVoidMethod(t.classID, t.methodID, result);
	}
}

void PostBoxRequest(const char* _name)
{
	log("PostBoxRequest 01");
	JniMethodInfo t;
	jstring result;
	if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/PostBoxTest", "Request", "(Ljava/lang/String;)Z"))
	{
		log("PostBoxRequest 02");
		result = t.env->NewStringUTF(_name);
		t.env->CallStaticBooleanMethod(t.classID, t.methodID, result);
		log("PostBoxRequest 03");
	}
	log("PostBoxRequest 04");
}

char* getBuildTime()
{
	log("getBuildTime 01");

	JniMethodInfo t;

	if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "getSampleBuildTime", "()Ljava/lang/String;"))
	{
		log("getBuildTime 02");
		t.env->CallStaticObjectMethod(t.classID, t.methodID);
		log("getBuildTime 03");
	}
}

char* getVersionName()
{
	log("getVersionName 01");

	JniMethodInfo t;

	if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "getSampleVersionName", "()Ljava/lang/String;"))
	{
		log("getVersionName 02");
		t.env->CallStaticObjectMethod(t.classID, t.methodID);
		log("getVersionName 03");
	}
}

char* getVersionCode()
{
	log("getVersionCode 01");

	JniMethodInfo t;

	if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "getSampleVersionCode", "()Ljava/lang/String;"))
	{
		log("getVersionCode 02");
		t.env->CallStaticObjectMethod(t.classID, t.methodID);
		log("getVersionCode 03");
	}
}

void activeuserInit(const char* _empty)
{
    log("activeuserInit");
    JniMethodInfo t;
    jstring result;
    if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "activeuserInit", "(Ljava/lang/String;)V"))
    {
        result = t.env->NewStringUTF(_empty);
        t.env->CallStaticVoidMethod(t.classID, t.methodID, result);
    }
}

void inappv4Init(const char* _empty)
{
    log("inappv4Init");
    JniMethodInfo t;
    jstring result;
    if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "inappv4Init", "(Ljava/lang/String;)V"))
    {
        result = t.env->NewStringUTF(_empty);
        t.env->CallStaticVoidMethod(t.classID, t.methodID, result);
    }
}

void hivepromotionInit(const char* _empty)
{
    log("hivepromotionInit");
    JniMethodInfo t;
    jstring result;
    if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "hivepromotionInit", "(Ljava/lang/String;)V"))
    {
        result = t.env->NewStringUTF(_empty);
        t.env->CallStaticVoidMethod(t.classID, t.methodID, result);
    }
}

/**
 * MERCURY init
 * @param _empty
 */
void mercuryInit(const char* _empty)
{
	log("mercuryInit");
	JniMethodInfo t;
	jstring result;
	if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "mercuryInit", "(Ljava/lang/String;)V"))
	{
		result = t.env->NewStringUTF(_empty);
		t.env->CallStaticVoidMethod(t.classID, t.methodID, result);
	}
}

/**
 * OFFERWALL init
 * @param _empty
 */
void offerwallInit(const char* _empty)
{
	log("offerwallInit");
	JniMethodInfo t;
	jstring result;
	if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "offerwallInit", "(Ljava/lang/String;)V"))
	{
		result = t.env->NewStringUTF(_empty);
		t.env->CallStaticVoidMethod(t.classID, t.methodID, result);
	}
}

/**
  * PUSH init
  * @param _empty
  */
void pushInit(const char* _empty)
{
	log("pushInit");
	JniMethodInfo t;
	jstring result;
	if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "pushInit", "(Ljava/lang/String;)V"))
	{
		result = t.env->NewStringUTF(_empty);
		t.env->CallStaticVoidMethod(t.classID, t.methodID, result);
	}
}

/**
  * INAPP init
  * @param _empty
  */
void inappInit(const char* _empty)
{
	log("inappInit");
	JniMethodInfo t;
	jstring result;
	if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "inappInit", "(Ljava/lang/String;)V"))
	{
		result = t.env->NewStringUTF(_empty);
		t.env->CallStaticVoidMethod(t.classID, t.methodID, result);
	}
}

void inappSetLog(const char* _empty)
{
	log("inappSetLog");
	JniMethodInfo t;
	jstring result;
	if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "inappSetLog", "(Ljava/lang/String;)V"))
	{
		result = t.env->NewStringUTF(_empty);
		t.env->CallStaticVoidMethod(t.classID, t.methodID, result);
	}
}

/**
  * PEPPERMINT init
  * @param _empty
  */
void peppermintInit(const char* _empty)
{
	log("peppermintInit");
	JniMethodInfo t;
	jstring result;
	if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "peppermintInit", "(Ljava/lang/String;)V"))
	{
		result = t.env->NewStringUTF(_empty);
		t.env->CallStaticVoidMethod(t.classID, t.methodID, result);
	}
}

void requestNetowrkMercuryUA(const char* _type)
{
	log("requestNetowrkMercuryUA");
	JniMethodInfo t;
	jstring result;
	if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "requestNetowrkMercuryUA", "(Ljava/lang/String;)V"))
	{
		result = t.env->NewStringUTF(_type);
		t.env->CallStaticVoidMethod(t.classID, t.methodID, result);
	}
}

std::string getUaToken()
{
	log("getUaToken");

	JniMethodInfo t;
	jstring result;
	if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "getUaToken", "()Ljava/lang/String;"))
	{
//        result = t.env->NewStringUTF(_type);
		result = (jstring) t.env->CallStaticObjectMethod(t.classID, t.methodID);
		std::string resultStd = JniHelper::jstring2string(result);

		return resultStd;
	}
	std::string returnValue("");
	return returnValue;
}

void setUIDfromCocos(const char* _uid)
{
	log("setUIDfromCocos");

	JniMethodInfo t;
	jstring result;
	if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "setUIDfromCocos", "(Ljava/lang/String;)V"))
	{
		result = t.env->NewStringUTF(_uid);
		t.env->CallStaticVoidMethod(t.classID, t.methodID, result);
	}
}

// get 3rd party lib version
const char* getAndroidFacebookVersion() {
	JniMethodInfo t;
	jstring result;
	if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "getAndroidFacebookVer", "()Ljava/lang/String;"))
	{
		result = (jstring) t.env->CallStaticObjectMethod(t.classID, t.methodID);
		std::string resultStd = JniHelper::jstring2string(result);

		return resultStd.c_str();
	}
	return "";
}

const char* getAndroidSingularVersion() {
	JniMethodInfo t;
	jstring result;
	if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "getAndroidSingularVer", "()Ljava/lang/String;"))
	{
		result = (jstring) t.env->CallStaticObjectMethod(t.classID, t.methodID);
		std::string resultStd = JniHelper::jstring2string(result);

		return resultStd.c_str();
	}
	return "";
}

const char* getAndroidAdjustVersion() {
	JniMethodInfo t;
	jstring result;
	if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "getAndroidAdjustVer", "()Ljava/lang/String;"))
	{
		result = (jstring) t.env->CallStaticObjectMethod(t.classID, t.methodID);
		std::string resultStd = JniHelper::jstring2string(result);

		return resultStd.c_str();
	}
	return "";
}

const char* getAndroidAppsFlyerVersion() {
	JniMethodInfo t;
	jstring result;
	if(JniHelper::getStaticMethodInfo(t, "org/cocos2dx/cpp/AppActivity", "getAndroidAppsFlyerVer", "()Ljava/lang/String;"))
	{
		result = (jstring) t.env->CallStaticObjectMethod(t.classID, t.methodID);
		std::string resultStd = JniHelper::jstring2string(result);

		return resultStd.c_str();
	}
	return "";
}

#ifdef __cplusplus
}
#endif



