#ifdef _WIN32 //|| _WIN64
#define USE_HIVE_EMPTY_SYMBOLS 1
#elif defined(__APPLE__)
//    #include "TargetConditionals.h"
	#if TARGET_OS_MAC && (PLATFORM_ANDROID && !PLATFORM_IOS)
         #define USE_HIVE_EMPTY_SYMBOLS 1
    #endif
    #if PLATFORM_MAC
        #define USE_HIVE_EMPTY_SYMBOLS 1
    #endif
#endif

#if defined(USE_HIVE_EMPTY_SYMBOLS)

#include "HIVE_CppPlugin.h"
#include "HIVE_Analytics.h"
#include "HIVE_Auth.h"
#include "HIVE_Configuration.h"
#include "HIVE_IAP.h"
#include "HIVE_JniHelper.h"
#include "HIVE_Logger.h"
#include "HIVE_PlatformHelper.h"
#include "HIVE_Promotion.h"
#include "HIVE_Push.h"
#include "HIVE_ResultAPI.h"
#include "HIVE_SocialFacebook.h"
#include "HIVE_SocialGoogle.h"
#include "HIVE_SocialHive.h"
#include "picojson.h"
#include <string>
#include "HIVE_AuthV4.h"
#include "HIVE_IAPV4.h"
#include "HIVE_ProviderApple.h"
#include "HIVE_ProviderGoogle.h"
#include "HIVE_PermissionView.h"
#include "HIVE_SocialV4.h"

NS_HIVE_BEGIN

#define HIVE_EMPTY_CONSTRUCTOR(cls) cls::cls() {}
#define HIVE_EMPTY_CONSTRUCTOR_PARAM(cls,clsparam) cls::clsparam {}
#define HIVE_EMPTY_DESTRUCTOR(cls) cls::~cls
#define HIVE_EMPTY_IMPL_VOID(cls,func) void cls::func {}
#define HIVE_EMPTY_IMPL_DEFAULT(cls,func,ty) ty cls::func { return static_cast<ty>(0); }
#define HIVE_EMPTY_IMPL_CLASS(cls,func,ty) ty cls::func { ty t; return t; }
#define HIVE_EMPTY_IMPL_NULLABLE(cls,func,ty) ty cls::func { return static_cast<ty>(nullptr); }
#define HIVE_EMPTY_IMPL_STDSTRING(cls,func) std::string cls::func { return ""; }

//Analytics
HIVE_EMPTY_IMPL_DEFAULT(Analytics,sendAnalyticsLog(picojson::object & logData), bool)
HIVE_EMPTY_IMPL_VOID(Analytics,setEnableTracker(TrackingType trackingType, bool isEnable))
HIVE_EMPTY_IMPL_VOID(Analytics,sendEvent(std::string eventName))
HIVE_EMPTY_IMPL_VOID(Analytics,executeEngine(picojson::value jsonParam))

//Auth
HIVE_EMPTY_IMPL_VOID(Auth,initialize(onAuthInitialize listener))
HIVE_EMPTY_IMPL_DEFAULT(Auth,getLoginType(),LoginType)
HIVE_EMPTY_IMPL_VOID(Auth,login(LoginType loginType, onAuthLogin listener))
HIVE_EMPTY_IMPL_VOID(Auth,showLoginSelection(picojson::object currentData, picojson::object selectData, onAuthLogin listener))
HIVE_EMPTY_IMPL_VOID(Auth,bindLogin(std::string selectedVid, onAuthLogin listener))
HIVE_EMPTY_IMPL_VOID(Auth,logout(onAuthLogout listener))
HIVE_EMPTY_IMPL_CLASS(Auth,getAccount(),Account)
HIVE_EMPTY_IMPL_VOID(Auth,showTerms(onAuthShowTerms listener))
HIVE_EMPTY_IMPL_VOID(Auth,checkMaintenance(bool isShow, onAuthMaintenance listener))
HIVE_EMPTY_IMPL_VOID(Auth,showAdultConfirm(onAuthAdultConfirm listener))
HIVE_EMPTY_IMPL_VOID(Auth,reset())
HIVE_EMPTY_IMPL_VOID(Auth,executeEngine(picojson::value jsonParam))
HIVE_EMPTY_IMPL_VOID(Auth,requestPermissionViewData(onAuthRequestPermissionViewData listener))
HIVE_EMPTY_IMPL_VOID(Auth,showDeviceManagement(onShowDeviceManagement listener))

//Account
HIVE_EMPTY_CONSTRUCTOR(Account)
HIVE_EMPTY_CONSTRUCTOR_PARAM(Account,Account(picojson::value jsonParam))
HIVE_EMPTY_IMPL_CLASS(Account,toJson() const,picojson::object)
HIVE_EMPTY_IMPL_STDSTRING(Account,toString() const)

//AuthInitResult
HIVE_EMPTY_CONSTRUCTOR(AuthInitResult)
HIVE_EMPTY_CONSTRUCTOR_PARAM(AuthInitResult,AuthInitResult(picojson::value jsonParam))
HIVE_EMPTY_IMPL_CLASS(AuthInitResult,toJson() const,picojson::object)
HIVE_EMPTY_IMPL_STDSTRING(AuthInitResult,toString() const)

//AuthMaintenanceInfo
HIVE_EMPTY_CONSTRUCTOR(AuthMaintenanceInfo)
HIVE_EMPTY_CONSTRUCTOR_PARAM(AuthMaintenanceInfo,AuthMaintenanceInfo(picojson::value jsonParam))
HIVE_EMPTY_IMPL_CLASS(AuthMaintenanceInfo,toJson() const,picojson::object)
HIVE_EMPTY_IMPL_STDSTRING(AuthMaintenanceInfo,toString() const)

//configuration
HIVE_EMPTY_IMPL_CLASS(Configuration,getPermissionViewData(HIVELanguage language),PermissionViewData)
HIVE_EMPTY_IMPL_VOID(Configuration,setHivePermissionViewOn(bool isOn))
HIVE_EMPTY_IMPL_VOID(Configuration,setAgeGateU13(bool ageGateU13))
HIVE_EMPTY_IMPL_STDSTRING(Configuration,getConfiguration())
HIVE_EMPTY_IMPL_STDSTRING(Configuration,getHiveSDKVersion())
HIVE_EMPTY_IMPL_STDSTRING(Configuration,getReferenceSDKVersion())
HIVE_EMPTY_IMPL_STDSTRING(Configuration,getAppId())
HIVE_EMPTY_IMPL_VOID(Configuration,setAppId(std::string appId))
HIVE_EMPTY_IMPL_DEFAULT(Configuration,getZone(),ZoneType)
HIVE_EMPTY_IMPL_VOID(Configuration,setZone(ZoneType zone))
HIVE_EMPTY_IMPL_STDSTRING(Configuration,getServerId())
HIVE_EMPTY_IMPL_VOID(Configuration,setServerId(std::string serverId))
HIVE_EMPTY_IMPL_VOID(Configuration,setGameLanguage(std::string language))
HIVE_EMPTY_IMPL_DEFAULT(Configuration,getUseLog(),bool)
HIVE_EMPTY_IMPL_VOID(Configuration,setUseLog(bool useLog))
HIVE_EMPTY_IMPL_STDSTRING(Configuration,getCompany())
HIVE_EMPTY_IMPL_VOID(Configuration,setCompany(std::string company))
HIVE_EMPTY_IMPL_STDSTRING(Configuration, getCompanyIndex())
HIVE_EMPTY_IMPL_VOID(Configuration, setCompanyIndex(int companyIndex))
HIVE_EMPTY_IMPL_STDSTRING(Configuration,getChannel())
HIVE_EMPTY_IMPL_VOID(Configuration,setChannel(std::string channel))
HIVE_EMPTY_IMPL_DEFAULT(Configuration,getHttpConnectTimeout(),int)
HIVE_EMPTY_IMPL_VOID(Configuration,setHttpConnectTimeout(int httpConnectTimeout))
HIVE_EMPTY_IMPL_DEFAULT(Configuration,getHttpReadTimeout(),int)
HIVE_EMPTY_IMPL_VOID(Configuration,setHttpReadTimeout(int httpReadTimeout))
HIVE_EMPTY_IMPL_DEFAULT(Configuration,getMaxGameLogSize(),int)
HIVE_EMPTY_IMPL_VOID(Configuration,setMaxGameLogSize(int maxGameLogSize))
HIVE_EMPTY_IMPL_STDSTRING(Configuration,getMarket())
HIVE_EMPTY_IMPL_VOID(Configuration,setMarket(std::string market))
HIVE_EMPTY_IMPL_VOID(Configuration,getMetaData(std::string key, bool forceReload, onGetMetaData listener))
HIVE_EMPTY_IMPL_VOID(Configuration,executeEngine(picojson::value jsonParam))

//cpp
HIVE_EMPTY_IMPL_CLASS(HiveCppPlugin,createParam(std::string className, std::string methodName),picojson::object)
HIVE_EMPTY_IMPL_NULLABLE(HiveCppPlugin,callNative(picojson::object jsonParam),picojson::value)
HIVE_EMPTY_IMPL_VOID(HiveCppPlugin,callEngine(std::string jsonParamString))

//IAP
HIVE_EMPTY_IMPL_VOID(IAP,initialize(onIAPMarketInfo listener))
HIVE_EMPTY_IMPL_VOID(IAP,getShopInfo(std::string locationCode, onIAPShopInfo listener))
HIVE_EMPTY_IMPL_VOID(IAP,purchase(std::string gamePid, std::string additionalInfo, onIAPPurchaseReceipt listener))
HIVE_EMPTY_IMPL_VOID(IAP,showMarketSelection(onIAPMarketInfo listener))
HIVE_EMPTY_IMPL_VOID(IAP,getBalanceInfo(onIAPBalanceInfo listener))
HIVE_EMPTY_IMPL_VOID(IAP,showCharge(onIAPBalanceInfo listener))
HIVE_EMPTY_IMPL_VOID(IAP,executeEngine(picojson::value jsonParam))
HIVE_EMPTY_IMPL_VOID(IAP,checkPromotePurchase(onCheckPromotePurchase listener))
HIVE_EMPTY_IMPL_VOID(IAP,restoreReceipt(onIAPRestoreReceipt listener))

//IAPShop
HIVE_EMPTY_CONSTRUCTOR(IAPShop)
HIVE_EMPTY_CONSTRUCTOR_PARAM(IAPShop,IAPShop(picojson::value jsonParam))
HIVE_EMPTY_IMPL_DEFAULT(IAPShop,parse(picojson::value jsonParam),bool)
HIVE_EMPTY_IMPL_CLASS(IAPShop,toJson() const,picojson::object)
HIVE_EMPTY_IMPL_STDSTRING(IAPShop,toString() const)


//IAPShop
HIVE_EMPTY_CONSTRUCTOR(IAPProduct)
HIVE_EMPTY_CONSTRUCTOR_PARAM(IAPProduct,IAPProduct(picojson::value jsonParam))
HIVE_EMPTY_IMPL_DEFAULT(IAPProduct,parse(picojson::value jsonParam),bool)
HIVE_EMPTY_IMPL_CLASS(IAPProduct,toJson() const,picojson::object)
HIVE_EMPTY_IMPL_STDSTRING(IAPProduct,toString() const)

//Logger
HIVE_EMPTY_IMPL_DEFAULT(Logger,isActivateLogging(),bool)
HIVE_EMPTY_IMPL_VOID(Logger,setLoggerListener(onLogger listener))
HIVE_EMPTY_IMPL_VOID(Logger,log(const char * format, ...))

//PlatformHelper
HIVE_EMPTY_IMPL_VOID(PlatformHelper,executeEngine(picojson::value jsonParam))
HIVE_EMPTY_IMPL_VOID(PlatformHelper,requestUserPermissions(std::vector<std::string> requests, onRequestUserPermissionsHandler handler))
HIVE_EMPTY_IMPL_VOID(PlatformHelper,share(PlatformShare platformShare, onHIVEPlatformHelperShareHandler handler))

//PlatformShare
HIVE_EMPTY_CONSTRUCTOR(PlatformShare)
HIVE_EMPTY_IMPL_DEFAULT(PlatformShare,getShareTypeInt(),int);
HIVE_EMPTY_IMPL_VOID(PlatformShare,setShareType(PlatformShareType argShareType))
HIVE_EMPTY_IMPL_CLASS(PlatformShare,getSubject(),std::string)
HIVE_EMPTY_IMPL_VOID(PlatformShare,setSubject(std::string argSubject))
HIVE_EMPTY_IMPL_CLASS(PlatformShare,getText(),std::string)
HIVE_EMPTY_IMPL_VOID(PlatformShare,setText(std::string argText))
HIVE_EMPTY_IMPL_CLASS(PlatformShare,getMedia(),std::vector<std::string>)
HIVE_EMPTY_IMPL_VOID(PlatformShare,setMedia(std::vector<std::string> argPaths))
PlatformShare::~PlatformShare() {}

//Promotion
HIVE_EMPTY_IMPL_VOID(Promotion,showPromotion(PromotionType promotionType, bool isForced, onPromotionView listener))
HIVE_EMPTY_IMPL_VOID(Promotion,showCustomContents(PromotionCustomType customType, std::string contentsKey, onPromotionView listener))
HIVE_EMPTY_IMPL_DEFAULT(Promotion,getOfferwallState(),OfferwallState)
HIVE_EMPTY_IMPL_VOID(Promotion,showOfferwall(onPromotionView listener))
HIVE_EMPTY_IMPL_VOID(Promotion,showReview(onPromotionView listener))
HIVE_EMPTY_IMPL_VOID(Promotion,showExit(onPromotionView listener))
HIVE_EMPTY_IMPL_VOID(Promotion,getViewInfo(PromotionCustomType customType, std::string contentsKey, onPromotionViewInfo listener))
HIVE_EMPTY_IMPL_VOID(Promotion,getBadgeInfo(onPromotionBadgeInfo listener))
HIVE_EMPTY_IMPL_VOID(Promotion,getAppInvitationData(onAppInvitationData listener))
HIVE_EMPTY_IMPL_VOID(Promotion,setAdditionalInfo(std::string additionalInfo))
HIVE_EMPTY_IMPL_VOID(Promotion,showNativeReview(onPromotionView listener))
HIVE_EMPTY_IMPL_VOID(Promotion,executeEngine(picojson::value jsonParam))
HIVE_EMPTY_IMPL_CLASS(Promotion,setEngagementReady(bool isReady),ResultAPI)
HIVE_EMPTY_IMPL_VOID(Promotion,setEngagementHandler(onEngagement engagementHandler))
HIVE_EMPTY_IMPL_VOID(Promotion,showUAShare(std::string inviteMessage, std::string inviteLink, onPromotionUAShare engagementHandler))
HIVE_EMPTY_IMPL_VOID(Promotion,getBannerInfo(PromotionCampaignType campaignType, PromotionBannerType bannerType, onPromotionBannerInfo linstener))
HIVE_EMPTY_IMPL_VOID(Promotion,getBannerInfoString(std::string campaignString, std::string bannerString, onPromotionBannerInfo linstener))

//PromotionViewInfo
HIVE_EMPTY_CONSTRUCTOR(PromotionViewInfo)
HIVE_EMPTY_IMPL_DEFAULT(PromotionViewInfo,parse(picojson::value jsonParam),bool)
HIVE_EMPTY_IMPL_CLASS(PromotionViewInfo,toJson() const,picojson::object)
HIVE_EMPTY_IMPL_STDSTRING(PromotionViewInfo,toString() const)

//PromotionBadgeInfo
HIVE_EMPTY_CONSTRUCTOR(PromotionBadgeInfo)
HIVE_EMPTY_IMPL_DEFAULT(PromotionBadgeInfo,parse(picojson::value jsonParam),bool)
HIVE_EMPTY_IMPL_CLASS(PromotionBadgeInfo,toJson() const,picojson::object)
HIVE_EMPTY_IMPL_STDSTRING(PromotionBadgeInfo,toString() const)

HIVE_EMPTY_CONSTRUCTOR(PromotionBannerInfo)
HIVE_EMPTY_IMPL_DEFAULT(PromotionBannerInfo,parse(picojson::value jsonParam),bool)
HIVE_EMPTY_IMPL_CLASS(PromotionBannerInfo,toJson() const,picojson::object)
HIVE_EMPTY_IMPL_STDSTRING(PromotionBannerInfo,toString() const)
HIVE_EMPTY_IMPL_VOID(Promotion,updatePromotionData())

//OfferwallReward
//HIVE_EMPTY_CONSTRUCTOR(OfferwallReward)
//HIVE_EMPTY_IMPL_DEFAULT(OfferwallReward,parse(picojson::value jsonParam),bool)
//HIVE_EMPTY_IMPL_CLASS(OfferwallReward,toJson() const,picojson::object)
//HIVE_EMPTY_IMPL_STDSTRING(OfferwallReward,toString() const)

//AppInvitationData
HIVE_EMPTY_CONSTRUCTOR(AppInvitationData)
HIVE_EMPTY_IMPL_DEFAULT(AppInvitationData,parse(picojson::value jsonParam),bool)
HIVE_EMPTY_IMPL_CLASS(AppInvitationData,toJson() const,picojson::object)
HIVE_EMPTY_IMPL_STDSTRING(AppInvitationData,toString() const)

//AppInvitationCampaign
HIVE_EMPTY_CONSTRUCTOR(AppInvitationCampaign)
HIVE_EMPTY_IMPL_DEFAULT(AppInvitationCampaign,parse(picojson::value jsonParam),bool)
HIVE_EMPTY_IMPL_CLASS(AppInvitationCampaign,toJson() const,picojson::object)
HIVE_EMPTY_IMPL_STDSTRING(AppInvitationCampaign,toString() const)

//AppInvitationCampaign
HIVE_EMPTY_CONSTRUCTOR(AppInvitationCampaignStage)
HIVE_EMPTY_IMPL_DEFAULT(AppInvitationCampaignStage,parse(picojson::value jsonParam),bool)

//Push
HIVE_EMPTY_IMPL_VOID(Push,getRemotePush(onRemotePush listener))
HIVE_EMPTY_IMPL_VOID(Push,setRemotePush(RemotePush remotePush, onRemotePush listener))
HIVE_EMPTY_IMPL_VOID(Push,registerLocalPush(LocalPush localPush, onLocalPush listener))
HIVE_EMPTY_IMPL_VOID(Push,unregisterLocalPush(int noticeId))
HIVE_EMPTY_IMPL_VOID(Push,getForegroundPush(onPushSetting listener))
HIVE_EMPTY_IMPL_VOID(Push,setForegroundPush(PushSetting setting, onPushSetting listener))
HIVE_EMPTY_IMPL_VOID(Push,executeEngine(picojson::value jsonParam))

//RemotePush
HIVE_EMPTY_CONSTRUCTOR(RemotePush)
HIVE_EMPTY_CONSTRUCTOR_PARAM(RemotePush,RemotePush(bool isAgreeNotice, bool isAgreeNight))
HIVE_EMPTY_CONSTRUCTOR_PARAM(RemotePush,RemotePush(picojson::value jsonParam))
HIVE_EMPTY_IMPL_CLASS(RemotePush,toJson() const,picojson::object)
HIVE_EMPTY_IMPL_STDSTRING(RemotePush,toString() const)

//LocalPush
HIVE_EMPTY_CONSTRUCTOR(LocalPush)
HIVE_EMPTY_CONSTRUCTOR_PARAM(LocalPush,LocalPush(int noticeID, std::string title, std::string msg, long after))
HIVE_EMPTY_CONSTRUCTOR_PARAM(LocalPush,LocalPush(picojson::value jsonParam))
HIVE_EMPTY_IMPL_CLASS(LocalPush,toJson() const,picojson::object)
HIVE_EMPTY_IMPL_STDSTRING(LocalPush,toString() const)

//PushSetting
HIVE_EMPTY_CONSTRUCTOR(PushSetting)
HIVE_EMPTY_CONSTRUCTOR_PARAM(PushSetting,PushSetting(bool useForegroundRemotePush, bool useForegroundLocalPush))
HIVE_EMPTY_CONSTRUCTOR_PARAM(PushSetting,PushSetting(picojson::value jsonParam))
HIVE_EMPTY_IMPL_CLASS(PushSetting,toJson() const,picojson::object)
HIVE_EMPTY_IMPL_STDSTRING(PushSetting,toString() const)

//ResultAPI
HIVE_EMPTY_CONSTRUCTOR(ResultAPI)
HIVE_EMPTY_CONSTRUCTOR_PARAM(ResultAPI,ResultAPI(int errorCode, std::string errorMessage))
HIVE_EMPTY_CONSTRUCTOR_PARAM(ResultAPI,ResultAPI(picojson::value jsonParam))
HIVE_EMPTY_IMPL_DEFAULT(ResultAPI,isSuccess() const,bool)
HIVE_EMPTY_IMPL_CLASS(ResultAPI,toJson() const,picojson::object)
HIVE_EMPTY_IMPL_STDSTRING(ResultAPI,toString() const)
HIVE_EMPTY_IMPL_DEFAULT(ResultAPI,needExit() const,bool)

//SocialFacebook
HIVE_EMPTY_IMPL_VOID(SocialFacebook, getMyProfile(onProfileFacebook listener))
HIVE_EMPTY_IMPL_VOID(SocialFacebook, getFriends(onProfileFacebook listener))
HIVE_EMPTY_IMPL_VOID(SocialFacebook, sendMessageFacebook(FacebookMessage messageContents, onSendMessageFacebook listener))
HIVE_EMPTY_IMPL_VOID(SocialFacebook, showInvitationDialog(FacebookMessage inviteContents, onShowInvitationDialogFacebook listener))
HIVE_EMPTY_IMPL_DEFAULT(SocialFacebook,isLogin(),bool)
HIVE_EMPTY_IMPL_VOID(SocialFacebook, executeEngine(picojson::value jsonParam))
HIVE_EMPTY_IMPL_VOID(SocialFacebook, postFacebookWithContentURL(std::string contentURL, onPostFacebook listener))

//ProfileFacebook
HIVE_EMPTY_CONSTRUCTOR(ProfileFacebook)
HIVE_EMPTY_CONSTRUCTOR_PARAM(ProfileFacebook,ProfileFacebook(picojson::value jsonParam))
HIVE_EMPTY_IMPL_CLASS(ProfileFacebook,toJson() const,picojson::object)
HIVE_EMPTY_IMPL_STDSTRING(ProfileFacebook,toString() const)

//FacebookMessage
HIVE_EMPTY_CONSTRUCTOR(FacebookMessage)
HIVE_EMPTY_CONSTRUCTOR_PARAM(FacebookMessage,FacebookMessage(std::vector<std::string> recipients, std::string dialogTitle, std::string message, std::string data))
HIVE_EMPTY_CONSTRUCTOR_PARAM(FacebookMessage,FacebookMessage(picojson::value jsonParam))
HIVE_EMPTY_IMPL_CLASS(FacebookMessage,toJson() const,picojson::object)
HIVE_EMPTY_IMPL_STDSTRING(FacebookMessage,toString() const)

//SocialGoogle
HIVE_EMPTY_IMPL_VOID(SocialGoogle, getMyProfile(onProfileGoogle listener))
HIVE_EMPTY_IMPL_VOID(SocialGoogle, executeEngine(picojson::value jsonParam))

//ProfileGooglePlay
SocialGoogle::HIVE_EMPTY_CONSTRUCTOR(ProfileGooglePlay)
SocialGoogle::HIVE_EMPTY_CONSTRUCTOR_PARAM(ProfileGooglePlay,ProfileGooglePlay(std::string arg_playerId, std::string arg_playerName))
SocialGoogle::HIVE_EMPTY_CONSTRUCTOR_PARAM(ProfileGooglePlay,ProfileGooglePlay(picojson::value jsonParam))
HIVE_EMPTY_IMPL_CLASS(SocialGoogle::ProfileGooglePlay,toJson() const,picojson::object)
HIVE_EMPTY_IMPL_STDSTRING(SocialGoogle::ProfileGooglePlay,toString() const)

//SocialHive
HIVE_EMPTY_IMPL_VOID(SocialHive, getMyProfile(onProfileHive listener))
HIVE_EMPTY_IMPL_VOID(SocialHive, setMyProfile(std::string displayName, onProfileHive listener))
HIVE_EMPTY_IMPL_VOID(SocialHive, getFriends(FriendType friendType, onProfileHive listener))
HIVE_EMPTY_IMPL_VOID(SocialHive, getProfiles(std::vector<std::string> vidList, onProfileHive listener))
HIVE_EMPTY_IMPL_VOID(SocialHive, sendMessage(MessageContent messageContent, onSendMessageHive listener))
HIVE_EMPTY_IMPL_VOID(SocialHive, sendInvitationMessage(MessageContent messageContent, onSendMessageHive listener))
HIVE_EMPTY_IMPL_VOID(SocialHive, showHiveDialog(HiveDialogType hiveDialogType, std::string vid, onShowHiveDialog listener))
HIVE_EMPTY_IMPL_VOID(SocialHive, executeEngine(picojson::value jsonParam))

//ProfileHive
HIVE_EMPTY_CONSTRUCTOR(ProfileHive)
HIVE_EMPTY_CONSTRUCTOR_PARAM(ProfileHive,ProfileHive(picojson::value jsonParam))
HIVE_EMPTY_IMPL_CLASS(ProfileHive,toJson() const,picojson::object)
HIVE_EMPTY_IMPL_STDSTRING(ProfileHive,toString() const)

//MessageContent
HIVE_EMPTY_CONSTRUCTOR(MessageContent)
HIVE_EMPTY_CONSTRUCTOR_PARAM(MessageContent,MessageContent(std::string vid, std::string uid, std::string message, std::string imageUrl, std::string thumbnailUrl, bool usePush))
HIVE_EMPTY_CONSTRUCTOR_PARAM(MessageContent,MessageContent(picojson::value jsonParam))
HIVE_EMPTY_IMPL_CLASS(MessageContent,toJson() const,picojson::object)
HIVE_EMPTY_IMPL_STDSTRING(MessageContent,toString() const)

//AuthV4
HIVE_EMPTY_IMPL_VOID(AuthV4,setup(onSetup setupListener))
HIVE_EMPTY_IMPL_VOID(AuthV4,signIn(ProviderType providerType, onSignIn signInListener))
HIVE_EMPTY_IMPL_VOID(AuthV4,signOut(onSignOut signOutListener))
HIVE_EMPTY_IMPL_VOID(AuthV4,connect(ProviderType providerType, onConnect connectListener))
HIVE_EMPTY_IMPL_VOID(AuthV4,disconnect(ProviderType providerType, onDisconnect disconnectListener))
HIVE_EMPTY_IMPL_VOID(AuthV4,selectConflict(PlayerID selectedPlayerId, onSignIn signInListener))
HIVE_EMPTY_IMPL_VOID(AuthV4,checkProvider(ProviderType providerType, onCheckProvider checkProviderListener))
HIVE_EMPTY_IMPL_VOID(AuthV4,checkMaintenance(bool isShow, onMaintenance maintenanceListener))
HIVE_EMPTY_IMPL_VOID(AuthV4,checkBlacklist(bool isShow, onMaintenance maintenanceListener))
HIVE_EMPTY_IMPL_VOID(AuthV4,setProviderChangedListener(onCheckProvider checkProviderLisener))
HIVE_EMPTY_IMPL_VOID(AuthV4,showSignIn(onSignIn signInListener))
HIVE_EMPTY_IMPL_VOID(AuthV4,showConflictSelection(IConflictViewInfo const& viewInfo,onSignIn signInListener))
HIVE_EMPTY_IMPL_VOID(AuthV4,showInquiry(onShowInquiry showInquiryListener))
HIVE_EMPTY_IMPL_VOID(AuthV4,showTerms(onShowTerms showTermsListener))
HIVE_EMPTY_IMPL_VOID(AuthV4,showAdultConfirm(onAdultConfirm adultConfirmListener))
HIVE_EMPTY_IMPL_VOID(AuthV4,getProfile(std::vector<PlayerID> playerIdList, onGetProfile getProfileListener))
HIVE_EMPTY_IMPL_VOID(AuthV4,showProfile(PlayerID playerId, onShowProfile showProfileListener))
HIVE_EMPTY_IMPL_VOID(AuthV4,reset())
HIVE_EMPTY_IMPL_DEFAULT(AuthV4,isAutoSignIn(),bool)
HIVE_EMPTY_IMPL_CLASS(AuthV4,getPlayerInfo(),PlayerInfo)
HIVE_EMPTY_IMPL_VOID(AuthV4,getProviderFriendsList(ProviderType providerType, onGetProviderFriendsList getProviderFriendsListListener))
HIVE_EMPTY_IMPL_VOID(AuthV4,resolveConflict(onResolveConflict resolveConflictListener))
HIVE_EMPTY_IMPL_VOID(AuthV4,executeEngine(picojson::value jsonParam))
HIVE_EMPTY_IMPL_VOID(AuthV4,showGameCenterLoginCancelDialog(onAuthV4DialogDismiss listener))
HIVE_EMPTY_IMPL_VOID(AuthV4,requestPermissionViewData(onAuthV4RequestPermissionViewData listener))
HIVE_EMPTY_IMPL_DEFAULT(AuthV4,getAgeGateU13(),bool)
HIVE_EMPTY_IMPL_VOID(AuthV4,showDeviceManagement(onShowDeviceManagement listener))

//AuthV4 helper
HIVE_EMPTY_IMPL_VOID(AuthV4,Helper::executeEngine(picojson::value jsonParam))
HIVE_EMPTY_IMPL_VOID(AuthV4,Helper::syncAccount(ProviderType providerType, onAuthV4Helper listener))
HIVE_EMPTY_IMPL_VOID(AuthV4,Helper::signIn(onAuthV4Helper listener))
HIVE_EMPTY_IMPL_VOID(AuthV4,Helper::signOut(onAuthV4Helper listener))
HIVE_EMPTY_IMPL_VOID(AuthV4,Helper::connect(ProviderType providerType, onAuthV4Helper listener))
HIVE_EMPTY_IMPL_VOID(AuthV4,Helper::disconnect(ProviderType providerType, onAuthV4Helper listener))
HIVE_EMPTY_IMPL_VOID(AuthV4,Helper::showAchievements(onAuthV4Helper listener))
HIVE_EMPTY_IMPL_VOID(AuthV4,Helper::showLeaderboard(onAuthV4Helper listener))
HIVE_EMPTY_IMPL_VOID(AuthV4,Helper::achievementsReveal(const std::string achievementId, onAuthV4Helper listener))
HIVE_EMPTY_IMPL_VOID(AuthV4,Helper::achievementsUnlock(const std::string achievementId, onAuthV4Helper listener))
HIVE_EMPTY_IMPL_VOID(AuthV4,Helper::achievementsIncrement(const std::string achievementId, const int value, onAuthV4Helper listener))
HIVE_EMPTY_IMPL_VOID(AuthV4,Helper::leaderboardsSubmitScore(const std::string leaderboardId, const long long score, onAuthV4Helper listener))
HIVE_EMPTY_IMPL_VOID(AuthV4,Helper::showConflict(onAuthV4Helper listener))
HIVE_EMPTY_IMPL_VOID(AuthV4,Helper::showConflict(ConflictSingleViewInfo const& viewInfo,onAuthV4Helper listener))
HIVE_EMPTY_IMPL_VOID(AuthV4,Helper::switchAccount(onAuthV4Helper listener))
HIVE_EMPTY_IMPL_VOID(AuthV4,Helper::resolveConflict(onAuthV4Helper listener))
HIVE_EMPTY_IMPL_CLASS(AuthV4,Helper::getIDPList(), std::vector<ProviderType>)
HIVE_EMPTY_IMPL_VOID(AuthV4,Helper::showGameCenterLoginCancelDialog(onAuthV4DialogDismiss listener))


//ProfileInfo
HIVE_EMPTY_CONSTRUCTOR(ProfileInfo)
HIVE_EMPTY_CONSTRUCTOR_PARAM(ProfileInfo,ProfileInfo(picojson::value object))
ProfileInfo::~ProfileInfo(){}

//PlayerInfo
HIVE_EMPTY_CONSTRUCTOR(PlayerInfo)
HIVE_EMPTY_CONSTRUCTOR_PARAM(PlayerInfo,PlayerInfo(picojson::value object))
PlayerInfo::~PlayerInfo() {}

//ConflictSingleViewInfo
HIVE_EMPTY_CONSTRUCTOR_PARAM(ConflictSingleViewInfo,ConflictSingleViewInfo(PlayerID playerId))
ConflictSingleViewInfo::~ConflictSingleViewInfo() {}
HIVE_EMPTY_IMPL_VOID(ConflictSingleViewInfo,SetValue(const std::string key,const long long playerData))
HIVE_EMPTY_IMPL_VOID(ConflictSingleViewInfo,SetValue(const std::string key,const double playerData))
HIVE_EMPTY_IMPL_VOID(ConflictSingleViewInfo,SetValue(const std::string key,const std::string playerData))
HIVE_EMPTY_IMPL_STDSTRING(ConflictSingleViewInfo,toJsonConflict() const)
HIVE_EMPTY_IMPL_STDSTRING(ConflictSingleViewInfo,toJsonCurrent() const)

//ConflictViewInfo
HIVE_EMPTY_CONSTRUCTOR_PARAM(ConflictViewInfo,ConflictViewInfo(PlayerID currentPlayerId,PlayerID conflictPlayerId))
ConflictViewInfo::~ConflictViewInfo() {}
HIVE_EMPTY_IMPL_VOID(ConflictViewInfo,SetValue(const std::string key,const long long currentPlayerData,const long long conflictPlayerData))
HIVE_EMPTY_IMPL_VOID(ConflictViewInfo,SetValue(const std::string key,const double currentPlayerData,const double conflictPlayerData))
HIVE_EMPTY_IMPL_VOID(ConflictViewInfo,SetValue(const std::string key,const std::string currentPlayerData,const std::string conflictPlayerData))
HIVE_EMPTY_IMPL_STDSTRING(ConflictViewInfo,toJsonConflict() const)
HIVE_EMPTY_IMPL_STDSTRING(ConflictViewInfo,toJsonCurrent() const)

//ProviderInfo
HIVE_EMPTY_CONSTRUCTOR(ProviderInfo)
HIVE_EMPTY_CONSTRUCTOR_PARAM(ProviderInfo,ProviderInfo(picojson::value object))
HIVE_EMPTY_IMPL_STDSTRING(ProviderInfo,stringProviderType(ProviderType providerType))
HIVE_EMPTY_IMPL_DEFAULT(ProviderInfo,providerTypeFromString(const std::string typeString),ProviderType)

//ProviderGoogle
HIVE_EMPTY_IMPL_VOID(ProviderGoogle,achievementsReveal(const std::string achievementId))
HIVE_EMPTY_IMPL_VOID(ProviderGoogle,achievementsReveal(const std::string achievementId, onAchievementsResult listener))
HIVE_EMPTY_IMPL_VOID(ProviderGoogle,achievementsUnlock(const std::string achievementId))
HIVE_EMPTY_IMPL_VOID(ProviderGoogle,achievementsUnlock(const std::string achievementId, onAchievementsResult listener))
HIVE_EMPTY_IMPL_VOID(ProviderGoogle,achievementsIncrement(const std::string incrementalAchievementId, const int argValue))
HIVE_EMPTY_IMPL_VOID(ProviderGoogle,achievementsIncrement(const std::string incrementalAchievementId, const int argValue, onAchievementsResult listener))
HIVE_EMPTY_IMPL_VOID(ProviderGoogle,leaderboardsSubmitScore(const std::string leaderboardId, const long long score))
HIVE_EMPTY_IMPL_VOID(ProviderGoogle,leaderboardsSubmitScore(const std::string leaderboardId, const long long score, onLeaderboardsResult listener))
HIVE_EMPTY_IMPL_VOID(ProviderGoogle,showLeaderboard(onLeaderboardsResult listener))
HIVE_EMPTY_IMPL_VOID(ProviderGoogle,showAchievements(onAchievementsResult listener))
HIVE_EMPTY_IMPL_VOID(ProviderGoogle,executeEngine(picojson::value jsonParam))
HIVE_EMPTY_IMPL_VOID(ProviderGoogle,getGooglePlayerId(onGooglePlayerIdResult listener))

//ProviderApple
HIVE_EMPTY_IMPL_VOID(ProviderApple,reportScore(std::string score,std::string leaderboardIdentifier,onReportLeaderboard listener))
HIVE_EMPTY_IMPL_VOID(ProviderApple,showLeaderboard(onShowLeaderboard listener))
HIVE_EMPTY_IMPL_VOID(ProviderApple,loadAchievements(onLoadAchievements listener))
HIVE_EMPTY_IMPL_VOID(ProviderApple,reportAchievement(std::string percent,bool showsCompletionBanner,std::string achievementIdentifier,onReportAchievement listener))
HIVE_EMPTY_IMPL_VOID(ProviderApple,showAchievements(onShowAchievement listener))
HIVE_EMPTY_IMPL_VOID(ProviderApple,resetAchievements(onResetAchievements listener))
HIVE_EMPTY_IMPL_VOID(ProviderApple,executeEngine(picojson::value jsonParam))

//ProviderAppleAchievement
HIVE_EMPTY_CONSTRUCTOR(ProviderAppleAchievement)
ProviderAppleAchievement::~ProviderAppleAchievement() {}

//SocialV4
HIVE_EMPTY_IMPL_VOID(SocialV4, showCommunity(ProviderType providerType, onShowCommunity listener))
HIVE_EMPTY_IMPL_VOID(SocialV4, showCommunity(ProviderType providerType, ViewType viewType, onShowCommunity listener))
HIVE_EMPTY_IMPL_VOID(SocialV4, sharePhoto(ProviderType providerType, onSharePhoto listener))

//IAPV4
HIVE_EMPTY_IMPL_VOID(IAPV4,marketConnect(onMarketConnect listener))
HIVE_EMPTY_IMPL_VOID(IAPV4,getProductInfo(onGetProductInfo listener))
HIVE_EMPTY_IMPL_VOID(IAPV4,purchase(std::string marketPid,std::string additionalInfo,onPurchase listener))
HIVE_EMPTY_IMPL_VOID(IAPV4,restore(onRestore listener))
HIVE_EMPTY_IMPL_VOID(IAPV4,transactionFinish(std::string marketPid,onTransactionFinish listener))
HIVE_EMPTY_IMPL_VOID(IAPV4,transactionMultiFinish(std::vector<std::string> const & marketPidList,onTransactionMultiFinish listener))
HIVE_EMPTY_IMPL_VOID(IAPV4,showMarketSelection(onMarketConnect listener))
HIVE_EMPTY_IMPL_VOID(IAPV4,getBalanceInfo(onBalance listener))
HIVE_EMPTY_IMPL_VOID(IAPV4,showCharge(onBalance listener))
HIVE_EMPTY_IMPL_VOID(IAPV4,checkPromotePurchase(onCheckPromotePurchase listener))
HIVE_EMPTY_IMPL_VOID(IAPV4,executeEngine(picojson::value jsonParam))
HIVE_EMPTY_IMPL_VOID(IAPV4,getSubscriptionProductInfo(onGetProductInfo listener))
HIVE_EMPTY_IMPL_VOID(IAPV4,purchaseSubscriptionUpdate(std::string marketPid,std::string oldMarketPid,std::string additionalInfo,onPurchase listener))
HIVE_EMPTY_IMPL_VOID(IAPV4,restoreSubscription(onRestore listener))
HIVE_EMPTY_IMPL_DEFAULT(IAPV4,getSelectedMarket, IAPV4Type)

//IAPV4Product
HIVE_EMPTY_CONSTRUCTOR(IAPV4Product)
HIVE_EMPTY_CONSTRUCTOR_PARAM(IAPV4Product,IAPV4Product(picojson::value const& jsonParam))

//IAPV4Receipt
HIVE_EMPTY_CONSTRUCTOR(IAPV4Receipt)
HIVE_EMPTY_IMPL_CLASS(IAPV4Receipt,create(picojson::value const& jsonParam), std::shared_ptr<IAPV4Receipt>)
IAPV4Receipt::~IAPV4Receipt() {}

//PermissionViewData
HIVE_EMPTY_CONSTRUCTOR(PermissionViewData)

////IAPV4ReceiptApple
//HIVE_EMPTY_CONSTRUCTOR(IAPV4ReceiptApple)
//HIVE_EMPTY_CONSTRUCTOR_PARAM(IAPV4ReceiptApple,IAPV4ReceiptApple(picojson::value const& jsonParam))
//IAPV4ReceiptApple::~IAPV4ReceiptApple() {}
//HIVE_EMPTY_IMPL_CLASS(IAPV4ReceiptApple,& get() const, IAPV4ReceiptApple)
//
////IAPV4ReceiptGoogle
//HIVE_EMPTY_CONSTRUCTOR(IAPV4ReceiptGoogle)
//HIVE_EMPTY_CONSTRUCTOR_PARAM(IAPV4ReceiptGoogle,IAPV4ReceiptGoogle(picojson::value const& jsonParam))
//IAPV4ReceiptGoogle::~IAPV4ReceiptGoogle() {}
//HIVE_EMPTY_IMPL_CLASS(IAPV4ReceiptGoogle,& get() const, IAPV4ReceiptGoogle)
//
////IAPV4ReceiptLebi
//HIVE_EMPTY_CONSTRUCTOR(IAPV4ReceiptLebi)
//HIVE_EMPTY_CONSTRUCTOR_PARAM(IAPV4ReceiptLebi,IAPV4ReceiptLebi(picojson::value const& jsonParam))
//IAPV4ReceiptLebi::~IAPV4ReceiptLebi() {}
//
////IAPV4ReceiptOneStore
//HIVE_EMPTY_CONSTRUCTOR(IAPV4ReceiptOneStore)
//HIVE_EMPTY_CONSTRUCTOR_PARAM(IAPV4ReceiptOneStore,IAPV4ReceiptOneStore(picojson::value const& jsonParam))
//IAPV4ReceiptOneStore::~IAPV4ReceiptOneStore() {}


NS_HIVE_END
#endif
