package org.cocos2dx.cpp;

import org.json.JSONObject;

public interface PostBoxListener {
	public static final String POST_KEY_VID = "vid";
	public static final String POST_KEY_POSTID = "post_id";
	public static final String POST_KEY_ASSETCODE = "asset_code";
	public static final String POST_KEY_ASSETAMOUNT = "asset_amount";
	public static final String POST_KEY_USERMSG = "user_msg";
	public static final String POST_KEY_RECEIVETIME = "receive_time";
	public static final String POST_KEY_ADDEDTIME = "date_added";

	public static final String POST_KEY_NICKNAME = "nickname";
	public static final String POST_KEY_GOLD = "gold";
	public static final String POST_KEY_GEM = "gem";

	public static final String POST_KEY_POST_LIST = "post_list";

	// finishNetworkFailProcess 용.
	public static final String POST_KEY_RESULT_CODE = "result_code";
	public static final String POST_KEY_RESULT_MSG = "result_msg";

	/**
	 * requestLoginConnection callback.
	 * 
	 * @param resultObjects
	 *            key : POST_KEY_NICKNAME, POST_KEY_GOLD, POST_KEY_GEM
	 */
	public void finishLoginProcess(JSONObject resultObjects);

	/**
	 * requestReceivePostConnection callback.
	 * 
	 * @param resultObjects
	 *            key : POST_KEY_POST_LIST (JSONArray) , POST_KEY_NICKNAME,
	 *            POST_KEY_GOLD, POST_KEY_GEM
	 * 
	 *            > POST_LIST 의 key : POST_KEY_POSTID, POST_KEY_ASSETCODE,
	 *            POST_KEY_ASSETAMOUNT, POST_KEY_USERMSG, POST_KEY_RECEIVETIME
	 * 
	 */
	public void finishReceiveProcess(JSONObject resultObjects);

	/**
	 * requestRefreshPostConnection callback.
	 * 
	 * @param resultObjects
	 *            key : POST_KEY_POST_LIST (JSONArray)
	 * 
	 *            > POST_LIST 의 key : POST_KEY_POSTID, POST_KEY_ASSETCODE,
	 *            POST_KEY_ASSETAMOUNT, POST_KEY_USERMSG, POST_KEY_RECEIVETIME
	 */
	public void finishRefreshProcess(JSONObject resultObjects);

	/**
	 * requestUserInfoConnection callback.
	 * 
	 * @param resultObjects
	 *            key : POST_KEY_NICKNAME, POST_KEY_GOLD, POST_KEY_GEM
	 */
	public void finishUserInfoProcess(JSONObject resultObjects);

	/**
	 * request**Connection 공용 network 실패 처리 callback.
	 * 
	 * @param resultObjects
	 *            key : "result_code" , "result_msg"
	 */
	public void finishNetworkFailProcess(JSONObject resultObjects);

	public void finishVerifyProcess(JSONObject resultObjects);

}
