/****************************************************************************
 Copyright (c) 2010 cocos2d-x.org
 
 http://www.cocos2d-x.org
 
 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:
 
 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.
 
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
 ****************************************************************************/

#import "AppController.h"

//#import <HIVE_SDK/HIVESDK.h>
//#import <HIVE_SDK_Plugin/HIVE_CppPlugin.h>
#import <WebKit/WebKit.h>
#import <UIKit/UIKit.h>
#import <GameKit/GameKit.h>
#import <Foundation/Foundation.h>
//#import <HIVECore/HIVECore-Swift.h>
//#import <ProviderAdapter/ProviderAdapter-Swift.h>
//#import <HIVEService/HIVEService-Swift.h>

//#import "HIVEConfiguration.h"   // HIVE SDK 설정을 위한 화면


#import "cocos2d.h"

#import "AppDelegate.h"
#import "RootViewController.h"
#import "C2SPush.h"

#if (defined(COCOS2D_VERSION) && COCOS2D_VERSION < 0x00030300)

// for Cocos2d-x 3.3 under
#import "platform/ios/CCEAGLView.h"

#else

// for Cocos2d-x 3.3 over
#import "platform/ios/CCEAGLView-ios.h"

#endif      // #if (defined(COCOS2D_VERSION) && COCOS2D_VERSION < 0x00030300)




@implementation AppController

#pragma mark -
#pragma mark Application lifecycle


// cocos2d application instance
static AppDelegate s_sharedApplication;
static AppController *controller;

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    NSURL *launchURL;
    if ((launchURL = [launchOptions objectForKey:UIApplicationLaunchOptionsURLKey])) {
        
//        [KakaoiOS sharedInstance].launchURL = launchURL;
    }
    controller = self;
    
#warning HIVEPromotion 테스트 데이터가 있습니다.
//    [HIVEConfiguration setAppId:@"com.com2us.misample.normal.freefull.apple.global.ios.universal"];
    

    // Override point for customization after application launch.
    
    // Add the view controller's view to the window and display.
    window = [[UIWindow alloc] initWithFrame: [[UIScreen mainScreen] bounds]];
    
    
    cocos2d::Application *app = cocos2d::Application::getInstance();
    
#if (defined(COCOS2D_VERSION) && COCOS2D_VERSION < 0x00030300)
    // for Cocos2d-x 3.3 under
    CCEAGLView *eaglView = [CCEAGLView viewWithFrame: [window bounds]
                                         pixelFormat: kEAGLColorFormatRGBA8
                                         depthFormat: GL_DEPTH24_STENCIL8_OES
                                  preserveBackbuffer: NO
                                          sharegroup: nil
                                       multiSampling: NO
                                     numberOfSamples: 0 ];
#else
    // for Cocos2d-x 3.3 over
    app->initGLContextAttrs();
    cocos2d::GLViewImpl::convertAttrs();
    
    CCEAGLView *eaglView = [CCEAGLView viewWithFrame: [window bounds]
                                         pixelFormat: (__bridge NSString*)cocos2d::GLViewImpl::_pixelFormat
                                         depthFormat: cocos2d::GLViewImpl::_depthFormat
                                  preserveBackbuffer: NO
                                          sharegroup: nil
                                       multiSampling: NO
                                     numberOfSamples: 0 ];
#endif      // #if (defined(COCOS2D_VERSION) && COCOS2D_VERSION < 0x00030300)
    
    
    
    
    // Use RootViewController manage CCEAGLView
    _viewController = [[RootViewController alloc] initWithNibName:nil bundle:nil];
    _viewController.wantsFullScreenLayout = YES;
    _viewController.view = eaglView;
    
    // Set RootViewController to window
    if ( [[UIDevice currentDevice].systemVersion floatValue] < 6.0)
    {
        // warning: addSubView doesn't work on iOS6
        [window addSubview: _viewController.view];
    }
    else
    {
        // use this method on ios6
        [window setRootViewController:_viewController];
    }
    
    [window makeKeyAndVisible];
    
    [[UIApplication sharedApplication] setStatusBarHidden:true];
    
    //ActivityIndicator
    _activityIndicator = [[UIActivityIndicatorView alloc] initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleWhiteLarge];
    [_activityIndicator setCenter:_viewController.view.center];
    _activityIndicator.hidden = TRUE;
    [_viewController.view addSubview:_activityIndicator];
    

    
    // IMPORTANT: Setting the GLView should be done after creating the RootViewController
    
#if (defined(COCOS2D_VERSION) && COCOS2D_VERSION < 0x00030300)
    
    // for Cocos2d-x 3.3 under
    cocos2d::GLView *glview = cocos2d::GLView::createWithEAGLView((__bridge void*)eaglView);
    
#else
    
    // for Cocos2d-x 3.3 over
    cocos2d::GLView *glview = cocos2d::GLViewImpl::createWithEAGLView((__bridge void*)eaglView);
    
#endif
    
    cocos2d::Director::getInstance()->setOpenGLView(glview);
    
    app->run();
    
    Class clzHIVEAppDelegate = NSClassFromString(@"HIVEAppDelegate");
    SEL selApplicationDidFinishLaunchingWithOptions = NSSelectorFromString(@"application:didFinishLaunchingWithOptions:");
    if( clzHIVEAppDelegate != nil && [clzHIVEAppDelegate respondsToSelector:selApplicationDidFinishLaunchingWithOptions] ) {
        NSMethodSignature *method = [clzHIVEAppDelegate methodSignatureForSelector:selApplicationDidFinishLaunchingWithOptions];
        if (method != nil) {
            
            NSInvocation *invocation = [NSInvocation invocationWithMethodSignature:method];
            [invocation setSelector:selApplicationDidFinishLaunchingWithOptions];
            [invocation setTarget:clzHIVEAppDelegate];
            [invocation setArgument:(void*)&application atIndex:2];
            if( launchOptions != nil )
                [invocation setArgument:(void*)&launchOptions atIndex:3];
            [invocation invoke];
            
            BOOL returnBoolValue = FALSE;
            [invocation getReturnValue:&returnBoolValue];
            return returnBoolValue;
        }
    }
    return YES;
    //return [HIVEAppDelegate application:application didFinishLaunchingWithOptions:launchOptions];
}


- (void)applicationWillResignActive:(UIApplication *)application {
    /*
     Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
    
    //We don't need to call this method any more. It will interupt user defined game pause&resume logic
    /* cocos2d::Director::getInstance()->pause(); */
}

- (void)applicationDidBecomeActive:(UIApplication *)application {
    /*
     Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
     */
    //We don't need to call this method any more. It will interupt user defined game pause&resume logic
    
    /* cocos2d::Director::getInstance()->resume(); */
}

- (void)applicationDidEnterBackground:(UIApplication *)application {
    /*
     Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
     If your application supports background execution, called instead of applicationWillTerminate: when the user quits.
     */
    cocos2d::Application::getInstance()->applicationDidEnterBackground();
}

- (void)applicationWillEnterForeground:(UIApplication *)application {
    /*
     Called as part of  transition from the background to the inactive state: here you can undo many of the changes made on entering the background.
     */
    cocos2d::Application::getInstance()->applicationWillEnterForeground();
}

- (void)applicationWillTerminate:(UIApplication *)application {
    /*
     Called when the application is about to terminate.
     See also applicationDidEnterBackground:.
     */
}


- (BOOL)application:(UIApplication *)application openURL:(NSURL *)url sourceApplication:(NSString *)sourceApplication annotation:(id)annotation
{
    return YES;//[[FBSDKApplicationDelegate sharedInstance] application:application openURL:url sourceApplication:sourceApplication annotation:annotation];
}

- (BOOL)application:(UIApplication *)app openURL:(NSURL *)url options:(NSDictionary<NSString*, id> *)options
{
    return YES;
}

- (UIInterfaceOrientationMask)application:(UIApplication *)application supportedInterfaceOrientationsForWindow:(UIWindow *)window {
    return [[window rootViewController] supportedInterfaceOrientations];
}

- (BOOL)application:(UIApplication *)application continueUserActivity:(NSUserActivity *)userActivity restorationHandler:(void (^)(NSArray<id<UIUserActivityRestoring>> *restorableObjects))restorationHandler {
    return YES;
}

- (BOOL)application:(UIApplication *)application willContinueUserActivityWithType:(NSString *)userActivityType {
    return YES;
}

#pragma mark -
#pragma mark Memory management

- (void)applicationDidReceiveMemoryWarning:(UIApplication *)application {
    /*
     Free up as much memory as possible by purging cached data objects that can be recreated (or reloaded from disk) later.
     */
}

- (void)dealloc {
    //    [window release];
    //    [super dealloc];
}

+(void) startActivityIndicator {
    dispatch_async(dispatch_get_main_queue(), ^{
        [controller activityIndicator].hidden = FALSE;
        [[controller activityIndicator] startAnimating];
    });
}

+(void) endActivityIndicator {
    dispatch_async(dispatch_get_main_queue(), ^{
        [[controller activityIndicator] stopAnimating];
        [controller activityIndicator].hidden = TRUE;
    });
}

@end


extern "C" const char* getHiveSdkVersion() {
    
    NSString *resultValue = @"";
    Class classAPI = NSClassFromString(@"C2SModuleSns");
    SEL methodToPerformSelector = NSSelectorFromString(@"getVersion");
    NSMethodSignature *methodSignature = [classAPI methodSignatureForSelector:methodToPerformSelector];
    NSInvocation *myInvocation = [NSInvocation invocationWithMethodSignature:methodSignature];
    [myInvocation setTarget:classAPI];
    [myInvocation setSelector:methodToPerformSelector];
    
    [myInvocation invoke];
    [myInvocation getReturnValue:&resultValue];
     
    return [resultValue UTF8String];
}
extern "C" const char* getAppVersion() {
    return [[[NSBundle mainBundle] objectForInfoDictionaryKey:@"CFBundleVersion"] UTF8String];
}
extern "C" const char* getCurrentTime() {
    
    NSDate *date = [NSDate date];
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
    [formatter setDateFormat:@"yy-MM-dd hh:mm a"];
    NSString *timeString = [formatter stringFromDate:date];
    
    
    return [timeString UTF8String];
}
