//
//  AuthV4HelperTest.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by paikjongman on 2018. 3. 12..
//  Copyright © 2018년 GCP. All rights reserved.
//

#ifndef AuthV4HelperTest_hpp
#define AuthV4HelperTest_hpp

#include "BaseView.hpp"
#include "AuthV4Test.hpp"
#include "UICombobox.hpp"

class AuthV4HelperTest : public AuthV4Test
{
public:
    CREATE_FUNC(AuthV4HelperTest);
    
    virtual bool init()override;
    
    virtual void onButtonEvent(int buttonTag)override;
private:
    enum : int {
        BUTTON_SIGNIN
        ,BUTTON_SIGNOUT
        ,BUTTON_PLAYERDELETE
        ,BUTTON_SHOW_SIGNIN
        ,BUTTON_GET_IDPLIST
        ,BUTTON_CONNECT
        ,BUTTON_DISCONNECT
        ,BUTTON_RESOLVE_CONFLICT
        ,BUTTON_SWITCH_CONFLICT
        ,BUTTON_SHOW_CONFLICT_1
        ,BUTTON_SHOW_CONFLICT_2
        ,BUTTON_SYNC_ACCOUNT
        ,BUTTON_SHOW_GAME_CENTER_LOGINCANCELDIALOG
        ,BUTTON_SHOW_ACHIVEMENTS
        ,BUTTON_SHOW_LEADERBOARD
        ,EDITBOX_ID
        ,EDITBOX_VALUE
        ,BUTTON_ACHIVEMENTS_REVEAL
        ,BUTTON_ACHIVEMENTS_UNLOCK
        ,BUTTON_ACHIVEMENTS_INCREMENTS
        ,BUTTON_LEADERBOARDS_SUBMIT_SCORE
    };
    
    std::vector<const char*>& getProviderTypeStringList();
    std::vector<std::string>& getProviderTypeStringListStr();
    std::vector<std::string> providerTypeStringListStr;
    std::vector<const char*> providerTypeStringList;
    
    void logResult(const char* funcName,const hive::ResultAPI &result,std::shared_ptr<hive::PlayerInfo> playerInfo);
    void logResult(const char* funcName,const hive::ResultAPI &result, const hive::PlayerInfo &playerInfo);
    void logResult(const char* funcName, std::vector<std::string> idpList);
    void conflictProcess(hive::ResultAPI const & result,std::shared_ptr<hive::PlayerInfo> playerInfo);
};

#endif /* AuthV4HelperTest_hpp */
