//
//  AuthV4Test.h
//  HIVE_SDK_Cocos_Sample
//
//  Created by paikjongman on 2017. 6. 8..
//  Copyright © 2017년 GCP. All rights reserved.
//

#ifndef AuthV4Test_h
#define AuthV4Test_h

#include "BaseView.hpp"
#include "UICombobox.hpp"
#include <functional>

class AuthV4Test : public BaseView
{
public:
    CREATE_FUNC(AuthV4Test);
    
    virtual bool init()override;
    
    virtual void onButtonEvent(int buttonTag)override;
    //virtual void onRadioButtonSelectChange(int radioButtonTag,int index)override;
    
private:
    enum : int {
        BUTTON_REQUESTPERMISSIONVIEWDATA
        ,BUTTON_SETUP
        ,BUTTON_SIGNIN
        ,BUTTON_SIGNOUT
        ,BUTTON_PLAYERDELETE
        ,BUTTON_CONNECT
        ,BUTTON_DISCONNECT
        ,BUTTON_RESOLVE_CONFLICT
        ,BUTTON_SELECT_CONFLICT
        ,BUTTON_SHOW_CONFLICTSELECTION
        ,BUTTON_ISREADYENGAGEMENT
        ,BUTTON_CHECK_PROVIDER
        ,BUTTON_CHECK_MAINTENANCE
        ,BUTTON_CHECK_BLACKLIST
        ,BUTTON_SETPROVIDERCHANGEHANDLER
        ,BUTTON_SHOWSIGNIN
        ,BUTTON_SHOWCAFE
        ,BUTTON_SHOWINQUIRY
        ,BUTTON_SHOWCHATBOTINQUIRY
        ,BUTTON_SHOWMYINQUIRY
        ,BUTTON_SHOWTERMS
        ,BUTTON_SHOWADULTCONFIRM
        ,BUTTON_GETPROFILE
        ,BUTTON_SHOWPROFILE
        ,BUTTON_RESET
        ,BUTTON_ISAUTOSIGNIN
        ,BUTTON_GETPLAYERINFO
        ,BUTTON_GETPROVIDERFRIENDLIST
        ,BUTTON_SHOW_GAME_CENTER_LOGINCANCELDIALOG
        ,TOGGLE_BUTTON_IS_READY_ENGAGEMENT
        ,TOGGLE_BUTTON_IS_SHOW_MAINTENANCE
        ,EDITBOX_SHOW_PROFILE
        ,COMBOBOX_LOGINTYPE
        ,BUTTON_GET_AGEGATEU13
        ,BUTTON_IS_ACTIVATE_LOGGING
        ,EDITBOX_PERMISSION_LIST
        ,BUTTON_REQUEST_USER_PERMISSIONS
        ,BUTTON_SHOW_DEVICEMANAGEMENT
        ,COMBOBOX_EXTERNAL_AUTH_PROVIDER
        ,EDITBOX_EXTERNAL_AUTH_PROVIDER
        ,EDITBOX_EXTERNAL_AUTH_USER_ID
        ,BUTTON_EXTERNAL_AUTH_AND_SIGNIN_WITH_AUTH_KEY
        ,BUTTON_EXTERNAL_AUTH_AND_CONNECT_WITH_AUTH_KEY
        ,BUTTON_EXTERNAL_AUTH_AND_DISCONNECT_WITH_NAME
    };
    
public:

protected:
    typedef std::function<void(hive::ProviderType)> ProviderSelectCallback;
    void showProviderSelectView(std::vector<std::string> list,ProviderSelectCallback callback);
private:
    void showProviderSelectView(ProviderSelectCallback callback);
    //PlayerInfo에 있는 ProviderData를 기준으로 생성
    void showProviderSelectView(const hive::PlayerInfo& info,ProviderSelectCallback callback);
    
    std::string getResultString(hive::ResultAPI const & api);
    void LogHead(const char* funcName);
    void LogHead(const char* funcName,hive::ResultAPI const & api);
    bool ErrorCheckResultAPI(hive::ResultAPI const & api);
    void showResult(hive::ResultAPI const & api);
};



#endif /* AuthV4Test_h */
