//
//  GameManager.h
//  HIVE_SDK_Cocos_Sample
//
//  Created by paikjongman on 2017. 7. 26..
//  Copyright © 2017년 GCP. All rights reserved.
//

#ifndef GameManager_hpp
#define GameManager_hpp

#include <HIVE_SDK_Plugin/HIVE_CPP.h>

class GameManager {
public:
    struct _ConflictUserData{
        _ConflictUserData(hive::PlayerID _playerId,std::string _name,std::string _token){
            playerId = _playerId;
            name = _name;
            token = _token;
        }
        hive::PlayerID playerId;
        std::string name;
        std::string token;
    } typedef ConflictUserData;
    
    enum AuthModule{
        AUTHv1,
        AUTHv4,
    };
    
    ~GameManager();
    
    static GameManager* getInstance();
    
    static void engagemenetResult(hive::ResultAPI const & result, hive::EngagementEventType engagementEventType, hive::EngagementEventState engagementEventState, picojson::value const & param);
    
    void ConflictProc(const ConflictUserData& current,const ConflictUserData& conflict);
    
    void SetCurrentAuthModule(AuthModule module);
    AuthModule GetCurrentAuthModule() const;
    
    hive::PlayerInfo const & GetCurrentPlayerInfo() const;
    void SetCurrentPlayerInfo(hive::PlayerInfo const & playerInfo);
    
    hive::PlayerInfo const & GetConflictPlayerInfo() const;
    void SetConflictPlayerInfo(hive::PlayerInfo const & playerInfo);
    
private:
    
    GameManager();
    static std::string getResultString(hive::ResultAPI const & api);
    static bool ErrorCheckResultAPI(hive::ResultAPI const & api);
    
    static bool isConflict(picojson::value const & param);
    
    AuthModule authModule;
    
    hive::PlayerInfo currentPlayerInfo;
    hive::PlayerInfo conflictPlayerInfo;
};

#endif /* GameManager_h */
