//
//  PromotionTest.hpp
//  hivesdk
//
//  Created by paikjongman on 2017. 2. 28..
//
//

#ifndef PromotionTest_hpp
#define PromotionTest_hpp

#include "BaseView.hpp"

class PromotionTest : public BaseView
{
public:
    CREATE_FUNC(PromotionTest);
    virtual bool init()override;
    virtual void onButtonEvent(int buttonTag)override;
    
    enum : int
    {
        COMBOBOX_PROMOTION_TYPE,
        TOGGLE_BUTTON_PROMOTION_FORCE,
        BUTTON_SHOW_PROMOTION,
        EDITBOX_NEWS_MENU,
        EDITBOX_NEWS_GIFTPIDLIST,
        BUTTON_NEWS_GIFTPIDLIST_RANDOM,
        BUTTON_SHOW_NEWS,
        COMBOBOX_CUSTOM_TYPE,
        EDITBOX_CONTENTS_KEY,
        BUTTON_SHOW_CUSTOM_CONTENTS,
        BUTTON_SHOW_CUSTOM_CONTENTS_ON_GAME_WINDOW,
        BUTTON_SHOW_OFFERWALL,
        BUTTON_SHOW_REVIEW,
        BUTTON_SHOW_NATIVE_REVIEW,
        BUTTON_SHOW_EXIT,//Android only
        BUTTON_GET_OFFERWALL_STATE,
        BUTTON_GET_VIEW_INFO,
        BUTTON_GET_BADGE_INFO,
        COMBOBOX_CAMPAIGN_TYPE,
        COMBOBOX_BANNER_TYPE,
        BUTTON_GET_BANNER_INFO,
        EDITBOX_CAMPAIGN_TYPE,
        EDITBOX_BANNER_TYPE,
        BUTTON_GET_BANNER_INFO_STRING,
        BUTTON_GET_APP_INVITATION_DATA,
        EDITBOX_ADDITIONAL_INFO,
        BUTTON_SET_ADDITIONAL_INFO,
		BUTTON_SHOW_UA_SHARE,
        EDITBOX_USER_ENGAGEMENT_URI,
        BUTTON_PROCESS_URI,
        BUTTON_UPDATE_PROMOTIN_DATA,
        EDITBOX_UPDATE_GAME_LANGUAGE,
        BUTTON_UPDATE_GAME_LANGUAGE,
        EDITBOX_UPDATE_SERVER_ID,
        BUTTON_UPDATE_SERVER_ID,
        BUTTON_RESET_ADDITIONAL_INFO,
        BUTTON_RANDOM_ADDITIONAL_INFO,
        BUTTON_GET_APP_INVITATION_SENDER_INFO,
    };
    
    // 프로모션 뷰 API 결과 통지 리스너 - Promotion::showXXX()
    void onPromotionView(hive::ResultAPI result, hive::PromotionEventType eventType);
    
    // viewId에 해당하는 컨텐츠 조회의 결과 통지 리스너 - Promotion::getViewInfo()
    void onPromotionViewInfo(hive::ResultAPI result, std::vector<hive::PromotionViewInfo> promotionViewInfo);
    
    // 프로모션 배지 표시 정보 조회에 대한 결과 통지 리스너 - Promotion::getBadgeInfo()
    void onPromotionBadgeInfo(hive::ResultAPI result, std::vector<hive::PromotionBadgeInfo> badgeInfoList);

    // 롤링 프로모션 배너 정보 조회 리스너 - Promotion.getBannerInfo()
    void onPromotionBannerInfo(hive::ResultAPI result, std::vector<hive::PromotionBannerInfo> bannerInfoList);
    
    // 앱 초대 정보 요청에 대한 결과 통지 리스너 - Promotion::getAppInvitationData()
    void onAppInvitationData(hive::ResultAPI result, hive::AppInvitationData appInvitationData);

    // UA 초대자 정보 - Promotion::getAppInvitationSenderInfo()
    void onAppInvitationSenderInfo(hive::ResultAPI result, hive::AppInvitationSenderInfo appInvitationSenderInfo);
	
	// UA 공유 기능 요청에 대한 결과 통지 리스너 - Promotion::showUAShare()
	void onUAShare(hive::ResultAPI result);
    
    // Promotion getAppInvitaionData API의 결과를 저장
    hive::AppInvitationData invitationData;
};

#endif /* PromotionTest_hpp */
