//
//  LoggerUtils.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by paikjongman on 2017. 8. 31..
//  Copyright © 2017년 GCP. All rights reserved.
//

#ifndef LoggerUtils_hpp
#define LoggerUtils_hpp

#include <HIVE_SDK_Plugin/HIVE_CPP.h>

class ResultUtils {
public:
    static std::string getResultAPIString(hive::ResultAPI const & result);
    static void showResult(hive::ResultAPI const & result);
    static bool errorCheckResultAPI(hive::ResultAPI const & result);
    
    static void logHead(const char* className,const char* funcName);
    static void logHead(const char* className,const char* funcName,hive::ResultAPI const & result);
    
    static void logProviderInfo(const char* className,const char* funcName,hive::ProviderInfo const & providerInfo);
    static void logPlayerInfo(const char* className,const char* funcName,hive::PlayerInfo const & playerInfo);
    static void logProfileInfo(const char* className,const char* funcName,hive::ProfileInfo const & profileInfo);
    
    static std::string getProviderInfoString(const hive::ProviderInfo& info);
    static std::string getPlayerInfoString(const hive::PlayerInfo& info);
    static std::string getProfileInfoString(const hive::ProfileInfo& info);
    
    static std::string getAppInvitationCampaignString(const hive::AppInvitationCampaign& info);
    static std::string getAppInvitationCampaignStageString(const hive::AppInvitationCampaignStage& info);
};

#endif /* LoggerUtils_hpp */
