//
//  SocialFacebookTest.hpp
//  hivesdk
//
//  Created by paikjongman on 2017. 2. 28..
//
//

#ifndef SocialFacebookTest_hpp
#define SocialFacebookTest_hpp

#include "BaseView.hpp"

class SocialFacebookTest : public BaseView
{
public:
    CREATE_FUNC(SocialFacebookTest);
    virtual bool init()override;
    virtual void onButtonEvent(int buttonTag)override;
    
    enum : int
    {
        BUTTON_GET_MY_PROFILE = 0,
        BUTTON_GET_FRIENDS,
        MUILTY_FRIENDS_FBAPPID,
        EDITBOX_FRIENDS_MESSAGE,
        BUTTON_SEND_MESSAGE,
        EDITBOX_INVITATION_MESSAGE,
        BUTTON_SHOW_INVITATION_DIALOG,
        EDITBOX_POST_MESSAGE,
        EDITBOX_POST_IMAGE_URL,
        EDITBOX_POST_CONTENT_URL,
        BUTTON_POST_FACEBOOK
    };
    
    // Facebook 프로필 정보 결과 통지 리스너 - SocialFacebook::getMyProfile()
    void onProfileFacebook(hive::ResultAPI result, std::vector<hive::ProfileFacebook> profileList);
    
    // Facebook 친구 정보 결과 통지 리스너 - SocialFacebook::getFriends()
    void onFriendsFacebook(hive::ResultAPI result, std::vector<hive::ProfileFacebook> profileList);
    
    // Facebook 인증 사용자의 친구 메시지 전송 결과 통지 리스너 - SocialFacebook::sendMessageFacebook()
    void onSendMessageFacebook(hive::ResultAPI result);
    
    // Facebook 인증 사용자의 친구 요청 대화상자 호출 결과 통지 리스너 - SocialFacebook::showInvitationDialog()
    void onShowInvitationDialogFacebook(hive::ResultAPI result);
    
    // Facebook 인증 사용자의 게시글 등록 요청 - SocialFacebook::postFacebook()
    void onPostFacebook(hive::ResultAPI result);
};

#endif /* SocialFacebookTest_hpp */
