//
//  UICombobox.cpp
//  hivesdk
//
//  Created by paikjongman on 2017. 2. 28..
//
//

#include "UICombobox.hpp"
#include <memory>

using namespace cocos2d;
using namespace cocos2d::ui;

#define DEFAULT_BUTTON_TAG 1
#define DEFAULT_COMBOLIST_TAG 2
#define DEFAULT_UI_SIZE Size(350, 50)

Combobox *Combobox::create(const char *title,const std::vector<std::string>& list,ComboboxCallback callback)
{
    return create(title,list,true,callback);
}

Combobox *Combobox::create(const char *title,const std::vector<std::string>& list,bool useBack,ComboboxCallback callback){
    return create(title, DEFAULT_UI_SIZE, list, useBack, callback);
}

Combobox *Combobox::create(const char *title, const cocos2d::Size size, const std::vector<std::string>& list,bool useBack,ComboboxCallback callback) {
    Combobox *pRet = new(std::nothrow) Combobox();
    if (pRet && pRet->initWithButton(title, size, std::move(list), useBack, callback))
    {
        pRet->autorelease();
        return pRet;
    }
    else
    {
        delete pRet;
        pRet = nullptr;
        return nullptr;
    }
}

bool Combobox::initWithButton(const char *title,const std::vector<std::string>& list,bool useBack,ComboboxCallback callback)
{
    return initWithButton(title, DEFAULT_UI_SIZE, list, useBack, callback);
}

bool Combobox::initWithButton(const char *title, const cocos2d::Size size, const std::vector<std::string>& list, bool useBack, ComboboxCallback callback)
{
    if(!BaseView::init())
        return false;
    
    if(useBack)
        setUseBackButton(true);
    
    addLabel(title);
    
    combolist = std::move(list);
    
    for(int i=0;i<list.size();++i)
    {
        addButton(combolist[i].c_str(), size, i);
    }
    
    selectCallback = callback;
    
    return true;
}

void Combobox::onButtonEvent(int buttonTag)
{
    selectCallback(combolist[buttonTag].c_str(),buttonTag);
    popView();
}
