//
//  UICombobox.hpp
//  hivesdk
//
//  Created by paikjongman on 2017. 2. 28..
//
//

#ifndef UICombobox_hpp
#define UICombobox_hpp

#include "cocos2d.h"
#include "ui/CocosGUI.h"
#include "BaseView.hpp"
#include <vector>
#include <memory>

class Combobox : public BaseView
{
public:
    typedef std::function<void(const char *selectItem,int index)> ComboboxCallback;
    static Combobox *create(const char *title,const std::vector<std::string>& list,ComboboxCallback callback);
    //back버튼을 직접 추가해서 사용하고 싶을때.
    static Combobox *create(const char *title,const std::vector<std::string>& list,bool useBack,ComboboxCallback callback);
    //size 지정 combobox
    static Combobox *create(const char *title, const cocos2d::Size size, const std::vector<std::string>& list,bool useBack,ComboboxCallback callback);
    virtual bool initWithButton(const char *title,const std::vector<std::string>& list,bool useBack,ComboboxCallback callback);
    virtual bool initWithButton(const char *title, const cocos2d::Size size, const std::vector<std::string>& list, bool useBack, ComboboxCallback callback);
    
protected:
    virtual void onButtonEvent(int buttonTag)override;
    
private:
    ComboboxCallback selectCallback;
    std::vector<std::string> combolist;
};

#endif /* UICombobox_hpp */
