//
//  UIInputList.cpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by paikjongman on 2017. 6. 16..
//  Copyright © 2017년 GCP. All rights reserved.
//

#include "UIInputList.hpp"

using namespace cocos2d;
using namespace cocos2d::ui;


InputList* InputList::create(const char* title,InputListCallback callback)
{
    InputList *pRet = new(std::nothrow) InputList();
    if (pRet && pRet->init(title,callback))
    {
        pRet->autorelease();
        return pRet;
    }
    else
    {
        delete pRet;
        pRet = nullptr;
        return nullptr;
    }
}
bool InputList::init(const char* title,InputListCallback callback)
{
    if(!BaseView::init())
        return false;
    
    viewTitle = title;
    
    addLabel(title);
    
    OK_BUTTON_TAG = -98;
    CANCEL_BUTTON_TAG = -99;
    ADD_EDITBOX_TAG = -100;
    addButton("OK", OK_BUTTON_TAG);
    addButton("Cancel",CANCEL_BUTTON_TAG);
    addButton("Add Item",ADD_EDITBOX_TAG);

    okCallback = callback;
    
    return true;
}
std::vector<std::string> InputList::getInputLists(){
    for(int i=0;i<data.size();++i){
        data[i] = getEditboxValue(i);
    }
    return data;
}


void InputList::onButtonEvent(int buttonTag) {
    if(buttonTag == OK_BUTTON_TAG)
    {
        okCallback(this,getInputLists());
        popView();
    }
    else if (buttonTag == CANCEL_BUTTON_TAG)
    {
        popView();
    }
    else if(buttonTag == ADD_EDITBOX_TAG)
    {
        if(data.size() >= INT_MAX)
            return;
        addEditBox("",static_cast<int>(data.size()));
        data.push_back("");
    }
}
