#ifndef __DATA_MANAGER_H__
#define __DATA_MANAGER_H__

#include "cocos2d.h"

USING_NS_CC;

#define TAG_APIACTION_INITIALIZE		101
#define TAG_APIACTION_LOGIN				102
#define TAG_APIACTION_LOGOUT			103
#define TAG_APIACTION_LOGOUT_USEREXIT	1031		// Hive 1.19.5.2
#define TAG_APIACTION_PUSHREGISTER		104
#define TAG_APIACTION_PUSHUNREGISTER	105
#define TAG_APIACTION_PUSHDESCRIPTION	106
#define TAG_APIACTION_PUSHREGISTER_LIST		10401
#define TAG_APIACTION_PUSHUNREGISTER_LIST	10501
#define TAG_APIACTION_PUSH_REQUEST_PERMISSION   10502
#define TAG_APIACTION_SNSUSER			107
#define TAG_APIACTION_SNSUSER_DELETE			1071			// Hive 1.20.1
#define TAG_APIACTION_SNSPOSTING		108
#define TAG_APIACTION_PROMOTIONSHOW		109
#define TAG_APIACTION_PROMOTIONINFO		110
#define TAG_APIACTION_SNSFRIENDS		111
#define TAG_APIACTION_SNSMESSAGE		112
#define TAG_APIACTION_SNSSESSION		113
#define TAG_APIACTION_INAPPRESTORE		114
#define TAG_APIACTION_INAPPPURCHASE		115
#define TAG_APIACTION_INAPPFINISH		116
#define TAG_APIACTION_REQUESTBALANCE	117
#define TAG_APIACTION_PREPARE			118
#define TAG_APIACTION_SNSSHOW			119
#define TAG_APIACTION_SOCIALSHOW		120
#define TAG_APIACTION_SENDEVENT			121
#define TAG_APIACTION_SETENABLE			122
#define TAG_APIACTION_GETLOGINSTATE		123
#define TAG_APIACTION_USERACQUISITION	124				// HIVE 1.9.0 : promotion acquisition
#define TAG_APIACTION_SOCIALINFO		125				// HIVE 1.10.0
#define TAG_APIACTION_HIVEIAP_INFO		126				// HIVE 1.10.0
#define TAG_APIACTION_HIVEIAP_SHOW		127				// HIVE 1.10.0
#define TAG_APIACTION_HIVEIAP_PURCHASE	128				// HIVE 1.10.0
#define TAG_APIACTION_HIVEIAP_RESTORE	129				// HIVE 1.10.0
#define TAG_APIACTION_ENGAGEMENT_GETEVENTS		130		// HIVE 1.10.0
#define TAG_APIACTION_ENGAGEMENT_CONSUMECOUPON	131		// HIVE 1.10.0
#define TAG_APIACTION_ENGAGEMENT_SETREADY		136		// HIVE 1.11.0
#define TAG_APIACTION_HIVEIAP_POSTBOX			132		// HIVE 1.10.0

#define TAG_APIACTION_LOGIN_SELECT 			133			// HIVE 1.10.1
#define TAG_APIACTION_LOGIN_CUSTOMSELECT	134			// HIVE 1.10.1
#define TAG_APIACTION_SNSSETGUESTUSERINFO	135			// HIVE 1.10.1

#define TAG_APIACTION_HIVEPROMOTION_SHOW	137 		// HIVE 1.12.0
#define TAG_APIACTION_HIVEPROMOTION_INFO	138			// HIVE 1.12.0
#define TAG_APIACTION_HIVEPROMOTION_SETADDITIONALINFO		139		// HIVE 1.12.0
#define TAG_APIACTION_HIVEPROMOTION_GETOFFERWALLSTATE		140		// HIVE 1.12.0

#define TAG_APIACTION_SETGAMEINFO_SETGAMEINFO				141		// HIVE 1.12.0
#define TAG_APIACTION_SETGAMEINFO_GETHIVECOUNTRYCODE		1411
#define TAG_APIACTION_SETGAMEINFO_GETCHANNEL				1412	// Hive 1.20.3
#define TAG_APIACTION_SETGAMEINFO_SETCHANNEL				1413	// Hive 1.20.3
#define TAG_APIACTION_SETGAMEINFO_UPDATE_SERVERID			1414
#define TAG_APIACTION_SETGAMEINFO_UPDATE_GAMELANGUAGE		1415
#define TAG_APIACTION_SETGAMEINFO_SEND_DATA                 1416

#define TAG_APIACTION_PROMOTION_FULLBANNER_USE_LEGACY_BANNER	142	// HIVE 1.18.1

#define TAG_APIACTION_PROMOTION_GETBANNERINFO				143	// HIVE 1.18.3
#define TAG_APIACTION_HIVEPROMOTION_GETBANNERINFO			144 // HIVE 1.18.3
#define TAG_APIACTION_HIVEPROMOTION_UPDATEPROMOTIONDATA		155 // HIVE 1.19.0

#define TAG_APIACTION_INAPPV4_ITEMINFO						145 // HIVE 1.18.4
#define TAG_APIACTION_INAPPV4_PURCHASE						146 // HIVE 1.18.4
#define TAG_APIACTION_INAPPV4_RESTORE						147 // HIVE 1.18.4
#define TAG_APIACTION_INAPPV4_TRANSACTION_FINISH			148 // HIVE 1.18.4
#define TAG_APIACTION_INAPPV4_GET_SELECTED_MARKET			149 // HIVE 1.18.4
#define TAG_APIACTION_INAPPV4_MARKET_SELECT					150 // HIVE 1.18.4
#define TAG_APIACTION_INAPPV4_REQUEST_BALANCE				151 // HIVE 1.18.4
#define TAG_APIACTION_INAPPV4_CHARGE_BALANCE				152 // HIVE 1.18.4
#define TAG_APIACTION_INAPPV4_POSTBOX_LOGIN					153 // HIVE 1.18.4
#define TAG_APIACTION_INAPPV4_POSTBOX_SHOW					154 // HIVE 1.18.4
#define TAG_APIACTION_INAPPV4_CHECK_PROMOTE_PURCHASE        156 // Hive 1.19.1
#define TAG_APIACTION_INAPPV4_MARKETCONNECT					157 // Hive 1.20.0
#define TAG_APIACTION_INAPPV4_GET_ACCOUNT_UUID    			158 // HIVE 1.20.3

// MAX VALUE = 155

using namespace cocos2d;

class DataManager : public Menu
{
public:
	static cocos2d::Scene* createScene();
	virtual bool init();
	void menuCloseCallback(cocos2d::Ref* pSender);
	CREATE_FUNC(DataManager);

	// variable
	static bool isWeChatTestSampleMode;

	// function
	static void getApiAction(int num);
	static void setParamValue_bool(int apiNum, std::string key, bool value);
	static void setParamValue_int(int apiNum, std::string key, int value);
	static void setParamValue_string(int apiNum, std::string key, std::string value);

	static void setState(int sceneNum, std::string key, bool value);
	static void setState_int(int sceneNum, std::string key, int value);
	static void setState_string(int sceneNum, std::string key, std::string value);

	static std::string getParamValue(int apiNum, std::string key);
	static bool getParamValue_bool(int apiNum, std::string key);

	static void setCurrentModule(int currentModule);		// 몇번에 해당하는 ModuleListScene을 띄울지 관리
	static void setCurrentParameter(int currentParameter);	// 몇번에 해당하는 ParameterListScene을 띄울지 관리
	static int getCurrentModule();							// 몇번에 해당하는 ModuleListScene인지 반환
	static int getCurrentParameter();						// 몇번에 해당하는 ParameterListScene인지 반환

	static std::string getAppId(int appIdNum);				// 등록된 AppId 반환

	static void switchDisplayQRcode(bool displaySwitch);						// QRcode 팝업 띄우기 (add HIVE 1.9.0)

	// string parsing
	static std::vector<std::string> splitString(std::string input, std::string separator);		// string split with string delimiter (add HIVE 1.9.0)
	static std::string connectString(std::vector<std::string> dataList);						// connect string list(add HIVE 1.9.0)
	static std::vector<unsigned char> convertHexStringToBytes(std::string hexStr);				// convert hex string to (add HIVE 1.9.0)

};

#endif // __DATA_MANAGER_H__
