#include "InitParameterScene.h"
#include "InitListScene.h"
#include "DataManager.h"
#include "LogController.h"
#include "Parameter.h"


#ifdef __ANDROID__
#include "JNISample.h"
#endif

USING_NS_CC;

float InitParameterScene::ui_moduleListNameLabel_x = 0.5;
float InitParameterScene::ui_moduleListNameLabel_y = 0.85;
float InitParameterScene::ui_previousBtn_x = 0.1;
float InitParameterScene::ui_previousBtn_y = 0.85;
float InitParameterScene::ui_saveParamBtn_x = 0.85;
float InitParameterScene::ui_saveParamBtn_y = 0.1;
float InitParameterScene::ui_paramLabel_x = 0.2;
float InitParameterScene::ui_checkbox_x = 0.6;
float InitParameterScene::ui_textField_x = 0.75;
float InitParameterScene::ui_paddingSize_y = 0.04;

bool InitParameterScene::ui_isOpenedWindow = false;
// static variable ( checkbox )
bool InitParameterScene::ui_checkbox_initParameter_showLog = true;
bool InitParameterScene::ui_checkbox_initParameter_permissionWrite = true;
bool InitParameterScene::ui_checkbox_initParameter_showNotice = true;
//bool InitParameterScene::ui_checkbox_initParameter_HiveIAP = false;
bool InitParameterScene::ui_checkbox_initParameter_useOneStore = false;
bool InitParameterScene::ui_checkbox_initParameter_hivePromotion = true;
bool InitParameterScene::ui_checkbox_initParameter_useGalaxyStore = false;
bool InitParameterScene::ui_checkbox_initParameter_showPermissionView = true;
bool InitParameterScene::ui_checkbox_initParameter_useImageBanner = true;
bool InitParameterScene::ui_checkbox_initParameter_useInappV4 = true;
bool InitParameterScene::ui_checkbox_initParameter_useHercules = true;
// static variable ( textfield )
bool InitParameterScene::isFocusedTextField = false;
int InitParameterScene::focusedTextFieldState = 0;
CCRect InitParameterScene::tfArea_InitParameter_appId;
CCRect InitParameterScene::tfArea_InitParameter_serverId;
CCRect InitParameterScene::tfArea_InitParameter_gameLanguage;		// HIVE 1.12.0
CCRect InitParameterScene::tfArea_InitParameter_timeoutSeconds;		// HIVE 1.13.0
CCRect InitParameterScene::tfArea_InitParameter_hiveOrientation;	// HIVE 1.19.6
CCRect InitParameterScene::tfArea_InitParameter_facebookPermissions;	// HIVE 1.19.8
CCRect InitParameterScene::tfArea_InitParameter_channel;	// HIVE 1.20.3
// static variable ( popup )
int InitParameterScene::popValue_initParameter_appId = TAG_POP_INITPARAMETER_APPID_ID1;
	//int InitParameterScene::popValue_initParameter_country = TAG_POP_INITPARAMETER_COUNTRY_ID1;		// 보류된 기능
	//int InitParameterScene::popValue_initParameter_language = TAG_POP_INITPARAMETER_LANGUAGE_ID1;		// 보류된 기능
	//int InitParameterScene::popValue_initParameter_inquiry = TAG_POP_INITPARAMETER_INQUIRY_ID1;		// 보류된 기능

Scene* InitParameterScene::createScene() {
	auto scene = Scene::create();
	auto layer = InitParameterScene::create();
	scene->addChild(layer);
	return scene;
}

bool InitParameterScene::init()
{
	if (!Layer::init()) {
		return false;
	}

	Size visibleSize = Director::getInstance()->getVisibleSize();
	Vec2 origin = Director::getInstance()->getVisibleOrigin();

	log("### InitParameterScene : init() ###");

	// layer 생성
	auto layer = LayerColor::create(Color4B(255, 255, 255, 255));
	layer->setContentSize(Size(visibleSize.width, visibleSize.height));
	layer->setTag(TAG_LAYER_INITPARAMETER);
	this->addChild(layer);

	// button 생성 ( 돌아가기 버튼 )
	InitParameterScene::update_otherButtons(TAG_BTN_PREVIOUS_SCENE);
	// button 생성 ( 설정저장 버튼 )
	InitParameterScene::update_otherButtons(TAG_BTN_INITPARAMETER_SAVEPARAMETER);

	// label 생성 ( 현재 모듈 리스트의 파라미터 리스트 이름 )
	log("### InitParameterScene : create title name label ###");
	layer->addChild(InitParameterScene::createLabels(TAG_LABEL_INITPARAMETER_INITSETTING));

	// label 생성 ( InitParameterScene에 있는 기능에 대한 label들 표시 )
	log("### InitParameterScene : create parameter(option) labels ###");
	InitParameterScene::update_labels();

	// Checkbox 생성
	InitParameterScene::update_checkboxes();

	// TextField 생성
	InitParameterScene::update_textFields();

	// Popup Button 생성
	InitParameterScene::update_popupButtons();

	// android back button 작동을 위함
	this->setKeypadEnabled( true );

	return true;
}

LabelTTF* InitParameterScene::createLabels(int tag)
{
	Size visibleSize = Director::getInstance()->getVisibleSize();
	LabelTTF* label = LabelTTF::create();
	std::string temp = "";

	switch(tag) {
		case TAG_LABEL_INITPARAMETER_INITSETTING : {
			temp = "Init 설정";
			break;
		}
		default : {
			log("### InitParameterScene::createLabels(int tag) error ###");
			break;
		}
	}
	label = LabelTTF::create(temp, "arial.ttf", 20);
	label->setPosition(
			visibleSize.width * InitParameterScene::ui_moduleListNameLabel_x,
			visibleSize.height * InitParameterScene::ui_moduleListNameLabel_y);
	label->setColor(Color3B(0, 0, 0));
	return label;
}

void InitParameterScene::update_otherButtons(int btnType)
{
	Size visibleSize = Director::getInstance()->getVisibleSize();
	Layer *layer = (Layer *)this->getChildByTag(TAG_LAYER_INITPARAMETER);
	switch(btnType) {
		case TAG_BTN_PREVIOUS_SCENE : {
			// previous
			log("### InitParameterScene : create other buttons(previous) ###");
			auto btn = Menu::create(
					InitParameterScene::createButtons(TAG_BTN_PREVIOUS_SCENE),
					NULL);
			btn->setPosition(
					visibleSize.width * InitParameterScene::ui_previousBtn_x,
					visibleSize.height * InitParameterScene::ui_previousBtn_y);
			layer->addChild(btn);
			return;
			break;
		}case TAG_BTN_INITPARAMETER_SAVEPARAMETER : {
			log("### InitParameterScene : create other buttons(save) ###");
			auto btn = Menu::create(
					InitParameterScene::createButtons(TAG_BTN_INITPARAMETER_SAVEPARAMETER),
					NULL);
			btn->setPosition(
					visibleSize.width * InitParameterScene::ui_saveParamBtn_x,
					visibleSize.height * InitParameterScene::ui_saveParamBtn_y);
			layer->addChild(btn);
			break;
		}
		default : {
			// error
			log("### InitParameterScene : create other buttons(error) ###");
			break;
		}
	}
}

MenuItemImage* InitParameterScene::createButtons(int tag)
{
	auto btn = MenuItemImage::create();

	switch(tag) {
		// previous
		case TAG_BTN_PREVIOUS_SCENE : {
			btn = MenuItemImage::create(
					"btn_previous_normal.png", "btn_previous_clicked.png",
					CC_CALLBACK_1(InitParameterScene::buttonEvent, this));
			btn->setScale(0.3f);
			btn->setTag(tag);
			return btn;
			break;
		}case TAG_BTN_INITPARAMETER_SAVEPARAMETER : {
			btn = MenuItemImage::create(
					"btn_saveParameter_normal.png", "btn_saveParameter_clicked.png",
					CC_CALLBACK_1(InitParameterScene::buttonEvent, this));
			//btn->setScale(0.3f);
			btn->setTag(tag);
			return btn;
			break;
		}
		default : {
			btn = MenuItemImage::create(
					"btn_error.png", "btn_error.png",
					CC_CALLBACK_1(InitParameterScene::buttonEvent, this));
			break;
		}
	}
	btn->setTag(tag);
	return btn;
}

void InitParameterScene::buttonEvent(Ref *sender)
{
	if(InitParameterScene::ui_isOpenedWindow == true)	// 중복 클릭 방지
		return;

	auto btn = (MenuItem*) sender;

	switch(btn->getTag()) {
		case TAG_BTN_PREVIOUS_SCENE : {
            Director::getInstance()->getScheduler()->performFunctionInCocosThread([=]()->void{
                auto scene = TransitionFadeTR::create(1.0, InitListScene::createScene());
                Director::getInstance()->replaceScene(scene);
            });
			break;
		}case TAG_BTN_INITPARAMETER_SAVEPARAMETER : {
			InitParameterScene::saveParamValue();
			// QA 로그 출력
			Layer *layer = (Layer *)this->getChildByTag(TAG_LAYER_INITPARAMETER);
			layer->removeChildByTag(TAG_LABEL_QALOG, true);
			layer->addChild(LogController::createQALog(
					LogController::getQALog(
							TAG_LABEL_QALOG_INITPARAMETER, false)));
			break;
		}
		default : {
			break;
		}
	}
}

void InitParameterScene::update_labels()
{
	Size visibleSize = Director::getInstance()->getVisibleSize();
	Layer *layer = (Layer *)this->getChildByTag(TAG_LAYER_INITPARAMETER);

	auto labels = Menu::create();
	log("### InitParameterScene::update_labels ###");
	// (1) ShowLog
	labels = Menu::create(
			InitParameterScene::createParamLabels(TAG_LABEL_INITPARAMETER_SHOWLOG),
			NULL);
	labels->setPosition(
			visibleSize.width * InitParameterScene::ui_paramLabel_x,
			visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 0)));
	layer->addChild(labels);
	// (2) AppId
	labels = Menu::create(
			InitParameterScene::createParamLabels(TAG_LABEL_INITPARAMETER_APPID),
			NULL);
	labels->setPosition(
			visibleSize.width * InitParameterScene::ui_paramLabel_x,
			visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 1)));
	layer->addChild(labels);
	// (3) PermissionWriteExternalStorage
	labels = Menu::create(
			InitParameterScene::createParamLabels(TAG_LABEL_INITPARAMETER_PERMISSIONWRITE),
			NULL);
	labels->setPosition(
			visibleSize.width * InitParameterScene::ui_paramLabel_x,
			visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 3.5)));		// 두불로 표시됨.
	layer->addChild(labels);
	// (3) FacebookPermissions
	labels = Menu::create(
			InitParameterScene::createParamLabels(TAG_LABEL_INITPARAMETER_FACEBOOK_PERMISSIONS),
			NULL);
	labels->setPosition(
			visibleSize.width * InitParameterScene::ui_paramLabel_x,
			visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 5)));
	layer->addChild(labels);
	// (4) ServerId
	labels = Menu::create(
			InitParameterScene::createParamLabels(TAG_LABEL_INITPARAMETER_SERVERID),
			NULL);
	labels->setPosition(
			visibleSize.width * InitParameterScene::ui_paramLabel_x,
			visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 6)));
	layer->addChild(labels);
	/*
	// 보류된 기능들
	// (5) Country
	labels = Menu::create(
			InitParameterScene::createParamLabels(TAG_LABEL_INITPARAMETER_COUNTRY),
			NULL);
	labels->setPosition(
			visibleSize.width * InitParameterScene::ui_paramLabel_x,
			visibleSize.height * (0.75 - (0.05 * 6)));
	layer->addChild(labels);
	// (6) Language
	labels = Menu::create(
			InitParameterScene::createParamLabels(TAG_LABEL_INITPARAMETER_LANGUAGE),
			NULL);
	labels->setPosition(
			visibleSize.width * InitParameterScene::ui_paramLabel_x,
			visibleSize.height * (0.75 - (0.05 * 7)));
	layer->addChild(labels);
	// (7) Inquiry
	labels = Menu::create(
			InitParameterScene::createParamLabels(TAG_LABEL_INITPARAMETER_INQUIRY),
			NULL);
	labels->setPosition(
			visibleSize.width * InitParameterScene::ui_paramLabel_x,
			visibleSize.height * (0.75 - (0.05 * 8)));
	*/
	// (8) ShowNotice
	labels = Menu::create(
			InitParameterScene::createParamLabels(TAG_LABEL_INITPARAMETER_SHOWNOTICE),
			NULL);
	labels->setPosition(
			visibleSize.width * InitParameterScene::ui_paramLabel_x,
			visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 7)));
	layer->addChild(labels);
	// (9) HIVE IAP
//	labels = Menu::create(
//			InitParameterScene::createParamLabels(TAG_LABEL_INITPARAMETER_HIVEIAP),
//			NULL);
//	labels->setPosition(
//			visibleSize.width * InitParameterScene::ui_paramLabel_x,
//			visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 5)));
//	layer->addChild(labels);
	// (10) OneStore
	labels = Menu::create(
			InitParameterScene::createParamLabels(TAG_LABEL_INITPARAMETER_USEONESTORE),
			NULL);
	labels->setPosition(
			visibleSize.width * InitParameterScene::ui_paramLabel_x,
			visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 8)));
	layer->addChild(labels);
	// (11) HIVE Promotion		// HIVE 1.12.0
	labels = Menu::create(
			InitParameterScene::createParamLabels(TAG_LABEL_INITPARAMETER_HIVEPROMOTION),
			NULL);
	labels->setPosition(
			visibleSize.width * InitParameterScene::ui_paramLabel_x,
			visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 9)));
	layer->addChild(labels);
	// (12) Game Language		// HIVE 1.12.0
	labels = Menu::create(
			InitParameterScene::createParamLabels(TAG_LABEL_INITPARAMETER_GAMELANGUAGE),
			NULL);
	labels->setPosition(
			visibleSize.width * InitParameterScene::ui_paramLabel_x,
			visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 10)));
	layer->addChild(labels);
	// (13) timeoutSeconds		// HIVE 1.13.0
	labels = Menu::create(
			InitParameterScene::createParamLabels(TAG_LABEL_INITPARAMETER_TIMEOUTSECONDS),
			NULL);
	labels->setPosition(
			visibleSize.width * InitParameterScene::ui_paramLabel_x,
			visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 11)));
	layer->addChild(labels);
    // (14) useGalaxyStore		// HIVE 1.17.2
    labels = Menu::create(
            InitParameterScene::createParamLabels(TAG_LABEL_INITPARAMETER_USEGALAXYSTORE),
            NULL);
    labels->setPosition(
            visibleSize.width * InitParameterScene::ui_paramLabel_x,
            visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 12)));
    layer->addChild(labels);
    // (15) showPermissionView		// HIVE 1.17.2
    labels = Menu::create(
            InitParameterScene::createParamLabels(TAG_LABEL_INITPARAMETER_SHOWPERMISSIONVIEW),
            NULL);
    labels->setPosition(
            visibleSize.width * InitParameterScene::ui_paramLabel_x,
            visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 13)));
    layer->addChild(labels);
	// (16) useImageBanner		// HIVE 1.18.1
	labels = Menu::create(
			InitParameterScene::createParamLabels(TAG_LABEL_INITPARAMETER_MERCURY_INIT_EX),
			NULL);
	labels->setPosition(
			visibleSize.width * InitParameterScene::ui_paramLabel_x,
			visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 14)));
	layer->addChild(labels);
	// (17) useInappV4		// HIVE 1.18.4
//	labels = Menu::create(
//			InitParameterScene::createParamLabels(TAG_LABEL_INITPARAMETER_USE_INAPPV4),
//			NULL);
	// (17) useHercules		// Hive 1.20.2 - InAppV4는 기본 사용이므로 InAppV4를 Hercules로 변경하여 사용
	labels = Menu::create(
			InitParameterScene::createParamLabels(TAG_LABEL_INITPARAMETER_USE_HERCULES),
			NULL);
	labels->setPosition(
			visibleSize.width * InitParameterScene::ui_paramLabel_x,
			visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 15)));
	layer->addChild(labels);
	// (18) hive orientation		// HIVE 1.19.6
	labels = Menu::create(
			InitParameterScene::createParamLabels(TAG_LABEL_INITPARAMETER_HIVE_ORIENTATION),
			NULL);
	labels->setPosition(
			visibleSize.width * InitParameterScene::ui_paramLabel_x,
			visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 16)));
	layer->addChild(labels);
	// (19) Channel
	labels = Menu::create(
			InitParameterScene::createParamLabels(TAG_LABEL_INITPARAMETER_CHANNEL),
			NULL);
	labels->setPosition(
			visibleSize.width * InitParameterScene::ui_paramLabel_x,
			visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 17)));
	layer->addChild(labels);
}

MenuItemLabel* InitParameterScene::createParamLabels(int tag)
{
	auto label = Label::create();
	int textSize = 10;

	switch(tag) {
		case TAG_LABEL_INITPARAMETER_SHOWLOG : {
			label = Label::createWithSystemFont("showLog :", "arial.ttf", textSize);			// push register
			break;
		}case TAG_LABEL_INITPARAMETER_APPID : {
			label = Label::createWithSystemFont("appId :", "arial.ttf", textSize);
			break;
		}
		case TAG_LABEL_INITPARAMETER_PERMISSIONWRITE : {
			label = Label::createWithSystemFont("PermissionWrite\nExternalStorage :", "arial.ttf", textSize);
			break;
		}
		case TAG_LABEL_INITPARAMETER_FACEBOOK_PERMISSIONS : {
			label = Label::createWithSystemFont("facebookPermissions :", "arial.ttf", textSize);
			break;
		}
		case TAG_LABEL_INITPARAMETER_SERVERID : {
			label = Label::createWithSystemFont("serverId :", "arial.ttf", textSize);
			break;
		}
		/*
		case TAG_LABEL_INITPARAMETER_COUNTRY : {
			label = Label::createWithSystemFont("Country :", "arial.ttf", 60);
			break;
		}case TAG_LABEL_INITPARAMETER_LANGUAGE : {
			label = Label::createWithSystemFont("Language :", "arial.ttf", 60);
			break;
		}case TAG_LABEL_INITPARAMETER_INQUIRY : {
			label = Label::createWithSystemFont("Inquiry :", "arial.ttf", 60);
			break;
		}
		*/
		case TAG_LABEL_INITPARAMETER_SHOWNOTICE : {
			label = Label::createWithSystemFont("showNotice :", "arial.ttf", textSize);
			break;
		}
//		case TAG_LABEL_INITPARAMETER_HIVEIAP : {
//			label = Label::createWithSystemFont("useWhiteDomain :", "arial.ttf", textSize);
//			break;
//		}
		case TAG_LABEL_INITPARAMETER_USEONESTORE : {									// HIVE 1.11.0
			label = Label::createWithSystemFont("useOneStore :", "arial.ttf",textSize);
			break;
		}case TAG_LABEL_INITPARAMETER_HIVEPROMOTION : {									// HIVE 1.12.0
			label = Label::createWithSystemFont("HIVE Promotion :", "arial.ttf",textSize);
			break;
		}case TAG_LABEL_INITPARAMETER_GAMELANGUAGE : {									// HIVE 1.12.0
			label = Label::createWithSystemFont("Game Language :", "arial.ttf",textSize);
			break;
		}case TAG_LABEL_INITPARAMETER_TIMEOUTSECONDS : {								// HIVE 1.13.0
			label = Label::createWithSystemFont("timeoutSeconds :", "arial.ttf",textSize);
			break;
		}case TAG_LABEL_INITPARAMETER_USEGALAXYSTORE : {									// HIVE 1.17.2
			label = Label::createWithSystemFont("useGalaxyStore :", "arial.ttf",textSize);
			break;
		}case TAG_LABEL_INITPARAMETER_SHOWPERMISSIONVIEW : {								// HIVE 1.17.2
			label = Label::createWithSystemFont("showPermission :", "arial.ttf",textSize);
			break;
		}case TAG_LABEL_INITPARAMETER_MERCURY_INIT_EX : {									// HIVE 1.18.1
			label = Label::createWithSystemFont("useImageBanner :", "arial.ttf",textSize);
			break;
		}case TAG_LABEL_INITPARAMETER_USE_INAPPV4 : {									// HIVE 1.18.4
			label = Label::createWithSystemFont("useInappV4 :", "arial.ttf",textSize);
			break;
		}case TAG_LABEL_INITPARAMETER_HIVE_ORIENTATION : {								// HIVE 1.19.6
			label = Label::createWithSystemFont("hiveOrientation :", "arial.ttf",textSize);
			break;
		}case TAG_LABEL_INITPARAMETER_USE_HERCULES : {								// Hive 1.20.2
			label = Label::createWithSystemFont("useHercules :", "arial.ttf",textSize);
			break;
		}case TAG_LABEL_INITPARAMETER_CHANNEL : {
			label = Label::createWithSystemFont("channel :", "arial.ttf", textSize);
			break;
		}
		default : {
			log("### InitParameterScene::createParamLabels(int tag) error ###");
			break;
		}
	}
	label->setColor(Color3B(0, 0, 0));

	auto item = MenuItemLabel::create(label, CC_CALLBACK_1(InitParameterScene::labelEvent, this));
	item->setTag(tag);
	return item;
}

void InitParameterScene::labelEvent(Ref *sender)
{
	auto label = (MenuItem*) sender;

	switch(label->getTag()) {
		default : {
			// no event
			break;
		}
	}
}

// 체크 박스 생성
void InitParameterScene::update_checkboxes()
{
	Size visibleSize = Director::getInstance()->getVisibleSize();
	Layer *layer = (Layer *)this->getChildByTag(TAG_LAYER_INITPARAMETER);

	auto checkbox = Menu::create();
	log("### InitParameterScene::update_checkboxes ###");
	// (1) ShowLog
	checkbox = Menu::create(
			InitParameterScene::createCheckboxes(TAG_CB_INITPARAMETER_SHOWLOG),
			NULL);
	checkbox->setPosition(Point(visibleSize.width * InitParameterScene::ui_checkbox_x,
			visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 0))));
	//popupBtn->setTag(TAG_POP_PARAMETER_LIST);
	layer->addChild(checkbox);
	// (3) PermissionWriteExternalStorage
	checkbox = Menu::create(
			InitParameterScene::createCheckboxes(TAG_CB_INITPARAMETER_PERMISSIONWRITE),
			NULL);
	checkbox->setPosition(Point(visibleSize.width * InitParameterScene::ui_checkbox_x,
			visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 4))));
//	popupBtn->setTag(TAG_POP_PARAMETER_LIST);
	layer->addChild(checkbox);
	// (8) showNotice
	checkbox = Menu::create(
			InitParameterScene::createCheckboxes(TAG_CB_INITPARAMETER_SHOWNOTICE),
			NULL);
	checkbox->setPosition(Point(visibleSize.width * InitParameterScene::ui_checkbox_x,
			visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 7))));
	layer->addChild(checkbox);
	// (9) HIVE IAP
//	checkbox = Menu::create(
//			InitParameterScene::createCheckboxes(TAG_CB_INITPARAMETER_HIVEIAP),
//			NULL);
//	checkbox->setPosition(Point(visibleSize.width * InitParameterScene::ui_checkbox_x,
//			visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 5))));
//	layer->addChild(checkbox);
	// (10) useOneStore
	checkbox = Menu::create(
			InitParameterScene::createCheckboxes(TAG_CB_INITPARAMETER_USEONESTORE),
			NULL);
	checkbox->setPosition(Point(visibleSize.width * InitParameterScene::ui_checkbox_x,
			visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 8))));
	layer->addChild(checkbox);
	// (11) HIVE Promotion		// HIVE 1.12.0
	checkbox = Menu::create(
			InitParameterScene::createCheckboxes(TAG_CB_INITPARAMETER_HIVEPROMOTION),
			NULL);
	checkbox->setPosition(Point(visibleSize.width * InitParameterScene::ui_checkbox_x,
			visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 9))));
	layer->addChild(checkbox);
	// (12) useGalaxy			// HIVE 1.17.2
	checkbox = Menu::create(
			InitParameterScene::createCheckboxes(TAG_CB_INITPARAMETER_USEGALAXYSTORE),
			NULL);
	checkbox->setPosition(Point(visibleSize.width * InitParameterScene::ui_checkbox_x,
								visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 12))));
	layer->addChild(checkbox);
	// (13) showPermissionView		// HIVE 1.17.2
	checkbox = Menu::create(
			InitParameterScene::createCheckboxes(TAG_CB_INITPARAMETER_SHOWPERMISSIONVIEW),
			NULL);
	checkbox->setPosition(Point(visibleSize.width * InitParameterScene::ui_checkbox_x,
								visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 13))));
	layer->addChild(checkbox);
	// (14) useImageBanner		// HIVE 1.18.1
	checkbox = Menu::create(
			InitParameterScene::createCheckboxes(TAG_CB_INITPARAMETER_MERCURY_INIT_EX),
			NULL);
	checkbox->setPosition(Point(visibleSize.width * InitParameterScene::ui_checkbox_x,
								visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 14))));
	layer->addChild(checkbox);
	// (15) useInappV4			// HIVE 1.18.4
//	checkbox = Menu::create(
//			InitParameterScene::createCheckboxes(TAG_CB_INITPARAMETER_USE_INAPPV4),
//			NULL);
	// (15) useHercules		// Hive 1.20.2 - InAppV4는 기본 사용이므로 InAppV4를 Hercules로 변경하여 사용
	checkbox = Menu::create(
			InitParameterScene::createCheckboxes(TAG_CB_INITPARAMETER_USE_HERCULES),
			NULL);
	checkbox->setPosition(Point(visibleSize.width * InitParameterScene::ui_checkbox_x,
								visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 15))));
	layer->addChild(checkbox);
}

MenuItemToggle* InitParameterScene::createCheckboxes(int tag)
{
	auto checkbox_usePush_on_1 = Sprite::create("check_box_active.png");
	auto checkbox_usePush_on_2 = Sprite::create("check_box_active_press.png");
	auto checkbox_usePush_on = MenuItemSprite::create(checkbox_usePush_on_1, checkbox_usePush_on_2);
	auto checkbox_usePush_off_1 = Sprite::create("check_box_normal.png");
	auto checkbox_usePush_off_2 = Sprite::create("check_box_normal_press.png");
	auto checkbox_usePush_off = MenuItemSprite::create(checkbox_usePush_off_1, checkbox_usePush_off_2);
	auto checkboxItem = MenuItemToggle::createWithCallback(
			CC_CALLBACK_1(InitParameterScene::ToggleEvent, this),
			checkbox_usePush_on, checkbox_usePush_off, NULL);
	checkboxItem->setTag(tag);
	checkboxItem->setSelectedIndex(InitParameterScene::setCheckbox(tag));
	checkboxItem->setScale(1.5f);
	return checkboxItem;
}

void InitParameterScene::ToggleEvent(Ref* sender)
{
	auto checkbox = (MenuItemToggle*) sender;

	switch(checkbox->getTag()) {
		case TAG_CB_INITPARAMETER_SHOWLOG : {			// (1) ShowLog
			if(checkbox->getSelectedIndex() == 1) {
				InitParameterScene::ui_checkbox_initParameter_showLog = false;
			}
			else if(checkbox->getSelectedIndex() == 0) {
				InitParameterScene::ui_checkbox_initParameter_showLog = true;
			}
			break;
		}
		case TAG_CB_INITPARAMETER_PERMISSIONWRITE : {	// (3) PermissionWrite
			if(checkbox->getSelectedIndex() == 1) {
				InitParameterScene::ui_checkbox_initParameter_permissionWrite = false;
			}
			else if(checkbox->getSelectedIndex() == 0) {
				InitParameterScene::ui_checkbox_initParameter_permissionWrite = true;
			}
			break;
		}
		case TAG_CB_INITPARAMETER_SHOWNOTICE : {		// (8) showNotice
			if(checkbox->getSelectedIndex() == 1) {
				InitParameterScene::ui_checkbox_initParameter_showNotice = false;
			}
			else if(checkbox->getSelectedIndex() == 0) {
				InitParameterScene::ui_checkbox_initParameter_showNotice = true;
			}
			break;
		}
//		case TAG_CB_INITPARAMETER_HIVEIAP : {			// (9) HIVE IAP
//			if(checkbox->getSelectedIndex() == 1) {
//				InitParameterScene::ui_checkbox_initParameter_HiveIAP = false;
//			}
//			else if(checkbox->getSelectedIndex() == 0) {
//				InitParameterScene::ui_checkbox_initParameter_HiveIAP = true;
//			}
//			break;
//		}
		case TAG_CB_INITPARAMETER_USEONESTORE : {		// (10) One Store
			if(checkbox->getSelectedIndex() == 1) {
				InitParameterScene::ui_checkbox_initParameter_useOneStore = false;
			}
			else if(checkbox->getSelectedIndex() == 0) {
				InitParameterScene::ui_checkbox_initParameter_useOneStore = true;
			}
			break;
		}case TAG_CB_INITPARAMETER_HIVEPROMOTION : {	// (11) HIVE Promotion
			if(checkbox->getSelectedIndex() == 1) {
				InitParameterScene::ui_checkbox_initParameter_hivePromotion = false;
			}
			else if(checkbox->getSelectedIndex() == 0) {
				InitParameterScene::ui_checkbox_initParameter_hivePromotion = true;
			}
			break;
		}case TAG_CB_INITPARAMETER_USEGALAXYSTORE : {		// (12) Galaxy Store
			if(checkbox->getSelectedIndex() == 1) {
				InitParameterScene::ui_checkbox_initParameter_useGalaxyStore = false;
			}
			else if(checkbox->getSelectedIndex() == 0) {
				InitParameterScene::ui_checkbox_initParameter_useGalaxyStore = true;
			}
			break;
		}case TAG_CB_INITPARAMETER_SHOWPERMISSIONVIEW : {	// (13) Show Permission View
			if(checkbox->getSelectedIndex() == 1) {
				InitParameterScene::ui_checkbox_initParameter_showPermissionView = false;
			}
			else if(checkbox->getSelectedIndex() == 0) {
				InitParameterScene::ui_checkbox_initParameter_showPermissionView = true;
			}
			break;
		}case TAG_CB_INITPARAMETER_MERCURY_INIT_EX : {
			if(checkbox->getSelectedIndex() == 1) {
				InitParameterScene::ui_checkbox_initParameter_useImageBanner = false;
			}
			else if(checkbox->getSelectedIndex() == 0) {
				InitParameterScene::ui_checkbox_initParameter_useImageBanner = true;
			}
			break;
		}case TAG_CB_INITPARAMETER_USE_INAPPV4 : {
			if(checkbox->getSelectedIndex() == 1) {
				InitParameterScene::ui_checkbox_initParameter_useInappV4 = false;
			}
			else if(checkbox->getSelectedIndex() == 0) {
				InitParameterScene::ui_checkbox_initParameter_useInappV4 = true;
			}
			break;
		}case TAG_CB_INITPARAMETER_USE_HERCULES : {
			if(checkbox->getSelectedIndex() == 1) {
				InitParameterScene::ui_checkbox_initParameter_useHercules = false;
			}
			else if(checkbox->getSelectedIndex() == 0) {
				InitParameterScene::ui_checkbox_initParameter_useHercules = true;
			}
			break;
		}
		default :
			break;
	}
}

int InitParameterScene::setCheckbox(int tag)
{
	//MenuItemToggle *checkbox = (MenuItemToggle *)this->getChildByTag(tag);
	log("### InitParameterScene::setCheckbox ###");

	switch (tag) {
		case TAG_CB_INITPARAMETER_SHOWLOG : {
			if(DataManager::getParamValue_bool(TAG_APIACTION_INITIALIZE, "showLog")) {
				log("##### SHOWLOG TRUE!!!! #####");
				return 0;
			} else {
				log("##### SHOWLOG FALSE!!!! #####");
				return 1;
			}
			break;
		}
		case TAG_CB_INITPARAMETER_PERMISSIONWRITE : {
			if(DataManager::getParamValue_bool(TAG_APIACTION_INITIALIZE, "permissionWriteExternalStorage")) {
				log("##### PERMISSIONWRITE TRUE!!!! #####");
				return 0;
			} else {
				log("##### PERMISSIONWRITE FALSE!!!! #####");
				return 1;
			}
			break;
		}
		case TAG_CB_INITPARAMETER_SHOWNOTICE : {
			if(DataManager::getParamValue_bool(TAG_APIACTION_INITIALIZE, "showNotice")) {
				log("##### SHOWNOTICE TRUE!!!! #####");
				return 0;
			} else {
				log("##### SHOWNOTICE FALSE!!!! #####");
				return 1;
			}
			break;
		}
//		case TAG_CB_INITPARAMETER_HIVEIAP : {
//			if(DataManager::getParamValue_bool(TAG_APIACTION_INITIALIZE, "HIVEIAP")) {
//				log("##### HIVEIAP TRUE!!!! #####");
//				return 0;
//			} else {
//				log("##### HIVEIAP FALSE!!!! #####");
//				return 1;
//			}
//			break;
//		}
		case TAG_CB_INITPARAMETER_USEONESTORE : {
			if(DataManager::getParamValue_bool(TAG_APIACTION_INITIALIZE, "useOneStore")) {
				log("##### OneStore TRUE!!!! #####");
				return 0;
			} else {
				log("##### OneStore FALSE!!!! #####");
				return 1;
			}
			break;
		}case TAG_CB_INITPARAMETER_HIVEPROMOTION : {		// HIVE 1.12.0
			if(DataManager::getParamValue_bool(TAG_APIACTION_INITIALIZE, "HivePromotion")) {
				log("##### HIVE Promotion TRUE!!!! #####");
				return 0;
			} else {
				log("##### HIVE Promotion FALSE!!!! #####");
				return 1;
			}
			break;
		}case TAG_CB_INITPARAMETER_USEGALAXYSTORE : {		// HIVE 1.17.2
			if(DataManager::getParamValue_bool(TAG_APIACTION_INITIALIZE, "useGalaxyStore")) {
				log("##### USEGALAXYSTORE TRUE!!!! #####");
				return 0;
			} else {
				log("##### USEGALAXYSTORE FALSE!!!! #####");
				return 1;
			}
			break;
		}case TAG_CB_INITPARAMETER_SHOWPERMISSIONVIEW : {		// HIVE 1.17.2
			if(DataManager::getParamValue_bool(TAG_APIACTION_INITIALIZE, "showPermissionView")) {
				log("##### HOWPERMISSIONVIEW TRUE!!!! #####");
				return 0;
			} else {
				log("##### HOWPERMISSIONVIEW FALSE!!!! #####");
				return 1;
			}
			break;
		}case TAG_CB_INITPARAMETER_MERCURY_INIT_EX : {		// HIVE 1.18.1
			if(DataManager::getParamValue_bool(TAG_APIACTION_INITIALIZE, "useImageBanner")) {
				log("##### HIVE useImageBanner TRUE!!!! #####");
				return 0;
			} else {
				log("##### HIVE useImageBanner FALSE!!!! #####");
				return 1;
			}
			break;
		}case TAG_CB_INITPARAMETER_USE_INAPPV4 : {		// HIVE 1.18.1
			if(DataManager::getParamValue_bool(TAG_APIACTION_INITIALIZE, "useInappV4")) {
				log("##### use InappV4 TRUE!!!! #####");
				return 0;
			} else {
				log("##### use InappV4 FALSE!!!! #####");
				return 1;
			}
			break;
		}case TAG_CB_INITPARAMETER_USE_HERCULES : {		// Hive 1.20.2
			if(DataManager::getParamValue_bool(TAG_APIACTION_INITIALIZE, "useHercules")) {
				log("##### use useHercules TRUE!!!! #####");
				return 0;
			} else {
				log("##### use useHercules FALSE!!!! #####");
				return 1;
			}
			break;
		}
	}
	return 2;
}

// 설정 저장 버튼 터치 (활성)
void InitParameterScene::saveParamValue()
{
	log("### saveParamValue(InitParameter) start ###");
	// checkbox
	DataManager::setParamValue_bool(TAG_APIACTION_INITIALIZE, "showLog",
			InitParameterScene::ui_checkbox_initParameter_showLog);
	DataManager::setParamValue_bool(TAG_APIACTION_INITIALIZE, "permissionWriteExternalStorage",
			InitParameterScene::ui_checkbox_initParameter_permissionWrite);
	DataManager::setParamValue_bool(TAG_APIACTION_INITIALIZE, "showNotice",
			InitParameterScene::ui_checkbox_initParameter_showNotice);
//	DataManager::setParamValue_bool(TAG_APIACTION_INITIALIZE, "HIVEIAP",
//			InitParameterScene::ui_checkbox_initParameter_HiveIAP);
	DataManager::setParamValue_bool(TAG_APIACTION_INITIALIZE, "useOneStore",
			InitParameterScene::ui_checkbox_initParameter_useOneStore);
	DataManager::setParamValue_bool(TAG_APIACTION_INITIALIZE, "HivePromotion",
			InitParameterScene::ui_checkbox_initParameter_hivePromotion);				// HIVE 1.12.0
	DataManager::setParamValue_bool(TAG_APIACTION_INITIALIZE, "useGalaxyStore",
			InitParameterScene::ui_checkbox_initParameter_useGalaxyStore);					// HIVE 1.17.2
	DataManager::setParamValue_bool(TAG_APIACTION_INITIALIZE, "showPermissionView",
			InitParameterScene::ui_checkbox_initParameter_showPermissionView);				// HIVE 1.17.2
	DataManager::setParamValue_bool(TAG_APIACTION_INITIALIZE, "useImageBanner",
			InitParameterScene::ui_checkbox_initParameter_useImageBanner);				// HIVE 1.17.2
    DataManager::setParamValue_bool(TAG_APIACTION_INITIALIZE, "useInappV4",
            InitParameterScene::ui_checkbox_initParameter_useInappV4);				// HIVE 1.17.2
	DataManager::setParamValue_bool(TAG_APIACTION_INITIALIZE, "useHercules",
				  InitParameterScene::ui_checkbox_initParameter_useHercules);				// Hive 1.20.2
	// textfield
	std::string strTemp;
	TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_INITPARAMETER_FACEBOOK_PERMISSIONS);
	strTemp = temp_tf->getString();
	if(temp_tf->getString() == "") {	// textfield blank test
		log("### textfield is (%d) ===> blank ###", TAG_TF_INITPARAMETER_FACEBOOK_PERMISSIONS);
		DataManager::setParamValue_string(TAG_APIACTION_INITIALIZE, "facebookPermissions", "");	// 공백값을 설정.
	} else {
		DataManager::setParamValue_string(TAG_APIACTION_INITIALIZE, "facebookPermissions", temp_tf->getString());
	}
	temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_INITPARAMETER_SERVERID);
	strTemp = temp_tf->getString();
	if(temp_tf->getString() == "") {	// textfield blank test
		log("### textfield is (%d) ===> blank ###", TAG_TF_INITPARAMETER_SERVERID);
		DataManager::setParamValue_string(TAG_APIACTION_INITIALIZE, "serverId", "");	// 공백값을 설정.
	} else {
		DataManager::setParamValue_string(TAG_APIACTION_INITIALIZE, "serverId", temp_tf->getString());
	}
	temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_INITPARAMETER_APPID);
	strTemp = temp_tf->getString();
	if(temp_tf->getString() == "") {	// textfield blank test
		log("### textfield is (%d) ===> blank ###", TAG_TF_INITPARAMETER_APPID);
		DataManager::setParamValue_string(TAG_APIACTION_INITIALIZE, "appId", "");		// 공백값을 설정.
	} else {
		DataManager::setParamValue_string(TAG_APIACTION_INITIALIZE, "appId", temp_tf->getString());
	}
	temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_INITPARAMETER_GAMELANGUAGE);
	strTemp = temp_tf->getString();
	if(temp_tf->getString() == "") {	// textfield blank test
		log("### textfield is (%d) ===> blank ###", TAG_TF_INITPARAMETER_GAMELANGUAGE);
		DataManager::setParamValue_string(TAG_APIACTION_INITIALIZE, "gameLanguage", "");	// 공백값을 설정.
	} else {
		DataManager::setParamValue_string(TAG_APIACTION_INITIALIZE, "gameLanguage", temp_tf->getString());
	}
	temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_INITPARAMETER_TIMEOUTSECONDS);
	strTemp = temp_tf->getString();
	if(temp_tf->getString() == "") {	// textfield blank test
		log("### textfield is (%d) ===> blank ###", TAG_TF_INITPARAMETER_TIMEOUTSECONDS);
		DataManager::setParamValue_string(TAG_APIACTION_INITIALIZE, "timeoutSeconds", "");	// 공백값을 설정.
	} else {
		DataManager::setParamValue_string(TAG_APIACTION_INITIALIZE, "timeoutSeconds", temp_tf->getString());
	}
	temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_INITPARAMETER_HIVE_ORIENTATION);
	strTemp = temp_tf->getString();
	if(temp_tf->getString() == "") {	// textfield blank test
		log("### textfield is (%d) ===> blank ###", TAG_TF_INITPARAMETER_HIVE_ORIENTATION);
		DataManager::setParamValue_string(TAG_APIACTION_INITIALIZE, "hiveOrientation", "");	// 공백값을 설정.
	} else {
		DataManager::setParamValue_string(TAG_APIACTION_INITIALIZE, "hiveOrientation", temp_tf->getString());
	}
	temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_INITPARAMETER_CHANNEL);
	strTemp = temp_tf->getString();
	if(temp_tf->getString() == "") {	// textfield blank test
		log("### textfield is (%d) ===> blank ###", TAG_TF_INITPARAMETER_CHANNEL);
		DataManager::setParamValue_string(TAG_APIACTION_INITIALIZE, "channel", "");	// 공백값을 설정.
	} else {
		DataManager::setParamValue_string(TAG_APIACTION_INITIALIZE, "channel", temp_tf->getString());
	}
	// popup
	/*
	if(InitParameterScene::popValue_initParameter_appId == TAG_POP_INITPARAMETER_APPID_ID1) {
		strTemp = "appId_1";
	} else if(InitParameterScene::popValue_initParameter_appId == TAG_POP_INITPARAMETER_APPID_ID2) {
		strTemp = "appId_2";
	} else if(InitParameterScene::popValue_initParameter_appId == TAG_POP_INITPARAMETER_APPID_ID3) {
		strTemp = "appId_3";
	}
	*/
	/*
	DataManager::setParamValue_string(TAG_APIACTION_INITIALIZE, "appId", strTemp);
	if(InitParameterScene::popValue_initParameter_country == TAG_POP_INITPARAMETER_COUNTRY_ID1) {
		strTemp = "country_1";
	} else if(InitParameterScene::popValue_initParameter_country == TAG_POP_INITPARAMETER_COUNTRY_ID2) {
		strTemp = "country_2";
	} else if(InitParameterScene::popValue_initParameter_country == TAG_POP_INITPARAMETER_COUNTRY_ID3) {
		strTemp = "country_3";
	}
	DataManager::setParamValue_string(TAG_APIACTION_INITIALIZE, "country", strTemp);
	if(InitParameterScene::popValue_initParameter_language == TAG_POP_INITPARAMETER_LANGUAGE_ID1) {
		strTemp = "language_1";
	} else if(InitParameterScene::popValue_initParameter_language == TAG_POP_INITPARAMETER_LANGUAGE_ID2) {
		strTemp = "language_2";
	} else if(InitParameterScene::popValue_initParameter_language == TAG_POP_INITPARAMETER_LANGUAGE_ID3) {
		strTemp = "language_3";
	}
	DataManager::setParamValue_string(TAG_APIACTION_INITIALIZE, "language", strTemp);
	if(InitParameterScene::popValue_initParameter_inquiry == TAG_POP_INITPARAMETER_INQUIRY_ID1) {
		strTemp = "inquiry_1";
	} else if(InitParameterScene::popValue_initParameter_inquiry == TAG_POP_INITPARAMETER_INQUIRY_ID2) {
		strTemp = "inquiry_2";
	} else if(InitParameterScene::popValue_initParameter_inquiry == TAG_POP_INITPARAMETER_INQUIRY_ID3) {
		strTemp = "inquiry_3";
	}
	DataManager::setParamValue_string(TAG_APIACTION_INITIALIZE, "inquiry", strTemp);
	*/

	log("### saveParamValue(InitParameter) success ###");
}

void InitParameterScene::update_textFields()
{
	Size visibleSize = Director::getInstance()->getVisibleSize();

	InitParameterScene::createTextFields(TAG_TF_INITPARAMETER_APPID,
			(0.75 - (InitParameterScene::ui_paddingSize_y * 2)));
	InitParameterScene::createTextFields(TAG_TF_INITPARAMETER_FACEBOOK_PERMISSIONS,
						 (0.75 - (InitParameterScene::ui_paddingSize_y * 5)));
	InitParameterScene::createTextFields(TAG_TF_INITPARAMETER_SERVERID,
			(0.75 - (InitParameterScene::ui_paddingSize_y * 6)));
	InitParameterScene::createTextFields(TAG_TF_INITPARAMETER_GAMELANGUAGE,
			(0.75 - (InitParameterScene::ui_paddingSize_y * 10)));
	InitParameterScene::createTextFields(TAG_TF_INITPARAMETER_TIMEOUTSECONDS,
			(0.75 - (InitParameterScene::ui_paddingSize_y * 11)));
	InitParameterScene::createTextFields(TAG_TF_INITPARAMETER_HIVE_ORIENTATION,
			 (0.75 - (InitParameterScene::ui_paddingSize_y * 16)));
	InitParameterScene::createTextFields(TAG_TF_INITPARAMETER_CHANNEL,
										 (0.75 - (InitParameterScene::ui_paddingSize_y * 17)));
}

void InitParameterScene::createTextFields(int tag, float textFieldPos_y)
{
	Size visibleSize = Director::getInstance()->getVisibleSize();

	TextFieldTTF* textField = cocos2d::TextFieldTTF::textFieldWithPlaceHolder("input here!",
			cocos2d::Size(130, 17), TextHAlignment::LEFT, "arial.ttf", Parameter::paramSampleSetting.normalFontSize+5);
	textField->setPosition(
			Point(visibleSize.width * InitParameterScene::ui_textField_x,
					visibleSize.height * textFieldPos_y));
	textField->setColor(ccc3(0, 0, 255));
	textField->setColorSpaceHolder(Color3B::BLUE);
	textField->setTag(tag);
	textField->setDelegate(this);
	this->addChild(textField);
	//Layer *layer = (Layer *)this->getChildByTag(TAG_LAYER_PARAMETER_LIST);
	//layer->addChild(textField);

	auto touchListener = EventListenerTouchOneByOne::create();

	switch(tag) {
			case TAG_TF_INITPARAMETER_APPID : {
				textField->setString(DataManager::getParamValue(TAG_APIACTION_INITIALIZE, "appId"));	// set default or saved text
				InitParameterScene::tfArea_InitParameter_appId = textField->getBoundingBox();			// change this

				touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
					try {
						CCPoint point = touch->getLocationInView();
						point = Director::sharedDirector()->convertToGL(point);

						if(InitParameterScene::tfArea_InitParameter_appId.containsPoint(point)
								) {					// change this
							// Show the on screen keyboard
							InitParameterScene::focusedTextFieldState = TAG_TF_INITPARAMETER_APPID;	// change this
							auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
							textField_->attachWithIME();
						}
						return true;
					}
					catch(std::bad_cast * err) {
						return true;
					}
				};
				break;
			}
			case TAG_TF_INITPARAMETER_FACEBOOK_PERMISSIONS : {
				textField->setString(DataManager::getParamValue(TAG_APIACTION_INITIALIZE, "facebookPermissions"));    // set default or saved text
				InitParameterScene::tfArea_InitParameter_facebookPermissions = textField->getBoundingBox();        // change this

				touchListener->onTouchBegan = [](cocos2d::Touch *touch, cocos2d::Event *event) -> bool {
					try {
						CCPoint point = touch->getLocationInView();
						point = Director::sharedDirector()->convertToGL(point);

						if (InitParameterScene::tfArea_InitParameter_facebookPermissions.containsPoint(point)
								) {                    // change this
							// Show the on screen keyboard
							InitParameterScene::focusedTextFieldState = TAG_TF_INITPARAMETER_FACEBOOK_PERMISSIONS;    // change this
							auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
							textField_->attachWithIME();
						}
						return true;
					}
					catch (std::bad_cast *err) {
						return true;
					}
				};
				break;
			}case TAG_TF_INITPARAMETER_SERVERID : {
				textField->setString(DataManager::getParamValue(TAG_APIACTION_INITIALIZE, "serverId"));	// set default or saved text
				InitParameterScene::tfArea_InitParameter_serverId = textField->getBoundingBox();		// change this

				touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
					try {
						CCPoint point = touch->getLocationInView();
						point = Director::sharedDirector()->convertToGL(point);

						if(InitParameterScene::tfArea_InitParameter_serverId.containsPoint(point)
								) {					// change this
							// Show the on screen keyboard
							InitParameterScene::focusedTextFieldState = TAG_TF_INITPARAMETER_SERVERID;	// change this
							auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
							textField_->attachWithIME();
						}
						return true;
					}
					catch(std::bad_cast * err) {
						return true;
					}
				};
				break;
			}case TAG_TF_INITPARAMETER_GAMELANGUAGE : {		// HIVE 1.12.0
				textField->setString(DataManager::getParamValue(TAG_APIACTION_INITIALIZE, "gameLanguage"));	// set default or saved text
				InitParameterScene::tfArea_InitParameter_gameLanguage = textField->getBoundingBox();		// change this

				touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
					try {
						CCPoint point = touch->getLocationInView();
						point = Director::sharedDirector()->convertToGL(point);

						if(InitParameterScene::tfArea_InitParameter_gameLanguage.containsPoint(point)
								) {					// change this
							// Show the on screen keyboard
							InitParameterScene::focusedTextFieldState = TAG_TF_INITPARAMETER_GAMELANGUAGE;	// change this
							auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
							textField_->attachWithIME();
						}
						return true;
					}
					catch(std::bad_cast * err) {
						return true;
					}
				};
				break;
			}
			case TAG_TF_INITPARAMETER_TIMEOUTSECONDS : {		// HIVE 1.12.0
				textField->setString(DataManager::getParamValue(TAG_APIACTION_INITIALIZE, "timeoutSeconds"));	// set default or saved text
				InitParameterScene::tfArea_InitParameter_timeoutSeconds = textField->getBoundingBox();		// change this

				touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
					try {
						CCPoint point = touch->getLocationInView();
						point = Director::sharedDirector()->convertToGL(point);

						if(InitParameterScene::tfArea_InitParameter_timeoutSeconds.containsPoint(point)
						) {					// change this
							// Show the on screen keyboard
							InitParameterScene::focusedTextFieldState = TAG_TF_INITPARAMETER_TIMEOUTSECONDS;	// change this
							auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
							textField_->attachWithIME();
						}
						return true;
					}
					catch(std::bad_cast * err) {
						return true;
					}
				};
				break;
			}
			case TAG_TF_INITPARAMETER_HIVE_ORIENTATION : {		// HIVE 1.19.6
				textField->setString(DataManager::getParamValue(TAG_APIACTION_INITIALIZE, "hiveOrientation"));	// set default or saved text
				InitParameterScene::tfArea_InitParameter_hiveOrientation = textField->getBoundingBox();		// change this

				touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
					try {
						CCPoint point = touch->getLocationInView();
						point = Director::sharedDirector()->convertToGL(point);

						if(InitParameterScene::tfArea_InitParameter_hiveOrientation.containsPoint(point)
								) {					// change this
							// Show the on screen keyboard
							InitParameterScene::focusedTextFieldState = TAG_TF_INITPARAMETER_HIVE_ORIENTATION;	// change this
							auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
							textField_->attachWithIME();
						}
						return true;
					}
					catch(std::bad_cast * err) {
						return true;
					}
				};
				break;
			}
			case TAG_TF_INITPARAMETER_CHANNEL : {
				textField->setString(DataManager::getParamValue(TAG_APIACTION_INITIALIZE, "channel"));	// set default or saved text
				InitParameterScene::tfArea_InitParameter_channel = textField->getBoundingBox();		// change this

				touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
					try {
						CCPoint point = touch->getLocationInView();
						point = Director::sharedDirector()->convertToGL(point);

						if(InitParameterScene::tfArea_InitParameter_channel.containsPoint(point)
								) {					// change this
							// Show the on screen keyboard
							InitParameterScene::focusedTextFieldState = TAG_TF_INITPARAMETER_CHANNEL;	// change this
							auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
							textField_->attachWithIME();
						}
						return true;
					}
					catch(std::bad_cast * err) {
						return true;
					}
				};
				break;
			}
		default : {
			log("### InitParameterScene::createTextField(...) error ###");
			break;
		}
	}
	this->_eventDispatcher->addEventListenerWithSceneGraphPriority(touchListener, textField);
}

void InitParameterScene::update_popupButtons()
{
	Size visibleSize = Director::getInstance()->getVisibleSize();
	Layer *layer = (Layer *)this->getChildByTag(TAG_LAYER_INITPARAMETER);

	log("### InitParameterScene : create popupButtons(InitParameter) ###");
	// (2) AppId
	auto popupBtn = Menu::create();
	popupBtn = Menu::create(
			InitParameterScene::createPopupButtons(InitParameterScene::popValue_initParameter_appId),
			NULL);
	popupBtn->setPosition(Point(visibleSize.width * InitParameterScene::ui_textField_x,
			visibleSize.height * (0.75 - (InitParameterScene::ui_paddingSize_y * 1))));
	popupBtn->setTag(TAG_POP_INITPARAMETER_APPID);
	layer->addChild(popupBtn);

	/*
	// ---> 임시 보류된 기능들
	// (5) Country
	popupBtn = Menu::create(
			InitParameterScene::createPopupButtons(InitParameterScene::popValue_initParameter_country),
			NULL);
	popupBtn->setPosition(Point(visibleSize.width * InitParameterScene::ui_textField_x,
			visibleSize.height * (0.75 - (0.05 * 6))));
	popupBtn->setTag(TAG_POP_INITPARAMETER_COUNTRY);
	layer->addChild(popupBtn);
	// (6) Language
	popupBtn = Menu::create(
			InitParameterScene::createPopupButtons(InitParameterScene::popValue_initParameter_language),
			NULL);
	popupBtn->setPosition(Point(visibleSize.width * InitParameterScene::ui_textField_x,
			visibleSize.height * (0.75 - (0.05 * 7))));
	popupBtn->setTag(TAG_POP_INITPARAMETER_LANGUAGE);
	layer->addChild(popupBtn);
	// (7) Inquiry
	popupBtn = Menu::create(
			InitParameterScene::createPopupButtons(InitParameterScene::popValue_initParameter_inquiry),
			NULL);
	popupBtn->setPosition(Point(visibleSize.width * InitParameterScene::ui_textField_x,
			visibleSize.height * (0.75 - (0.05 * 8))));
	popupBtn->setTag(TAG_POP_INITPARAMETER_INQUIRY);
	layer->addChild(popupBtn);
	*/

	// function 'update_popupButtons' End
}

MenuItemFont* InitParameterScene::createPopupButtons(int tag) {
	MenuItemFont::setFontSize(15);
	switch (tag) {
		case TAG_POP_INITPARAMETER_APPID_ID1: {
			auto button_ = MenuItemFont::create("[ 크리티카 ]",
					CC_CALLBACK_1(InitParameterScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_INITPARAMETER_APPID);
			return button_;
		}case TAG_POP_INITPARAMETER_APPID_ID2: {
			auto button_ = MenuItemFont::create("[ MLB9이닝스 ]",
					CC_CALLBACK_1(InitParameterScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_INITPARAMETER_APPID);
			return button_;
		}case TAG_POP_INITPARAMETER_APPID_ID3: {
			auto button_ = MenuItemFont::create("[ 카툰워즈3 ]",
					CC_CALLBACK_1(InitParameterScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_INITPARAMETER_APPID);
			return button_;
		}
		/*
		case TAG_POP_INITPARAMETER_COUNTRY_ID1: {
			auto button_ = MenuItemFont::create("[ country_1 ]",
					CC_CALLBACK_1(InitParameterScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_INITPARAMETER_COUNTRY);
			return button_;
		}case TAG_POP_INITPARAMETER_COUNTRY_ID2: {
			auto button_ = MenuItemFont::create("[ country_2 ]",
					CC_CALLBACK_1(InitParameterScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_INITPARAMETER_COUNTRY);
			return button_;
		}case TAG_POP_INITPARAMETER_COUNTRY_ID3: {
			auto button_ = MenuItemFont::create("[ country_3 ]",
					CC_CALLBACK_1(InitParameterScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_INITPARAMETER_COUNTRY);
			return button_;
		}case TAG_POP_INITPARAMETER_LANGUAGE_ID1: {
			auto button_ = MenuItemFont::create("[ language_1 ]",
					CC_CALLBACK_1(InitParameterScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_INITPARAMETER_LANGUAGE);
			return button_;
		}case TAG_POP_INITPARAMETER_LANGUAGE_ID2: {
			auto button_ = MenuItemFont::create("[ language_2 ]",
					CC_CALLBACK_1(InitParameterScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_INITPARAMETER_LANGUAGE);
			return button_;
		}case TAG_POP_INITPARAMETER_LANGUAGE_ID3: {
			auto button_ = MenuItemFont::create("[ language_3 ]",
					CC_CALLBACK_1(InitParameterScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_INITPARAMETER_LANGUAGE);
			return button_;
		}case TAG_POP_INITPARAMETER_INQUIRY_ID1: {
			auto button_ = MenuItemFont::create("[ inquiry_1 ]",
					CC_CALLBACK_1(InitParameterScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_INITPARAMETER_INQUIRY);
			return button_;
		}case TAG_POP_INITPARAMETER_INQUIRY_ID2: {
			auto button_ = MenuItemFont::create("[ inquiry_2 ]",
					CC_CALLBACK_1(InitParameterScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_INITPARAMETER_INQUIRY);
			return button_;
		}case TAG_POP_INITPARAMETER_INQUIRY_ID3: {
			auto button_ = MenuItemFont::create("[ inquiry_3 ]",
					CC_CALLBACK_1(InitParameterScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_INITPARAMETER_INQUIRY);
			return button_;
		}
		*/
		default: {
			auto button_ = MenuItemFont::create("[ error ]",
					CC_CALLBACK_1(InitParameterScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			return button_;
		}
	}
}

void InitParameterScene::showPopupEvent(Ref *sender)
{
	if(InitParameterScene::ui_isOpenedWindow == true)
		return;

	auto mItem = (MenuItem*) sender;

	switch (mItem->getTag()) {
		case TAG_POP_INITPARAMETER_APPID: {
			// Display Pop-up
			Size visibleSize = Director::getInstance()->getVisibleSize();
			auto popup_layer = LayerColor::create(Color4B(0, 125, 125, 255));
			popup_layer->setContentSize(Size(visibleSize.width * 0.90, visibleSize.height * 0.5));
			popup_layer->setPosition(Point(visibleSize.width * 0.05, visibleSize.height * 0.05));
			popup_layer->setTag(-10000);
			this->addChild(popup_layer);

			MenuItemFont::setFontSize(15);
			auto button_1 = MenuItemFont::create("[ 크리티카 ]",
					CC_CALLBACK_1(InitParameterScene::closePopupEvent, this));
			button_1->setColor(ccc3(255, 255, 255));
			button_1->setTag(TAG_POP_INITPARAMETER_APPID_ID1);
			auto button_2 = MenuItemFont::create("[ MLB9이닝스 ]",
					CC_CALLBACK_1(InitParameterScene::closePopupEvent, this));
			button_2->setColor(ccc3(255, 255, 255));
			button_2->setTag(TAG_POP_INITPARAMETER_APPID_ID2);
			auto button_3 = MenuItemFont::create("[ 카툰워즈3 ]",
					CC_CALLBACK_1(InitParameterScene::closePopupEvent, this));
			button_3->setColor(ccc3(255, 255, 255));
			button_3->setTag(TAG_POP_INITPARAMETER_APPID_ID3);
			auto Popup_1 = Menu::create(button_1, button_2, button_3, NULL);
			Popup_1->alignItemsVerticallyWithPadding(visibleSize.height * 0.015);
			Popup_1->setPosition(Point(visibleSize.width * 0.45, visibleSize.height * ((0.5 - 0.05)*0.5) ));
			popup_layer->addChild(Popup_1);
			InitParameterScene::ui_isOpenedWindow = true;
			break;
		}
		/*
		case TAG_POP_INITPARAMETER_COUNTRY: {
			// Display Pop-up
			Size visibleSize = Director::getInstance()->getVisibleSize();
			auto popup_layer = LayerColor::create(Color4B(0, 125, 125, 255));
			popup_layer->setContentSize(Size(visibleSize.width * 0.90, visibleSize.height * 0.5));
			popup_layer->setPosition(Point(visibleSize.width * 0.05, visibleSize.height * 0.05));
			popup_layer->setTag(-10000);
			this->addChild(popup_layer);

			MenuItemFont::setFontSize(60);
			auto button_1 = MenuItemFont::create("[ country_1 ]",
					CC_CALLBACK_1(InitParameterScene::closePopupEvent, this));
			button_1->setColor(ccc3(255, 255, 255));
			button_1->setTag(TAG_POP_INITPARAMETER_COUNTRY_ID1);
			auto button_2 = MenuItemFont::create("[ country_2 ]",
					CC_CALLBACK_1(InitParameterScene::closePopupEvent, this));
			button_2->setColor(ccc3(255, 255, 255));
			button_2->setTag(TAG_POP_INITPARAMETER_COUNTRY_ID2);
			auto button_3 = MenuItemFont::create("[ country_3 ]",
					CC_CALLBACK_1(InitParameterScene::closePopupEvent, this));
			button_3->setColor(ccc3(255, 255, 255));
			button_3->setTag(TAG_POP_INITPARAMETER_COUNTRY_ID3);
			auto Popup_1 = Menu::create(button_1, button_2, button_3, NULL);
			Popup_1->alignItemsVerticallyWithPadding(visibleSize.height * 0.015);
			Popup_1->setPosition(Point(visibleSize.width * 0.45, visibleSize.height * ((0.5 - 0.05)*0.5) ));
			popup_layer->addChild(Popup_1);
			InitParameterScene::ui_isOpenedWindow = true;
			break;
		}case TAG_POP_INITPARAMETER_LANGUAGE: {
			// Display Pop-up
			Size visibleSize = Director::getInstance()->getVisibleSize();
			auto popup_layer = LayerColor::create(Color4B(0, 125, 125, 255));
			popup_layer->setContentSize(Size(visibleSize.width * 0.90, visibleSize.height * 0.5));
			popup_layer->setPosition(Point(visibleSize.width * 0.05, visibleSize.height * 0.05));
			popup_layer->setTag(-10000);
			this->addChild(popup_layer);

			MenuItemFont::setFontSize(60);
			auto button_1 = MenuItemFont::create("[ language_1 ]",
					CC_CALLBACK_1(InitParameterScene::closePopupEvent, this));
			button_1->setColor(ccc3(255, 255, 255));
			button_1->setTag(TAG_POP_INITPARAMETER_LANGUAGE_ID1);
			auto button_2 = MenuItemFont::create("[ language_2 ]",
					CC_CALLBACK_1(InitParameterScene::closePopupEvent, this));
			button_2->setColor(ccc3(255, 255, 255));
			button_2->setTag(TAG_POP_INITPARAMETER_LANGUAGE_ID2);
			auto button_3 = MenuItemFont::create("[ language_3 ]",
					CC_CALLBACK_1(InitParameterScene::closePopupEvent, this));
			button_3->setColor(ccc3(255, 255, 255));
			button_3->setTag(TAG_POP_INITPARAMETER_LANGUAGE_ID3);
			auto Popup_1 = Menu::create(button_1, button_2, button_3, NULL);
			Popup_1->alignItemsVerticallyWithPadding(visibleSize.height * 0.015);
			Popup_1->setPosition(Point(visibleSize.width * 0.45, visibleSize.height * ((0.5 - 0.05)*0.5) ));
			popup_layer->addChild(Popup_1);
			InitParameterScene::ui_isOpenedWindow = true;
			break;
		}case TAG_POP_INITPARAMETER_INQUIRY: {
			// Display Pop-up
			Size visibleSize = Director::getInstance()->getVisibleSize();
			auto popup_layer = LayerColor::create(Color4B(0, 125, 125, 255));
			popup_layer->setContentSize(Size(visibleSize.width * 0.90, visibleSize.height * 0.5));
			popup_layer->setPosition(Point(visibleSize.width * 0.05, visibleSize.height * 0.05));
			popup_layer->setTag(-10000);
			this->addChild(popup_layer);

			MenuItemFont::setFontSize(60);
			auto button_1 = MenuItemFont::create("[ inquiry_1 ]",
					CC_CALLBACK_1(InitParameterScene::closePopupEvent, this));
			button_1->setColor(ccc3(255, 255, 255));
			button_1->setTag(TAG_POP_INITPARAMETER_INQUIRY_ID1);
			auto button_2 = MenuItemFont::create("[ inquiry_2 ]",
					CC_CALLBACK_1(InitParameterScene::closePopupEvent, this));
			button_2->setColor(ccc3(255, 255, 255));
			button_2->setTag(TAG_POP_INITPARAMETER_INQUIRY_ID2);
			auto button_3 = MenuItemFont::create("[ inquiry_3 ]",
					CC_CALLBACK_1(InitParameterScene::closePopupEvent, this));
			button_3->setColor(ccc3(255, 255, 255));
			button_3->setTag(TAG_POP_INITPARAMETER_INQUIRY_ID3);
			auto Popup_1 = Menu::create(button_1, button_2, button_3, NULL);
			Popup_1->alignItemsVerticallyWithPadding(visibleSize.height * 0.015);
			Popup_1->setPosition(Point(visibleSize.width * 0.45, visibleSize.height * ((0.5 - 0.05)*0.5) ));
			popup_layer->addChild(Popup_1);
			InitParameterScene::ui_isOpenedWindow = true;
			break;
		}
		*/
		default:
			break;
	}
}

void InitParameterScene::closePopupEvent(Ref *sender)
{
	auto mItem = (MenuItem*) sender;
	Size visibleSize = Director::getInstance()->getVisibleSize();

	// remove
	Layer *layer = (Layer *) this->getChildByTag(TAG_LAYER_INITPARAMETER);
	this->removeChildByTag(-10000, true);
	layer->removeChildByTag(TAG_POP_INITPARAMETER_APPID, true);
	layer->removeChildByTag(TAG_POP_INITPARAMETER_COUNTRY, true);
	layer->removeChildByTag(TAG_POP_INITPARAMETER_LANGUAGE, true);
	layer->removeChildByTag(TAG_POP_INITPARAMETER_INQUIRY, true);

	InitParameterScene::ui_isOpenedWindow = false;	// 팝업 제거 --> UI 중복 클릭 해제
	// toss data
	switch (mItem->getTag()) {
		case TAG_POP_INITPARAMETER_APPID_ID1 : {
			InitParameterScene::popValue_initParameter_appId = TAG_POP_INITPARAMETER_APPID_ID1;
			// 텍스트 필드를 가져와서 setString 하기
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_INITPARAMETER_APPID);
			temp_tf->setString(DataManager::getAppId(1));
			break;
		}case TAG_POP_INITPARAMETER_APPID_ID2 : {
			InitParameterScene::popValue_initParameter_appId = TAG_POP_INITPARAMETER_APPID_ID2;
			// 텍스트 필드를 가져와서 setString 하기
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_INITPARAMETER_APPID);
			temp_tf->setString(DataManager::getAppId(2));
			break;
		}case TAG_POP_INITPARAMETER_APPID_ID3 : {
			InitParameterScene::popValue_initParameter_appId = TAG_POP_INITPARAMETER_APPID_ID3;
			// 텍스트 필드를 가져와서 setString 하기
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_INITPARAMETER_APPID);
			temp_tf->setString(DataManager::getAppId(3));
			break;
		}
		/*
		case TAG_POP_INITPARAMETER_COUNTRY_ID1 : {
			InitParameterScene::popValue_initParameter_country = TAG_POP_INITPARAMETER_COUNTRY_ID1;
			// TODO : DataManager를 통해 맵핑되는 값을 Parameter에 전달
			break;
		}case TAG_POP_INITPARAMETER_COUNTRY_ID2 : {
			InitParameterScene::popValue_initParameter_country = TAG_POP_INITPARAMETER_COUNTRY_ID2;
			// TODO : DataManager를 통해 맵핑되는 값을 Parameter에 전달
			break;
		}case TAG_POP_INITPARAMETER_COUNTRY_ID3 : {
			InitParameterScene::popValue_initParameter_country = TAG_POP_INITPARAMETER_COUNTRY_ID3;
			// TODO : DataManager를 통해 맵핑되는 값을 Parameter에 전달
			break;
		}case TAG_POP_INITPARAMETER_LANGUAGE_ID1 : {
			InitParameterScene::popValue_initParameter_language = TAG_POP_INITPARAMETER_LANGUAGE_ID1;
			// TODO : DataManager를 통해 맵핑되는 값을 Parameter에 전달
			break;
		}case TAG_POP_INITPARAMETER_LANGUAGE_ID2 : {
			InitParameterScene::popValue_initParameter_language = TAG_POP_INITPARAMETER_LANGUAGE_ID2;
			// TODO : DataManager를 통해 맵핑되는 값을 Parameter에 전달
			break;
		}case TAG_POP_INITPARAMETER_LANGUAGE_ID3 : {
			InitParameterScene::popValue_initParameter_language = TAG_POP_INITPARAMETER_LANGUAGE_ID3;
			// TODO : DataManager를 통해 맵핑되는 값을 Parameter에 전달
			break;
		}case TAG_POP_INITPARAMETER_INQUIRY_ID1 : {
			InitParameterScene::popValue_initParameter_inquiry = TAG_POP_INITPARAMETER_INQUIRY_ID1;
			// TODO : DataManager를 통해 맵핑되는 값을 Parameter에 전달
			break;
		}case TAG_POP_INITPARAMETER_INQUIRY_ID2 : {
			InitParameterScene::popValue_initParameter_inquiry = TAG_POP_INITPARAMETER_INQUIRY_ID2;
			// TODO : DataManager를 통해 맵핑되는 값을 Parameter에 전달
			break;
		}case TAG_POP_INITPARAMETER_INQUIRY_ID3 : {
			InitParameterScene::popValue_initParameter_inquiry = TAG_POP_INITPARAMETER_INQUIRY_ID3;
			// TODO : DataManager를 통해 맵핑되는 값을 Parameter에 전달
			break;
		}
		*/
		default :
			break;
	}
	// re-draw
	InitParameterScene::update_popupButtons();
}

void InitParameterScene::onKeyReleased( cocos2d::EventKeyboard::KeyCode keycode, cocos2d::Event *event )
{
    if (keycode == EventKeyboard::KeyCode::KEY_ESCAPE) {
    	/*
        if(InitParameterScene::isFocusedTextField == true) {
        	InitParameterScene::isFocusedTextField = false;
        	InitParameterScene::ui_isOpenedWindow = false;
        	log("### onKeyReleased : isFocused(%d), isOpenedWindow(%d)",
        			InitParameterScene::isFocusedTextField, InitParameterScene::ui_isOpenedWindow);
        }
        */
    }
}

// ********** Touch Event (TextField) ********** ********** ********** **********
bool InitParameterScene::onTextFieldAttachWithIME(TextFieldTTF *sender) {
	//InitParameterScene::ui_isOpenedWindow = true;
	//InitParameterScene::isFocusedTextField = true;
	return TextFieldDelegate::onTextFieldAttachWithIME(sender);
}

bool InitParameterScene::onTextFieldDetachWithIME(TextFieldTTF *sender) {
	//InitParameterScene::ui_isOpenedWindow = false;
	return TextFieldDelegate::onTextFieldDetachWithIME(sender);
}

bool InitParameterScene::onTextFieldInsertText(TextFieldTTF *sender,
		const char *text, size_t nLen) {
	return TextFieldDelegate::onTextFieldInsertText(sender, text, nLen);
}

bool InitParameterScene::onTextFieldDeleteBackward(
		TextFieldTTF *sender, const char *delText, size_t nLen) {
	return TextFieldDelegate::onTextFieldDeleteBackward(sender, delText, nLen);
}
// ********** ********** ********** ********** ********** ********** ********** ********** **********
