#ifndef __INIT_PARAMETER_SCENE_H__
#define __INIT_PARAMETER_SCENE_H__

#include "cocos2d.h"

USING_NS_CC;

#define TAG_BTN_PREVIOUS_SCENE					101

#define TAG_LAYER_INITPARAMETER					60001

#define TAG_LABEL_INITPARAMETER_INITSETTING		60101
#define TAG_BTN_INITPARAMETER_SAVEPARAMETER		60102
/**
 * label
 */
#define TAG_LABEL_INITPARAMETER_SHOWLOG			60201
#define TAG_LABEL_INITPARAMETER_APPID			60202
#define TAG_LABEL_INITPARAMETER_PERMISSIONWRITE	60203
#define TAG_LABEL_INITPARAMETER_SERVERID		60204
#define TAG_LABEL_INITPARAMETER_COUNTRY			60205
#define TAG_LABEL_INITPARAMETER_LANGUAGE		60206
#define TAG_LABEL_INITPARAMETER_INQUIRY			60207
#define TAG_LABEL_INITPARAMETER_SHOWNOTICE		60208
//#define TAG_LABEL_INITPARAMETER_HIVEIAP			60209
#define TAG_LABEL_INITPARAMETER_USEONESTORE		60210		// HIVE 1.11.0
#define TAG_LABEL_INITPARAMETER_HIVEPROMOTION	60211		// HIVE 1.12.0
#define TAG_LABEL_INITPARAMETER_GAMELANGUAGE	60212		// HIVE 1.12.0
#define TAG_LABEL_INITPARAMETER_TIMEOUTSECONDS	60213		// HIVE 1.13.0
#define TAG_LABEL_INITPARAMETER_USEGALAXYSTORE	60214		// HIVE 1.17.2
#define TAG_LABEL_INITPARAMETER_SHOWPERMISSIONVIEW	60215		// HIVE 1.17.2
#define TAG_LABEL_INITPARAMETER_MERCURY_INIT_EX	60216		// HIVE 1.18.1
#define TAG_LABEL_INITPARAMETER_USE_INAPPV4		60217		// HIVE 1.18.4
#define TAG_LABEL_INITPARAMETER_HIVE_ORIENTATION		60218		// HIVE 1.19.4
#define TAG_LABEL_INITPARAMETER_FACEBOOK_PERMISSIONS	60219		// HIVE 1.19.8
#define TAG_LABEL_INITPARAMETER_USE_HERCULES		    60220		// Hive 1.20.2
#define TAG_LABEL_INITPARAMETER_CHANNEL		    		60221		// Hive 1.20.3

/**
 * checkbox
 */
#define TAG_CB_INITPARAMETER_SHOWLOG			60301
#define TAG_CB_INITPARAMETER_PERMISSIONWRITE	60302
#define TAG_CB_INITPARAMETER_SHOWNOTICE			60303
//#define TAG_CB_INITPARAMETER_HIVEIAP			60304
#define TAG_CB_INITPARAMETER_USEONESTORE		60305		// HIVE 1.11.0
#define TAG_CB_INITPARAMETER_HIVEPROMOTION		60306		// HIVE 1.12.0
#define TAG_CB_INITPARAMETER_USEGALAXYSTORE		60307		// HIVE 1.17.2
#define TAG_CB_INITPARAMETER_SHOWPERMISSIONVIEW	60308		// HIVE 1.17.2
#define TAG_CB_INITPARAMETER_MERCURY_INIT_EX	60309		// HIVE 1.18.1
#define TAG_CB_INITPARAMETER_USE_INAPPV4		60310		// HIVE 1.18.4
#define TAG_CB_INITPARAMETER_USE_HERCULES   	60311		// Hive 1.20.2
/**
 * textfield
 */
#define TAG_TF_INITPARAMETER_APPID				60401
#define	TAG_TF_INITPARAMETER_SERVERID			60402
#define TAG_TF_INITPARAMETER_GAMELANGUAGE		60403		// HIVE 1.12.0
#define TAG_TF_INITPARAMETER_TIMEOUTSECONDS		60404		// HIVE 1.13.0
#define TAG_TF_INITPARAMETER_HIVE_ORIENTATION	60405		// HIVE 1.19.6
#define TAG_TF_INITPARAMETER_FACEBOOK_PERMISSIONS	60406	// HIVE 1.19.8
#define TAG_TF_INITPARAMETER_CHANNEL			60407		// HIVE 1.20.3

/**
 * popup
 */
#define TAG_POP_INITPARAMETER_APPID				60501
#define TAG_POP_INITPARAMETER_APPID_ID1			60502
#define TAG_POP_INITPARAMETER_APPID_ID2			60503
#define TAG_POP_INITPARAMETER_APPID_ID3			60504
#define TAG_POP_INITPARAMETER_COUNTRY			60601
#define TAG_POP_INITPARAMETER_COUNTRY_ID1		60602
#define TAG_POP_INITPARAMETER_COUNTRY_ID2		60603
#define TAG_POP_INITPARAMETER_COUNTRY_ID3		60604
#define TAG_POP_INITPARAMETER_LANGUAGE			60701
#define TAG_POP_INITPARAMETER_LANGUAGE_ID1		60702
#define TAG_POP_INITPARAMETER_LANGUAGE_ID2		60703
#define TAG_POP_INITPARAMETER_LANGUAGE_ID3		60704
#define TAG_POP_INITPARAMETER_INQUIRY			60801
#define TAG_POP_INITPARAMETER_INQUIRY_ID1		60802
#define TAG_POP_INITPARAMETER_INQUIRY_ID2		60803
#define TAG_POP_INITPARAMETER_INQUIRY_ID3		60804

using namespace cocos2d;

class InitParameterScene : public Layer, public TextFieldDelegate
{
public:
	static cocos2d::Scene* createScene();
	virtual bool init();
	CREATE_FUNC(InitParameterScene);

	// variable
	static float ui_moduleListNameLabel_x;
	static float ui_moduleListNameLabel_y;
	static float ui_previousBtn_x;
	static float ui_previousBtn_y;
	static float ui_saveParamBtn_x;
	static float ui_saveParamBtn_y;
	static float ui_paramLabel_x;
	static float ui_checkbox_x;
	static float ui_textField_x;
	static float ui_paddingSize_y;

	static bool ui_isOpenedWindow;									// ui 중복 클릭 방지
	// variable(checkbox)
	static bool ui_checkbox_initParameter_showLog;
	static bool ui_checkbox_initParameter_permissionWrite;
	static bool ui_checkbox_initParameter_showNotice;
//	static bool ui_checkbox_initParameter_HiveIAP;
	static bool ui_checkbox_initParameter_useOneStore;				// HIVE 1.11.0
	static bool ui_checkbox_initParameter_hivePromotion;			// HIVE 1.12.0
	static bool ui_checkbox_initParameter_useGalaxyStore;				// HIVE 1.17.2
	static bool ui_checkbox_initParameter_showPermissionView;			// HIVE 1.17.2
	static bool ui_checkbox_initParameter_useImageBanner;			// HIVE 1.18.1
	static bool ui_checkbox_initParameter_useInappV4;				// HIVE 1.18.4
	static bool ui_checkbox_initParameter_useHercules;				// Hive 1.20.2
	// variable(textfield)
	static int focusedTextFieldState;
	static bool isFocusedTextField;									// ui 중복 클릭 방지 (텍스트 필드)
	static cocos2d::CCRect tfArea_InitParameter_appId;
	static cocos2d::CCRect tfArea_InitParameter_serverId;
	static cocos2d::CCRect tfArea_InitParameter_gameLanguage;		// HIVE 1.12.0
	static cocos2d::CCRect tfArea_InitParameter_timeoutSeconds;		// HIVE 1.13.0
	static cocos2d::CCRect tfArea_InitParameter_hiveOrientation;	// Hive 1.19.6
	static cocos2d::CCRect tfArea_InitParameter_facebookPermissions;	// Hive 1.19.8
	static cocos2d::CCRect tfArea_InitParameter_channel;	// Hive 1.20.3
	// variable(popup)
	static int popValue_initParameter_appId;
	static int popValue_initParameter_country;
	static int popValue_initParameter_language;
	static int popValue_initParameter_inquiry;
	static int popValue_initParameter_hiveOrientation;

	// function
	LabelTTF* createLabels(int tag);
	void update_otherButtons(int btnType);
	MenuItemImage* createButtons(int tag);
	void buttonEvent(Ref *sender);

	void update_labels();
	MenuItemLabel* createParamLabels(int tag);
	void labelEvent(Ref *sender);

	void update_checkboxes();
	MenuItemToggle* createCheckboxes(int tag);
	void ToggleEvent(Ref* sender);
	int setCheckbox(int tag);

	void saveParamValue();

	void update_textFields();
	void createTextFields(int tag, float textFieldPos_y);

	void update_popupButtons();
	MenuItemFont* createPopupButtons(int tag);
	void showPopupEvent(Ref *sender);
	void closePopupEvent(Ref *sender);

	virtual bool onTextFieldAttachWithIME(cocos2d::TextFieldTTF *sender) override;										// 텍스트 필드 관련 함수
	virtual bool onTextFieldDetachWithIME(cocos2d::TextFieldTTF *sender) override;										// 텍스트 필드 관련 함수
	virtual bool onTextFieldInsertText(cocos2d::TextFieldTTF *sender, const char *text, size_t nLen) override;			// 텍스트 필드 관련 함수
	virtual bool onTextFieldDeleteBackward(cocos2d::TextFieldTTF *sender, const char *delText, size_t nLen) override;	// 텍스트 필드 관련 함수

	void onKeyReleased( cocos2d::EventKeyboard::KeyCode keycode, cocos2d::Event *event ); // 뒤로가기 버튼 (android) + 중복 클릭 방지
};

#endif // __INIT_PARAMETER_SCENE_H__
