#ifndef __LOG_SCENE_H__
#define __LOG_SCENE_H__

#include "cocos2d.h"

USING_NS_CC;

#define TAG_BTN_PREVIOUS_SCENE		101

#define TAG_LAYER_LOGSCENE			70001
#define TAG_LABEL_LOGSCENE_TITLE	70002

#define TAG_BTN_LOGSCENE_SHOWLOG	70101
#define TAG_BTN_LOGSCENE_SAVE		70102
#define TAG_BTN_LOGSCENE_CLEAR		70103
#define TAG_LABEL_LOGSCENE_LOGTYPE	70104

#define TAG_POP_LOGSCENE					70200
#define TAG_POP_LOGSCENE_LOGTYPE			70201
#define TAG_POP_LOGSCENE_LOGTYPE_LOCAL		70202
#define TAG_POP_LOGSCENE_LOGTYPE_ALL		70203


using namespace cocos2d;

class LogScene : public Layer
{
public:
	static cocos2d::Scene* createScene();
	virtual bool init();
	CREATE_FUNC(LogScene);

	// variable
	static float ui_previousBtn_x;
	static float ui_previousBtn_y;
	static float ui_showLogBtn_x;
	static float ui_showLogBtn_y;
	static float ui_saveLogBtn_x;
	static float ui_saveLogBtn_y;
	static float ui_clearLogBtn_x;
	static float ui_claerLogBtn_y;
	static float ui_titleLabel_x;
	static float ui_titleLabel_y;
	// variable
	static int popValue_logScene_logType;
	// variable (ui간의 중복 클릭 방지)
	static bool ui_isOpenedWindow;

	// function
	LabelTTF* createLabels(int tag);
	void update_otherButtons(int btnType);
	MenuItemImage* createButtons(int tag);
	void buttonEvent(Ref *sender);
	void update_labels(int tag);
	MenuItemLabel* createParamLabels(int tag);
	void labelEvent(Ref *sender);
	void update_popupButtons(int tag);
	MenuItemFont* createPopupButtons(int tag);
	void showPopupEvent(Ref *sender);
	void closePopupEvent(Ref *sender);

};

#endif // __LOG_SCENE_H__
